(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    382703,       8612]
NotebookOptionsPosition[    353865,       8144]
NotebookOutlinePosition[    355724,       8188]
CellTagsIndexPosition[    355508,       8180]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"x", "^", "k"}], "/", 
    RowBox[{"(", 
     RowBox[{"1", "+", 
      RowBox[{"Exp", "[", 
       RowBox[{"x", "-", "\[Eta]"}], "]"}]}], ")"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "Infinity"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.793550805739127*^9, 3.7935508594170637`*^9}, {
  3.7935511859606514`*^9, 3.793551194744153*^9}, {3.793551286703555*^9, 
  3.793551334615717*^9}},
 CellLabel->"In[9]:=",ExpressionUUID->"1095fb49-7af2-42eb-bd87-9f99ae5f06f5"],

Cell[BoxData[
 RowBox[{"ConditionalExpression", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     RowBox[{"Gamma", "[", 
      RowBox[{"1", "+", "k"}], "]"}]}], " ", 
    RowBox[{"PolyLog", "[", 
     RowBox[{
      RowBox[{"1", "+", "k"}], ",", 
      RowBox[{"-", 
       SuperscriptBox["\[ExponentialE]", "\[Eta]"]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"Re", "[", "k", "]"}], ">", 
    RowBox[{"-", "1"}]}]}], "]"}]], "Output",
 CellChangeTimes->{{3.7935508416283293`*^9, 3.7935508613338284`*^9}, 
   3.79355125643347*^9, {3.793551297185115*^9, 3.7935513368807755`*^9}},
 CellLabel->"Out[9]=",ExpressionUUID->"db31f587-3455-4da3-8fd9-402489531e8b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"k", "=", "1"}]], "Input",
 CellChangeTimes->{{3.793593207331031*^9, 3.7935932081943192`*^9}},
 CellLabel->"In[62]:=",ExpressionUUID->"f2dce862-28f9-4f07-a93c-5075ada52846"],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{3.793593208431535*^9},
 CellLabel->"Out[62]=",ExpressionUUID->"f1718048-72f0-4005-9f41-9c4c49fc53c2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    RowBox[{"Gamma", "[", 
     RowBox[{"1", "+", "k"}], "]"}]}], " ", 
   RowBox[{"PolyLog", "[", 
    RowBox[{
     RowBox[{"1", "+", "k"}], ",", 
     RowBox[{"-", 
      SuperscriptBox["\[ExponentialE]", "\[Eta]"]}]}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Gamma", "[", 
    RowBox[{"1", "+", "k"}], "]"}], " ", 
   RowBox[{"PolyLog", "[", 
    RowBox[{
     RowBox[{"1", "+", "k"}], ",", 
     RowBox[{"-", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"-", "\[Eta]"}]]}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.793593166945266*^9, 3.7935932161445684`*^9}},
 CellLabel->"In[65]:=",ExpressionUUID->"973af9d8-4f5c-448f-8dee-67951d3c61f9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PolyLog", "[", 
   RowBox[{"2", ",", 
    RowBox[{"-", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"-", "\[Eta]"}]]}]}], "]"}], "-", 
  RowBox[{"PolyLog", "[", 
   RowBox[{"2", ",", 
    RowBox[{"-", 
     SuperscriptBox["\[ExponentialE]", "\[Eta]"]}]}], "]"}]}]], "Output",
 CellChangeTimes->{{3.793593172135991*^9, 3.793593216681057*^9}},
 CellLabel->"Out[65]=",ExpressionUUID->"1e8a71eb-ca42-4332-b333-1f7c6728bb00"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.793593173066845*^9, 3.793593176065585*^9}},
 CellLabel->"In[66]:=",ExpressionUUID->"57585c61-bbfa-4db1-841a-0128e8dedf41"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   RowBox[{"PolyLog", "[", 
    RowBox[{"2", ",", 
     RowBox[{"-", 
      SuperscriptBox["\[ExponentialE]", "\[Eta]"]}]}], "]"}]}], "+", 
  RowBox[{"PolyLog", "[", 
   RowBox[{"2", ",", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{"Cosh", "[", "\[Eta]", "]"}]}], "+", 
     RowBox[{"Sinh", "[", "\[Eta]", "]"}]}]}], "]"}]}]], "Output",
 CellChangeTimes->{{3.7935931763998885`*^9, 3.7935932176204147`*^9}},
 CellLabel->"Out[66]=",ExpressionUUID->"a9665031-e0e6-4f0a-8455-84475a4659fd"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.793592373983342*^9, 
  3.7935923763179674`*^9}},ExpressionUUID->"d43f4dba-d1a1-4b32-aafd-\
02bc366bf227"],

Cell[BoxData[
 RowBox[{
  RowBox[{"F1", "[", 
   RowBox[{"k_", ",", "\[Eta]_"}], "]"}], ":=", 
  RowBox[{"Integrate", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"x", "^", "k"}], "/", 
     RowBox[{"(", 
      RowBox[{"1", "+", 
       RowBox[{"Exp", "[", 
        RowBox[{"x", "-", "\[Eta]"}], "]"}]}], ")"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "0", ",", "Infinity"}], "}"}], ",", 
    RowBox[{"Assumptions", "\[Rule]", 
     RowBox[{"k", ">", 
      RowBox[{"-", "1"}]}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7935923838783593`*^9, 3.7935923880701756`*^9}, {
  3.793592573022811*^9, 3.7935925762847905`*^9}},
 CellLabel->"In[20]:=",ExpressionUUID->"ccb2bc46-a511-451e-a78b-ab6436f355ec"],

Cell[BoxData[
 RowBox[{
  RowBox[{"F2", "[", 
   RowBox[{"k_", ",", "\[Eta]_", ",", "nMAX_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"k", "!"}], " ", 
   RowBox[{"Exp", "[", "\[Eta]", "]"}], " ", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"-", 
         RowBox[{"Exp", "[", "\[Eta]", "]"}]}], ")"}], "^", 
       RowBox[{"(", 
        RowBox[{"i", "-", "1"}], ")"}]}], "/", 
      RowBox[{"i", "^", 
       RowBox[{"(", 
        RowBox[{"k", "+", "1"}], ")"}]}]}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "nMAX"}], "}"}], ",", 
     RowBox[{"Assumptions", "\[Rule]", 
      RowBox[{"\[Eta]", "<", "0"}]}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.7935922890283756`*^9, 3.793592364446638*^9}, {
  3.793592432703845*^9, 3.7935924365198245`*^9}, {3.7935924709752755`*^9, 
  3.793592475381792*^9}, {3.7935928748939967`*^9, 3.793592892523073*^9}},
 CellLabel->"In[22]:=",ExpressionUUID->"a02097e4-b206-4b50-9d2f-14ed8d2525cb"],

Cell[BoxData[
 RowBox[{
  RowBox[{"fFermiZERO", "=", 
   RowBox[{"Function", "[", 
    RowBox[{
     RowBox[{"{", "k", "}"}], ",", 
     RowBox[{
      SuperscriptBox["2", 
       RowBox[{"-", "k"}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["2", "k"]}], ")"}], " ", 
      RowBox[{"Gamma", "[", 
       RowBox[{"1", "+", "k"}], "]"}], " ", 
      RowBox[{"Zeta", "[", 
       RowBox[{"1", "+", "k"}], "]"}]}]}], 
    RowBox[{"(*", "  ", 
     RowBox[{"Integrate", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"x", "^", "k"}], "/", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{"Exp", "[", "x", "]"}]}], ")"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", "0", ",", "Infinity"}], "}"}]}], "]"}], "*)"}], 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.593094173653285*^9, 3.5930941936749372`*^9}, {
   3.593858154916705*^9, 3.593858173773093*^9}, 3.593863936653059*^9},
 CellLabel->"In[2]:=",ExpressionUUID->"35f3ba98-cb0f-4310-a3e3-aeb69089c86c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"fFermi", "=", 
    RowBox[{"Function", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"k", ",", "\[Eta]", ",", "\[Theta]"}], "}"}], ",", 
      RowBox[{"NIntegrate", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"x", "^", "k"}], " ", 
         RowBox[{
          RowBox[{"Sqrt", "[", 
           RowBox[{"1", "+", 
            RowBox[{"\[Theta]", " ", 
             RowBox[{"x", "/", "2"}]}]}], "]"}], "/", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            RowBox[{"Exp", "[", 
             RowBox[{"x", "-", "\[Eta]"}], "]"}]}], ")"}]}]}], ",", 
        RowBox[{"{", 
         RowBox[{"x", ",", "0", ",", "Infinity"}], "}"}], ",", 
        RowBox[{"WorkingPrecision", "\[Rule]", "128"}], ",", 
        RowBox[{"Method", "\[Rule]", "\"\<DoubleExponential\>\""}], ",", 
        RowBox[{"MaxRecursion", "\[Rule]", "16"}]}], "]"}]}], "]"}]}], ";"}], 
  " ", 
  RowBox[{"(*", " ", 
   RowBox[{"Reference", " ", "numerical", " ", "result"}], " ", 
   "*)"}]}]], "Input",
 CellChangeTimes->{{3.55288208049907*^9, 3.5528821703822803`*^9}, {
   3.5528875154458857`*^9, 3.552887520604828*^9}, {3.593092441877892*^9, 
   3.5930924647517233`*^9}, {3.593092936515087*^9, 3.593092939397594*^9}, {
   3.593093970234536*^9, 3.593093970269682*^9}, {3.593094013785103*^9, 
   3.593094015199394*^9}, 3.59377897163573*^9, {3.59378019568433*^9, 
   3.5937802024092827`*^9}, {3.5938581936630898`*^9, 3.593858194310852*^9}, 
   3.79292275915775*^9, {3.7935076449919405`*^9, 3.7935076680685806`*^9}},
 CellLabel->"In[15]:=",ExpressionUUID->"29367083-80a7-4630-a222-ad39a661b768"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Estimate", " ", "of", " ", "infinite", " ", "sum"}], ";", " ", 
    RowBox[{"disretization", " ", "error"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"fFermiSum", "=", 
     RowBox[{"Function", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"k", ",", "\[Eta]", ",", "\[Theta]", ",", "h"}], "}"}], ",", 
       RowBox[{"Module", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "x", ",", "dx", ",", "integrand", ",", "t", ",", "i", ",", "n"}], 
          "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"t", "=", 
           RowBox[{"i", "*", "h"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"x", "=", 
           RowBox[{"Exp", "[", 
            RowBox[{"t", "-", 
             RowBox[{"Exp", "[", 
              RowBox[{"-", "t"}], "]"}]}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"dx", "=", 
           RowBox[{"x", "*", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              SuperscriptBox["\[ExponentialE]", 
               RowBox[{"-", "t"}]]}], ")"}]}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"integrand", "=", 
           RowBox[{
            RowBox[{"x", "^", "k"}], " ", 
            RowBox[{
             RowBox[{"Sqrt", "[", 
              RowBox[{"1", "+", 
               RowBox[{"\[Theta]", " ", 
                RowBox[{"x", "/", "2"}]}]}], "]"}], "/", 
             RowBox[{"(", 
              RowBox[{"1", "+", 
               RowBox[{"Exp", "[", 
                RowBox[{"x", "-", "\[Eta]"}], "]"}]}], ")"}]}], " ", "dx"}]}],
           ";", "\[IndentingNewLine]", 
          RowBox[{"oldSum", "=", "1"}], ";", "\[IndentingNewLine]", 
          RowBox[{"newSum", "=", "0"}], ";", "\[IndentingNewLine]", 
          RowBox[{"n", "=", "0"}], ";", "\[IndentingNewLine]", 
          RowBox[{"While", "[", 
           RowBox[{
            RowBox[{"newSum", "\[NotEqual]", "oldSum"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"n", "++"}], ";", "\[IndentingNewLine]", 
             RowBox[{"oldSum", "=", "newSum"}], ";", "\[IndentingNewLine]", 
             RowBox[{"newSum", "=", 
              RowBox[{"Sum", "[", 
               RowBox[{"integrand", ",", 
                RowBox[{"{", 
                 RowBox[{"i", ",", 
                  RowBox[{"-", "n"}], ",", "n"}], "}"}]}], "]"}]}], ";"}]}], 
           "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"h", "*", "newSum"}]}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.793163825280364*^9, 3.79316395754957*^9}, {
  3.793164004084096*^9, 3.793164009604108*^9}, {3.793164046949275*^9, 
  3.7931640559159503`*^9}, {3.793164377595171*^9, 3.7931644072977285`*^9}, {
  3.793164439968532*^9, 3.793164472081808*^9}, {3.7931646202412453`*^9, 
  3.7931646252958465`*^9}, {3.7931652899651184`*^9, 3.7931654337871056`*^9}, {
  3.7931655722106004`*^9, 3.7931655790268183`*^9}, {3.793185781345361*^9, 
  3.79318578732682*^9}, {3.793186943685828*^9, 3.793186946604488*^9}, {
  3.7931869887253776`*^9, 3.793186990908368*^9}, {3.793187070853216*^9, 
  3.7931870744515*^9}, {3.793187119332402*^9, 3.7931871205955505`*^9}, {
  3.7931873272913513`*^9, 3.793187327962962*^9}, {3.7931878090481577`*^9, 
  3.793187809207302*^9}, {3.793188709266276*^9, 3.793188711433749*^9}, {
  3.793274916451949*^9, 3.793274918199545*^9}, {3.7935076828611307`*^9, 
  3.7935077041170497`*^9}},
 CellLabel->"In[4]:=",ExpressionUUID->"1f56ca8f-8d3d-45bd-beba-dc0ce743be72"],

Cell[BoxData[
 RowBox[{"err", "=", 
  RowBox[{"ParallelTable", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"fFermiSum", "[", 
      RowBox[{"4", ",", "1", ",", "1", ",", 
       RowBox[{"N", "[", 
        RowBox[{
         RowBox[{"i", "/", "128"}], ",", "128"}], "]"}]}], "]"}], "-", 
     RowBox[{"fFermi", "[", 
      RowBox[{"4", ",", "1", ",", "1"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", "128", ",", "1"}], "}"}]}], "]"}]}]], "Input",\

 CellChangeTimes->{{3.793163959028923*^9, 3.793163965923715*^9}, {
   3.7931654389067574`*^9, 3.7931655017379746`*^9}, {3.7931655650345526`*^9, 
   3.7931656016729555`*^9}, {3.7931657469620485`*^9, 3.793165750640399*^9}, {
   3.7931673438382716`*^9, 3.7931673453566585`*^9}, {3.79318579538166*^9, 
   3.7931857955648265`*^9}, {3.793185948124047*^9, 3.79318594843533*^9}, {
   3.7931869536614275`*^9, 3.793186954028762*^9}, {3.793187251443719*^9, 
   3.793187252218423*^9}, {3.7931875155128374`*^9, 3.7931875162715263`*^9}, {
   3.7931887458741207`*^9, 3.793188752751895*^9}, {3.7931887837701893`*^9, 
   3.793188788736227*^9}, {3.7932749258705397`*^9, 3.7932749460544424`*^9}, {
   3.79327522142974*^9, 3.7932752222364817`*^9}, {3.793275517731693*^9, 
   3.7932755768257484`*^9}, {3.793275669818796*^9, 3.79327567521677*^9}, {
   3.793275769249432*^9, 3.7932757747845025`*^9}, 3.7935077309562464`*^9},
 CellLabel->"In[5]:=",ExpressionUUID->"e4f95e44-68da-449a-83ac-a4a91363e256"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"err", "//", "Abs"}], "//", "Log10"}], ",", 
   RowBox[{"InterpolationOrder", "\[Rule]", "0"}], ",", 
   RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.793275562555668*^9, 3.793275660225485*^9}},
 CellLabel->"In[6]:=",ExpressionUUID->"070271ab-e8b1-446a-a83f-d7299920295c"],

Cell[BoxData[
 GraphicsBox[{{}, {{{}, {}, 
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[0.009166666666666668],
       AbsoluteThickness[1.6], LineBox[CompressedData["
1:eJxl0nlMk3ccx/GKTAQFZiQTxCl3ELVAyyUMeUAQOQe13JYiEyOIR3RqpqBF
LIIRjwmygERBhhzbwKISFLHGjWyiojIQPAAF1GqZBRVIK7At/T5/fZo0zSv5
5Hk/v+epZfJ2QYoOh8NR/vf9/1f7sWO63Nqszrv7yFl79T26eOiUN9kevLE4
xvfPdC+yA1hcemp66agHeTm45fSBFv8z7mQuOO/YljdVrS5kJ/DK4wu2ZTWw
dgYfvFrde8GIR+aBY88N7GhodSLzwRU9JQn6Ox3JLuCA7NWqxOYVZFewecGR
yPI5rN3Auqlmn21qHcjuYLV1t87RW/ZkD/CGOJ2s6P2sV4JdKkO8itbbkT3B
r3vCxvXP25K9wDJNa7zQz4b8DdiHH+64yIq1NzjshvW5dhcr8irw45xft8QZ
WZN9wN0dSrXFuAWZAV/LvhxjIFuitQQ9vn9AZvEP2/MFf8xM9vRN+Jr2aLs5
jB+jXER7P/DuCI2tOM2c9mh1mqtLCsPuV4MVHVvn/RVoSnu0SeGLmlHTBbT3
B38YS6uOfLiQ9mjrwRgeX8DuA8BHjwgbBuvZHrruLHM1VMHe7xqwKOlkV/Xs
+bRHD457NqWkzaN9ILjpusWyL/8gS9B6A6rc0nh2vxZce/ZIw9M1RrRHZxfO
1myuMaR9ELjcra8obpjtoVW1OXmhuXNpHwy+ogoyEl4zoD1alhfbZNXI9kLA
8rot0pfH9WmP/twSz8tZNIv2oWBpsXmZg9kXtEcvNukLmypi92HgxA+JmV8F
6tEePctpIP3hDB3ah4OfbpV6/NY8fVO7R3dk2rTbDU1qzfkWzG1IXZDkNUV7
dLCorys9cAb1IsC6U/m6cTK6HwZt8Co5JcFSQ9dDdzda8Ewmx7SWo4esXnC3
936k+40EH6jr1wwtIzPohwXy6LtTZAm6It24ZX7mBPXQPwiGRb+spffJEYCt
D0pK/V9+oh76XqSvc4ZaRT208OT3jjWXldRDZ0wEFhz+oKDzrgOPLdapZTzJ
DPrQ6AlD+a231EPvDWntVCneUw9t+9JxpFtNz4MjBJfmj2XrSUaph1bKxJNN
ea+ph+av/WT7XtpPPXQkv/KNq1U39aLANYfXvwrZ+Ih66LeaZSXNzH3qoX8e
zhiWCe9SD12QytyxyWynXjQ4WLDaeNeNv6mHXn7h+ZJLvX3UQ0tKCkN1Den/
IEdv7N/RtsLuDfViwAJeG7cxqoN6aI/CQ2Xhrpeoh947sofrLW700fbQ6Te3
LdUU3NGaEwuOFfVXBr17pDWDDt3kXHbF/rHWEnS94wZfzqon1EO73XRQzQx+
Rr048LjfQg+H2OfUQ9cLixXyZLIELTaYOz8ggq4nR488ONFep+ihXjz4dGjR
cemtTuqhYyxTRC1P71EPPTU5k1/pXkU9tKT8+boSTg+97wTwj6ZV1VGryAy6
alOdnWnIDeqhn6UGKHvud1EPPdZR31Rzup/Oux7smuzSeH3nIJ0X7Sz1nKnJ
ek09dJZJ64PwaQX10Ac/l6t7DZXUE4G3runkZt0eph5asye66yfue+qhK+ZE
VxxYrqIe+smZ74ZuV5A5iWCROke8T2eEeuisi5n9vECyBJ1fOWHeuYssR7/7
3UxYn0vmiMEe4wv5GVK2h+56nPExKJXtoY2bRwXJPLaH3p2bLdXrZc+bBM4N
3yfQ36zy+RdZvKPT
       "]]}}, 
    {RGBColor[0.368417, 0.506779, 0.709798], PointSize[0.009166666666666668], 
     AbsoluteThickness[1.6]}, {
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[0.009166666666666668],
       AbsoluteThickness[1.6]}, {}}, {
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[0.009166666666666668],
       AbsoluteThickness[1.6]}, {}}}, {{}, {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0., 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImageSize->{747.3333333333328, Automatic},
  Method->{
   "OptimizePlotMarkers" -> True, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0., 128.}, {-31.217287230122416`, 1.095871284979064}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.793275566605364*^9, 3.7932756608250303`*^9}, 
   3.7932759708447547`*^9, 3.793507990220111*^9},
 CellLabel->"Out[6]=",ExpressionUUID->"2c14964c-e7ea-4a79-8cb7-8e7207fbf1d8"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"i", "/", "128"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "1", ",", "128", ",", "64"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.793166784233614*^9, 3.793166788256781*^9}, {
  3.7932749875263357`*^9, 
  3.7932749942059417`*^9}},ExpressionUUID->"1d9cd5e7-d72f-4ebe-ac9d-\
5d2e53a6f8ee"],

Cell[BoxData[
 RowBox[{
  RowBox[{"conv", "=", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", 
        FractionBox["1", "2"], ",", 
        FractionBox["1", "4"], ",", 
        FractionBox["1", "8"], ",", 
        FractionBox["1", "16"], ",", 
        FractionBox["1", "32"], ",", 
        FractionBox["1", "64"]}], "}"}], ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
         "-", "10.\
602286001068377269539464904898469146434280738571744712478811051928595925377391\
000202047433717889705165360149046512248951026079579869368`125.49614095997657"}\
], ",", 
         RowBox[{
         "-", "0.0046016771912173948134077140933088582310491124357843054313882\
64457424071352038495342915263935607952317897987472720917072837960084082789`\
122.20141664128946"}], ",", 
         RowBox[{
         "-", "1.1916052860746094386852162878547207326849530529234917334593031\
617994285178237643762216781389633378699270529666807154849848895543`116.\
61447573791871*^-8"}], ",", 
         RowBox[{
         "-", "1.9897856945957703739771020534166777313691221646764469625937008\
30949273011913106602611801681869458119595076689828186`103.83714952988655*^-\
21"}], ",", 
         RowBox[{
         "-", "9.9052098103237396908236981513758899211888147265247615777151180\
1955206076519472824329623079916`82.53420687636763*^-43"}], ",", 
         RowBox[{
         "-", "6.79880674294454139868054717239077605572946054304`37.\
37077588620571*^-88"}], ",", "0``124.53834318783488"}], "}"}], "//", 
       "Abs"}]}], "}"}], "//", "Transpose"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.7931668221286354`*^9, 3.793166838761808*^9}, {
   3.7931668768825755`*^9, 3.7931668776252503`*^9}, 3.793168071717749*^9},
 CellLabel->"In[80]:=",ExpressionUUID->"8c67ee88-fac7-4184-83f1-af0ffea1c6ba"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"conv", "//", "N"}], "//", "TableForm"}], "//", 
  "TeXForm"}]], "Input",
 CellChangeTimes->{{3.7931669839056177`*^9, 3.7931669867612195`*^9}, {
  3.793168103529255*^9, 3.7931681039116025`*^9}, {3.7931688075396175`*^9, 
  3.7931688090850286`*^9}},
 CellLabel->
  "In[108]:=",ExpressionUUID->"fc34d780-0b91-49e1-9527-a2bfb69d47c1"],

Cell["\<\
\\begin{array}{cc}
 1. & 10.6023 \\\\
 0.5 & 0.00460168 \\\\
 0.25 & \\text{1.1916052860746094$\\grave{ }$*${}^{\\wedge}$-8} \\\\
 0.125 & \\text{1.9897856945957703$\\grave{ }$*${}^{\\wedge}$-21} \\\\
 0.0625 & \\text{9.90520981032374$\\grave{ }$*${}^{\\wedge}$-43} \\\\
 0.03125 & \\text{6.798806742944541$\\grave{ }$*${}^{\\wedge}$-88} \\\\
 0.015625 & 0. \\\\
\\end{array}\
\>", "Output",
 CellChangeTimes->{
  3.79316698724566*^9, {3.793168090325716*^9, 3.7931681041858516`*^9}, 
   3.793168809422335*^9},
 CellLabel->
  "Out[108]//TeXForm=",ExpressionUUID->"8309d85d-1bf2-407c-9358-82f65b491d69"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListLogLogPlot", "[", "conv", "]"}]], "Input",
 CellChangeTimes->{{3.7931664060697236`*^9, 3.793166417603746*^9}, {
  3.7931664926922255`*^9, 3.793166510691657*^9}, {3.793166845002*^9, 
  3.793166848104331*^9}, {3.793166880985318*^9, 3.793166887039835*^9}},
 CellLabel->"In[83]:=",ExpressionUUID->"51d6f8cb-0511-4738-b4e0-998bb584da24"],

Cell[BoxData[
 GraphicsBox[{{}, {
    {RGBColor[0.368417, 0.506779, 0.709798], PointSize[0.012833333333333334`],
      AbsoluteThickness[1.6], 
     PointBox[{{0., 
      2.361069638344792}, {-0.6931471805599453, -5.3813344351536}, \
{-1.3862943611198906`, -18.245379365990235`}, {-2.0794415416798357`, \
-47.666260011095574`}, {-2.772588722239781, -96.7180981365539}, \
{-3.4657359027997265`, -200.71074106567093`}}]}, {
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
      0.012833333333333334`], AbsoluteThickness[1.6]}, {}}, {
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
      0.012833333333333334`], AbsoluteThickness[1.6]}, {}}}, {{}, {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{-3.611645791068639, -216.6022626918514},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{
     Charting`ScaledTicks[{Log, Exp}], 
     Charting`ScaledFrameTicks[{Log, Exp}]}, {
     Charting`ScaledTicks[{Log, Exp}], 
     Charting`ScaledFrameTicks[{Log, Exp}]}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  Method->{
   "OptimizePlotMarkers" -> True, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Exp[#]& )[
         Part[#, 1]], 
        (Exp[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Exp[#]& )[
         Part[#, 1]], 
        (Exp[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{-3.611645791068639, 0.}, {-216.6022626918514, 
   2.361069638344792}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.05]}},
  Ticks->FrontEndValueCache[{
     Charting`ScaledTicks[{Log, Exp}], 
     Charting`ScaledTicks[{Log, Exp}]}, {{{-2.995732273553991, 
       FormBox[
        TagBox[
         InterpretationBox["\"0.05\"", 0.05, AutoDelete -> True], 
         NumberForm[#, {
           DirectedInfinity[1], 2}]& ], TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {-2.3025850929940455`, 
       FormBox[
        TagBox[
         InterpretationBox["\"0.10\"", 0.1, AutoDelete -> True], 
         NumberForm[#, {
           DirectedInfinity[1], 2}]& ], TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {-0.6931471805599453, 
       FormBox[
        TagBox[
         InterpretationBox["\"0.50\"", 0.5, AutoDelete -> True], 
         NumberForm[#, {
           DirectedInfinity[1], 2}]& ], TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {0., 
       FormBox["1", TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {-4.605170185988091, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-3.912023005428146, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-3.506557897319982, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-3.2188758248682006`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-2.8134107167600364`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-2.659260036932778, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-2.5257286443082556`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-2.4079456086518722`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-1.6094379124341003`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-1.2039728043259361`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-0.916290731874155, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-0.5108256237659907, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-0.35667494393873245`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-0.2231435513142097, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-0.10536051565782628`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {0.6931471805599453, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {1.0986122886681098`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {1.3862943611198906`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {1.6094379124341003`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}}, {{-207.2326583694641, 
       FormBox[
        TemplateBox[{"10", 
          RowBox[{"-", "90"}]}, "Superscript", SyntaxForm -> SuperscriptBox], 
        TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {-161.1809565095832, 
       FormBox[
        TemplateBox[{"10", 
          RowBox[{"-", "70"}]}, "Superscript", SyntaxForm -> SuperscriptBox], 
        TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {-115.12925464970229`, 
       FormBox[
        TemplateBox[{"10", 
          RowBox[{"-", "50"}]}, "Superscript", SyntaxForm -> SuperscriptBox], 
        TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {-69.07755278982137, 
       FormBox[
        TemplateBox[{"10", 
          RowBox[{"-", "30"}]}, "Superscript", SyntaxForm -> SuperscriptBox], 
        TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {-23.025850929940457`, 
       FormBox[
        TemplateBox[{"10", 
          RowBox[{"-", "10"}]}, "Superscript", SyntaxForm -> SuperscriptBox], 
        TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {-184.20680743952366`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-138.15510557964274`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-92.10340371976183, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-46.051701859880914`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {0., 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}}}]]], "Output",
 CellChangeTimes->{
  3.7931664180291395`*^9, {3.793166493770212*^9, 3.7931665114713655`*^9}, 
   3.7931668483395443`*^9, {3.7931668815558367`*^9, 3.79316688729907*^9}, 
   3.793168112604501*^9},
 CellLabel->"Out[83]=",ExpressionUUID->"e1b625b4-374e-4c6b-9886-80cbaeb62aa4"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"conv2", "=", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", 
        FractionBox["1", "2"], ",", 
        FractionBox["1", "4"], ",", 
        FractionBox["1", "8"], ",", 
        FractionBox["1", "16"], ",", 
        FractionBox["1", "32"], ",", 
        FractionBox["1", "64"]}], "}"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"conv", "[", 
         RowBox[{"[", 
          RowBox[{";;", ",", "2"}], "]"}], "]"}], "//", "Abs"}], "//", 
       "Log10"}]}], "}"}], "//", "Transpose"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.793167073681514*^9, 3.7931670980322313`*^9}, {
  3.793168153184913*^9, 3.793168158776008*^9}, {3.793168245232323*^9, 
  3.7931683204318733`*^9}},
 CellLabel->
  "In[106]:=",ExpressionUUID->"88d91881-34d2-4f9f-9122-aa48474c2256"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"w1", "=", 
  RowBox[{"ListPlot", "[", "conv2", "]"}]}]], "Input",
 CellChangeTimes->{{3.793167083649107*^9, 3.7931670896385727`*^9}, 
   3.7931681393603373`*^9, {3.7931681767148666`*^9, 3.7931681771752853`*^9}},
 CellLabel->
  "In[107]:=",ExpressionUUID->"c6744a0d-f247-4d88-8322-6ab2aca51474"],

Cell[BoxData[
 GraphicsBox[{{}, {
    {RGBColor[0.368417, 0.506779, 0.709798], PointSize[0.012833333333333334`],
      AbsoluteThickness[1.6], 
     PointBox[{{1., 1.0253995153224498`}, {0.5, -2.337083850463161}, {
      0.25, -7.92386757888101}, {0.125, -20.701193695784443`}, {
      0.0625, -42.004136320882544`}, {0.03125, -87.16756730353329}}]}, {
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
      0.012833333333333334`], AbsoluteThickness[1.6]}, {}}, {
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
      0.012833333333333334`], AbsoluteThickness[1.6]}, {}}}, {{}, {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  Method->{
   "OptimizePlotMarkers" -> True, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 1.}, {-87.16756730353329, 1.0253995153224498`}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.7931670871302867`*^9, 3.793167089828746*^9}, {
  3.793168135184024*^9, 3.793168177514593*^9}, {3.793168247669544*^9, 
  3.79316832198028*^9}},
 CellLabel->
  "Out[107]=",ExpressionUUID->"1c03c875-9e47-4e48-8c4b-7a7b02abca31"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fit", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"a", " ", 
     RowBox[{"k", "^", "2"}]}], "+", 
    RowBox[{"b", " ", "k"}], " ", "+", "c"}], "/.", 
   RowBox[{"FindFit", "[", 
    RowBox[{
     RowBox[{"conv2", "[", 
      RowBox[{"[", 
       RowBox[{"1", ";;", "4"}], "]"}], "]"}], ",", 
     RowBox[{
      RowBox[{"a", " ", 
       RowBox[{"k", "^", "2"}]}], "+", 
      RowBox[{"b", " ", "k"}], " ", "+", "c"}], ",", 
     RowBox[{"{", 
      RowBox[{"a", ",", "b", ",", "c"}], "}"}], ",", "k"}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.793167101208132*^9, 3.7931671401661406`*^9}, {
  3.793168199384021*^9, 3.7931682028231525`*^9}},
 CellLabel->"In[91]:=",ExpressionUUID->"85cbbd76-189c-44c0-aa31-4395cc18d6f1"],

Cell[BoxData[
 RowBox[{"0.\
777087414029782576089804063103276303151551654866802118989865562648026336461222\
9116627101275018639402078037579535416`105.51536060754754", "+", 
  RowBox[{
  "0.0155242728354868417153967784538551018392061602123661202005467506223925410\
68895318523180581927190972050322471208615263378769537431344504`105.\
51536060754754", " ", "k"}], "-", 
  RowBox[{
  "2.3537106877794552198576363721102225820736161279282372805608719830405165425\
633176415556857189990191456241989759826523`105.51536060754754", " ", 
   SuperscriptBox["k", "2"]}]}]], "Output",
 CellChangeTimes->{{3.7931671291110415`*^9, 3.793167140527469*^9}, 
   3.793168164686899*^9, 3.7931682031054087`*^9},
 CellLabel->"Out[91]=",ExpressionUUID->"34b80227-11b2-4b7c-8bf9-1b471f32d332"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"w2", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{"fit", ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"-", "6"}], ",", "0"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7931682066246223`*^9, 3.7931682219986324`*^9}},
 CellLabel->"In[92]:=",ExpressionUUID->"ce8662bb-dd41-4e5d-85e9-d0a2b586dac7"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
      1.], LineBox[CompressedData["
1:eJwVk3VU1GkfxRGUkh5KBEVXUgVsQnyUUJeSGAGxEbEIWRQRcUWXGFG6F6VT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       "]]},
     Annotation[#, "Charting`Private`Tag$105626#1"]& ]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{-6, 0}, {-84.04963952262895, 0.7770874121288158}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.7931682223599606`*^9},
 CellLabel->"Out[92]=",ExpressionUUID->"9145c712-368a-49b4-abad-7a891fe2b9f5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Show", "[", 
  RowBox[{"w1", ",", "w2"}], "]"}]], "Input",
 CellChangeTimes->{{3.7931682257515545`*^9, 3.7931682280391517`*^9}},
 CellLabel->"In[93]:=",ExpressionUUID->"2a3642f2-3929-4ea9-a903-d711a887774c"],

Cell[BoxData[
 GraphicsBox[{{{}, {
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
      0.012833333333333334`], AbsoluteThickness[1.6], 
      PointBox[{{0., 
       1.0253995153224498`}, {-1., -2.337083850463161}, {-2., \
-7.92386757888101}, {-3., -20.701193695784443`}, {-4., -42.004136320882544`}, \
{-5., -87.16756730353329}}]}, {
      {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
       0.012833333333333334`], AbsoluteThickness[1.6]}, {}}, {
      {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
       0.012833333333333334`], AbsoluteThickness[
       1.6]}, {}}}, {{}, {}}}, {{{}, {}, 
     TagBox[
      {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], 
       Opacity[1.], LineBox[CompressedData["
1:eJwVk3VU1GkfxRGUkh5KBEVXUgVsQnyUUJeSGAGxEbEIWRQRcUWXGFG6F6VT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        "]]},
      Annotation[#, "Charting`Private`Tag$105626#1"]& ]}, {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  Method->{
   "OptimizePlotMarkers" -> True, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{-5., 0}, {-87.16756730353329, 1.0253995153224498`}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.7931682283404245`*^9},
 CellLabel->"Out[93]=",ExpressionUUID->"752eae86-6846-450b-9e3f-12577e7a10f8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fFermi", "[", 
  RowBox[{"4", ",", "1", ",", "1"}], "]"}]], "Input",
 CellChangeTimes->{{3.7931652276689014`*^9, 3.7931652332439833`*^9}},
 CellLabel->"In[35]:=",ExpressionUUID->"64702392-a28b-4dcb-b682-385a5aba4340"],

Cell[BoxData["114.\
066877991379025899925088247759032653609602513093723942663727131064033737949990\
4674644091267176659081707878047942922180030203557661620382401086648770034318`\
128."], "Output",
 CellChangeTimes->{3.7931652335892973`*^9},
 CellLabel->"Out[35]=",ExpressionUUID->"e4c02ca8-c24d-42cd-8f29-05a4091553b2"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"fFermiTanhSinh", "=", 
   RowBox[{"Function", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"k", ",", "\[Eta]", ",", "\[Theta]", ",", "h", ",", "tMAX"}], 
      "}"}], ",", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x", ",", "dx", ",", "integrand", ",", "tTBL"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"x", "=", 
         RowBox[{"Exp", "[", 
          RowBox[{"t", "-", 
           RowBox[{"Exp", "[", 
            RowBox[{"-", "t"}], "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        
        RowBox[{"dx", "=", 
         RowBox[{"D", "[", 
          RowBox[{"x", ",", "t"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"integrand", "=", 
         RowBox[{
          RowBox[{"x", "^", "k"}], " ", 
          RowBox[{
           RowBox[{"Sqrt", "[", 
            RowBox[{"1", "+", 
             RowBox[{"\[Theta]", " ", 
              RowBox[{"x", "/", "2"}]}]}], "]"}], "/", 
           RowBox[{"(", 
            RowBox[{"1", "+", 
             RowBox[{"Exp", "[", 
              RowBox[{"x", "-", "\[Eta]"}], "]"}]}], ")"}]}], " ", "dx"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"tTBL", "=", 
         RowBox[{"Table", "[", 
          RowBox[{"t", ",", 
           RowBox[{"{", 
            RowBox[{"t", ",", 
             RowBox[{"-", "tMAX"}], ",", "tMAX", ",", "h"}], "}"}]}], "]"}]}],
         ";", "\[IndentingNewLine]", 
        RowBox[{"h", "*", 
         RowBox[{"Sum", "[", 
          RowBox[{"integrand", ",", 
           RowBox[{"{", 
            RowBox[{"t", ",", "tTBL"}], "}"}]}], "]"}]}]}]}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.7930714016239533`*^9, 3.793071580695798*^9}, {
   3.793071639552605*^9, 3.7930716434231377`*^9}, {3.7930717048947515`*^9, 
   3.793071715823242*^9}, {3.793071782863896*^9, 3.7930718230300584`*^9}, 
   3.793507800820715*^9, 3.793518623631566*^9},
 CellLabel->"In[1]:=",ExpressionUUID->"033add7e-f6be-4059-b520-62ee5e84f9fe"],

Cell[BoxData[
 RowBox[{
  RowBox[{"fFermiTanhSinh2", "=", 
   RowBox[{"Function", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"k", ",", "\[Eta]", ",", "\[Theta]", ",", "h", ",", "tMAX"}], 
      "}"}], ",", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x", ",", "dx", ",", "integrand", ",", "tTBL"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"x", "=", 
         RowBox[{"\[Eta]", " ", 
          RowBox[{"Exp", "[", 
           RowBox[{"t", "-", 
            RowBox[{"Exp", "[", 
             RowBox[{"-", "t"}], "]"}]}], "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"dx", "=", 
         RowBox[{"D", "[", 
          RowBox[{"x", ",", "t"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"integrand", "=", 
         RowBox[{
          RowBox[{"x", "^", "k"}], " ", 
          RowBox[{
           RowBox[{"Sqrt", "[", 
            RowBox[{"1", "+", 
             RowBox[{"\[Theta]", " ", 
              RowBox[{"x", "/", "2"}]}]}], "]"}], "/", 
           RowBox[{"(", 
            RowBox[{"1", "+", 
             RowBox[{"Exp", "[", 
              RowBox[{"x", "-", "\[Eta]"}], "]"}]}], ")"}]}], " ", "dx"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"tTBL", "=", 
         RowBox[{"Table", "[", 
          RowBox[{"t", ",", 
           RowBox[{"{", 
            RowBox[{"t", ",", 
             RowBox[{"-", "tMAX"}], ",", "tMAX", ",", "h"}], "}"}]}], "]"}]}],
         ";", "\[IndentingNewLine]", 
        RowBox[{"h", "*", 
         RowBox[{"Sum", "[", 
          RowBox[{"integrand", ",", 
           RowBox[{"{", 
            RowBox[{"t", ",", "tTBL"}], "}"}]}], "]"}]}]}]}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.7935188411252155`*^9, 3.793518871516492*^9}, {
  3.7935189602613564`*^9, 3.793518974733138*^9}, {3.7936224164059544`*^9, 
  3.7936224173233*^9}},
 CellLabel->"In[2]:=",ExpressionUUID->"7a59c861-b7d6-4779-b5cf-1bdfcc5bddce"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"N", "[", 
  RowBox[{
   RowBox[{"fFermiTanhSinh", "[", 
    RowBox[{"0", ",", "100", ",", "1", ",", 
     RowBox[{"1", "/", "64"}], ",", "6"}], "]"}], ",", "32"}], "]"}]], "Input",\

 CellChangeTimes->{{3.793072993623496*^9, 3.7930730007029524`*^9}, {
  3.793074504391392*^9, 3.793074510341312*^9}, {3.7935186328219976`*^9, 
  3.793518650525761*^9}, {3.79351869935101*^9, 3.793518702926292*^9}, {
  3.7935187397902913`*^9, 3.7935188326444025`*^9}, {3.7935189923638115`*^9, 
  3.7935190018750305`*^9}, {3.7936226703626895`*^9, 3.793622670488804*^9}, {
  3.793622701178765*^9, 3.7936227866004553`*^9}},
 CellLabel->"In[38]:=",ExpressionUUID->"d9ef528d-8a4e-4dfd-aa61-fe33668623d1"],

Cell[BoxData["484.3415877873860230277931896030651405552382363193631999474773`\
32."], "Output",
 CellChangeTimes->{
  3.793073001197906*^9, {3.793074505674062*^9, 3.793074510666607*^9}, {
   3.793518637512824*^9, 3.793518650902103*^9}, 3.7935187031685123`*^9, {
   3.79351874172256*^9, 3.79351883280655*^9}, {3.793518977921075*^9, 
   3.7935190021492796`*^9}, 3.7936224308351297`*^9, 3.793622480291728*^9, 
   3.79362267101328*^9, {3.7936227025079794`*^9, 3.793622787060873*^9}, 
   3.7936229003721223`*^9},
 CellLabel->"Out[38]=",ExpressionUUID->"9a49b850-5aaf-44b6-8000-927eabee5229"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"N", "[", 
  RowBox[{
   RowBox[{"fFermiTanhSinh2", "[", 
    RowBox[{"0", ",", "100", ",", "1", ",", 
     RowBox[{"1", "/", "128"}], ",", "3"}], "]"}], ",", "32"}], 
  "]"}]], "Input",
 CellChangeTimes->{
  3.7935188830280194`*^9, {3.7935189308453784`*^9, 3.7935189314509287`*^9}, {
   3.7935190047802334`*^9, 3.7935190084986267`*^9}, {3.793622472006172*^9, 
   3.793622474514471*^9}, {3.793622673027115*^9, 3.793622695849394*^9}, {
   3.7936227421305137`*^9, 3.7936227942399054`*^9}},
 CellLabel->"In[35]:=",ExpressionUUID->"4ce8b5a5-cebc-4e27-8651-0188f9cfa421"],

Cell[BoxData["484.3413823417527813112989160124506958434525060019183506114193`\
32."], "Output",
 CellChangeTimes->{
  3.793518883573515*^9, 3.793518932199642*^9, {3.793518978658248*^9, 
   3.7935190088149137`*^9}, 3.7936224318260374`*^9, 3.793622474742678*^9, {
   3.7936226733554125`*^9, 3.7936226961726866`*^9}, {3.7936227437149596`*^9, 
   3.793622804097397*^9}},
 CellLabel->"Out[35]=",ExpressionUUID->"2f4193f3-6b65-4c39-ad1b-2b2c5252386f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fFermi", "[", 
  RowBox[{"0", ",", "100", ",", "1"}], "]"}]], "Input",
 CellChangeTimes->{{3.7935187227019744`*^9, 3.7935187264934473`*^9}},
 CellLabel->"In[39]:=",ExpressionUUID->"42d195c1-41af-4928-89eb-483a33d5d0a7"],

Cell[BoxData["484.\
341388801920283356723582929071031900525994750059092320043991585621732349551936\
4676472451101502326674472180038093492842977453516609585264652308977616751177`\
128."], "Output",
 CellChangeTimes->{
  3.793518728262182*^9, {3.79362246781585*^9, 3.793622489484106*^9}, 
   3.793622737029863*^9, 3.7936228059230614`*^9, 3.7936229047646265`*^9},
 CellLabel->"Out[39]=",ExpressionUUID->"63a8778d-ddf5-4819-a900-210bf9033fe2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "-", "%%"}]], "Input",
 CellChangeTimes->{{3.7936228063374367`*^9, 3.7936228070876217`*^9}},
 CellLabel->"In[40]:=",ExpressionUUID->"691a251c-fb73-445f-a5d7-424ecace234c"],

Cell[BoxData[
 RowBox[{"-", 
  "0.0001989854657396710696066739941086547122415693041076274335`25.\
61366959474809"}]], "Output",
 CellChangeTimes->{3.7936228073718796`*^9, 3.793622904828685*^9},
 CellLabel->"Out[40]=",ExpressionUUID->"a6812994-8c87-4ddc-a9bf-94bb2b5f7bc3"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
  "0.000000", " ", "100.000000", " ", "1.000000", " ", "4.843413696289062500",
    "e"}], "+", 
  RowBox[{"02", " ", "4.978699684143066406", "e"}], "+", 
  RowBox[{"00", " ", "4.843413888019202886", "e"}], "+", "02"}]], "Input",
 CellChangeTimes->{{3.7935186944554806`*^9, 
  3.793518694456481*^9}},ExpressionUUID->"acd1c97f-0353-4f33-ba09-\
1e86a07ee24d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"gFermi", "=", 
   RowBox[{"Function", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"n", ",", "\[Alpha]", ",", "\[Beta]"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"1", "/", 
       RowBox[{"\[Alpha]", "^", 
        RowBox[{"(", 
         RowBox[{"3", "+", 
          RowBox[{"2", "n"}]}], ")"}]}]}], 
      RowBox[{"NIntegrate", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"x", "^", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", "n"}], "+", "1"}], ")"}]}], 
         RowBox[{
          RowBox[{"Sqrt", "[", 
           RowBox[{
            RowBox[{"x", "^", "2"}], "-", 
            RowBox[{"\[Alpha]", "^", "2"}]}], "]"}], "/", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            RowBox[{"Exp", "[", 
             RowBox[{"x", "-", "\[Beta]"}], "]"}]}], ")"}]}]}], ",", 
        RowBox[{"{", 
         RowBox[{"x", ",", "\[Alpha]", ",", "Infinity"}], "}"}], ",", 
        RowBox[{"WorkingPrecision", "\[Rule]", "128"}], ",", 
        RowBox[{"Method", "\[Rule]", "\"\<DoubleExponential\>\""}], ",", 
        RowBox[{"MaxRecursion", "\[Rule]", "16"}]}], "]"}]}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.59385830912812*^9, 3.593858348279481*^9}, {
  3.5938591705668497`*^9, 3.593859171394637*^9}},
 CellLabel->"In[2]:=",ExpressionUUID->"53943d9e-19df-4fb2-a53f-a3559a3b51d5"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"kVALS", "=", 
   RowBox[{
    RowBox[{"Rationalize", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "0.99999999999999988897769753748435"}], ",", 
        RowBox[{"-", "0.999999"}], ",", 
        RowBox[{"-", "0.9999"}], ",", 
        RowBox[{"-", "0.999"}], ",", 
        RowBox[{"-", "0.99"}], ",", 
        RowBox[{"-", "0.98"}], ",", 
        RowBox[{"-", "0.97"}], ",", 
        RowBox[{"-", "0.96"}], ",", 
        RowBox[{"-", "0.95"}], ",", 
        RowBox[{"-", "0.94"}], ",", 
        RowBox[{"-", "0.93"}], ",", 
        RowBox[{"-", "0.92"}], ",", 
        RowBox[{"-", "0.91"}], ",", 
        RowBox[{"-", "0.9"}], ",", 
        RowBox[{"-", "0.8"}], ",", 
        RowBox[{"-", "0.7"}], ",", 
        RowBox[{"-", "0.6"}], ",", 
        RowBox[{"-", "0.5"}], ",", "0.0", ",", "0.5", ",", "1.0", ",", "2.0", 
        ",", "4.0"}], "}"}], ",", "0"}], "]"}], "//", "Reverse"}]}], 
  "\n"}]], "Input",
 CellChangeTimes->{{3.593092876277165*^9, 3.593092899060151*^9}, {
  3.5930932712207117`*^9, 3.5930932718354197`*^9}, {3.593093955401795*^9, 
  3.5930939628615217`*^9}, {3.793871182084708*^9, 3.7938711837407293`*^9}},
 CellLabel->"In[14]:=",ExpressionUUID->"b8d72ab5-eb21-4ea3-87f1-a127788e43fc"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"4", ",", "2", ",", "1", ",", 
   FractionBox["1", "2"], ",", "0", ",", 
   RowBox[{"-", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{"-", 
    FractionBox["3", "5"]}], ",", 
   RowBox[{"-", 
    FractionBox["7", "10"]}], ",", 
   RowBox[{"-", 
    FractionBox["4", "5"]}], ",", 
   RowBox[{"-", 
    FractionBox["9", "10"]}], ",", 
   RowBox[{"-", 
    FractionBox["91", "100"]}], ",", 
   RowBox[{"-", 
    FractionBox["23", "25"]}], ",", 
   RowBox[{"-", 
    FractionBox["93", "100"]}], ",", 
   RowBox[{"-", 
    FractionBox["47", "50"]}], ",", 
   RowBox[{"-", 
    FractionBox["19", "20"]}], ",", 
   RowBox[{"-", 
    FractionBox["24", "25"]}], ",", 
   RowBox[{"-", 
    FractionBox["97", "100"]}], ",", 
   RowBox[{"-", 
    FractionBox["49", "50"]}], ",", 
   RowBox[{"-", 
    FractionBox["99", "100"]}], ",", 
   RowBox[{"-", 
    FractionBox["999", "1000"]}], ",", 
   RowBox[{"-", 
    FractionBox["9999", "10000"]}], ",", 
   RowBox[{"-", 
    FractionBox["999999", "1000000"]}], ",", 
   RowBox[{"-", 
    FractionBox["9007199254740991", "9007199254740992"]}]}], "}"}]], "Output",\

 CellChangeTimes->{{3.593093963378934*^9, 3.5930939723541183`*^9}, 
   3.593094022910881*^9, 3.5937789760402107`*^9, 3.593858199168721*^9, 
   3.5938591791025963`*^9, 3.593860467444716*^9, 3.5938639429172363`*^9, 
   3.7938703950202293`*^9, 3.793870498790222*^9, 3.793870572016224*^9, 
   3.7938711842952423`*^9},
 CellLabel->"Out[14]=",ExpressionUUID->"e2904f80-edba-483b-8f30-602a4cc81f63"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"For", "[", 
  RowBox[{
   RowBox[{"i", "=", "1"}], ",", 
   RowBox[{"i", "\[LessEqual]", 
    RowBox[{"Length", "[", "kVALS", "]"}]}], ",", 
   RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"Date", "[", "]"}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"i", ",", "\"\<\\t\>\"", ",", 
      RowBox[{"kVALS", "[", 
       RowBox[{"[", "i", "]"}], "]"}], ",", "\"\<\\t\>\"", ",", 
      RowBox[{"fFermi", "[", 
       RowBox[{
        RowBox[{"kVALS", "[", 
         RowBox[{"[", "i", "]"}], "]"}], ",", "0", ",", "0"}], "]"}]}], 
     "]"}]}]}], "\[IndentingNewLine]", "]"}]], "Input",
 CellChangeTimes->{{3.7938704265165987`*^9, 3.7938704420973535`*^9}, {
   3.7938705010663023`*^9, 3.793870501912079*^9}, {3.7938712244845796`*^9, 
   3.793871275746625*^9}, {3.7938713085740957`*^9, 3.7938713245131893`*^9}, {
   3.7938713565142593`*^9, 3.793871372425352*^9}, {3.7938716392029514`*^9, 
   3.793871639598815*^9}, 
   3.7938724615954037`*^9},ExpressionUUID->"6494c50d-fb53-4646-9460-\
93a2b7c89fba"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2020", ",", "3", ",", "22", ",", "14", ",", "14", ",", 
   "0.2288902`7.112202187788913"}], "}"}]], "Print",
 CellChangeTimes->{{3.7938712594786835`*^9, 3.793871277323574*^9}, {
   3.793871311140438*^9, 3.793871324965104*^9}, 3.793871373309658*^9, 
   3.793871640242903*^9},
 CellLabel->
  "During evaluation of \
In[24]:=",ExpressionUUID->"79b1fb9b-4b26-4eeb-a971-59c011cda7e5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "1", "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   "27034.31311514835222998798734498350533233755574293780482597996888080851720\
7988842107400052758922952940491638674506062993631103444769295770376`128."}],
  SequenceForm[
  1, "\t", 4, "\t", 
   27034.313115148352229987987344983505332337555742937804825979968880808517207\
988842107400052758922952940491638674506062993631103444769295770376`128.],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7938712594786835`*^9, 3.793871277323574*^9}, {
   3.793871311140438*^9, 3.793871324965104*^9}, 3.793871373309658*^9, 
   3.793871640295951*^9},
 CellLabel->
  "During evaluation of \
In[24]:=",ExpressionUUID->"037b5b85-9743-4fb5-81c8-7cf688b137b6"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2020", ",", "3", ",", "22", ",", "14", ",", "14", ",", 
   "0.2949501`7.22232353690852"}], "}"}]], "Print",
 CellChangeTimes->{{3.7938712594786835`*^9, 3.793871277323574*^9}, {
   3.793871311140438*^9, 3.793871324965104*^9}, 3.793871373309658*^9, 
   3.793871640301956*^9},
 CellLabel->
  "During evaluation of \
In[24]:=",ExpressionUUID->"7433244a-c20e-4c1b-97b2-02630ab4958b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "2", "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   "366.2321054696421055583148799189747393104776055050779729117217304627689022\
922914815050436108848092215053724426404133557936221372026042731871705550200851\
089489`128."}],
  SequenceForm[
  2, "\t", 2, "\t", 
   366.23210546964210555831487991897473931047760550507797291172173046276890229\
229148150504361088480922150537244264041335579362213720260427318717055502008510\
89489`128.],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7938712594786835`*^9, 3.793871277323574*^9}, {
   3.793871311140438*^9, 3.793871324965104*^9}, 3.793871373309658*^9, 
   3.793871640365014*^9},
 CellLabel->
  "During evaluation of \
In[24]:=",ExpressionUUID->"4277c377-96e6-4369-917e-f1e52dc5577d"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2020", ",", "3", ",", "22", ",", "14", ",", "14", ",", 
   "0.3650139`7.314884392187267"}], "}"}]], "Print",
 CellChangeTimes->{{3.7938712594786835`*^9, 3.793871277323574*^9}, {
   3.793871311140438*^9, 3.793871324965104*^9}, 3.793871373309658*^9, 
   3.793871640367016*^9},
 CellLabel->
  "During evaluation of \
In[24]:=",ExpressionUUID->"c7e77bc0-cb78-4f56-ac3a-ef60b44324d9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "3", "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   "51.64488866743374196013717919146083835867631682320052278524187476386667904\
149481473557051306945741804840192605357744056886513130559756845487801214393464\
24445`128."}],
  SequenceForm[
  3, "\t", 1, "\t", 
   51.644888667433741960137179191460838358676316823200522785241874763866679041\
494814735570513069457418048401926053577440568865131305597568454878012143934642\
4445`128.],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7938712594786835`*^9, 3.793871277323574*^9}, {
   3.793871311140438*^9, 3.793871324965104*^9}, 3.793871373309658*^9, 
   3.793871640436078*^9},
 CellLabel->
  "During evaluation of \
In[24]:=",ExpressionUUID->"66150745-5a94-459b-b8dd-378b9b08b972"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2020", ",", "3", ",", "22", ",", "14", ",", "14", ",", 
   "0.4350774`7.391141513707079"}], "}"}]], "Print",
 CellChangeTimes->{{3.7938712594786835`*^9, 3.793871277323574*^9}, {
   3.793871311140438*^9, 3.793871324965104*^9}, 3.793871373309658*^9, 
   3.79387164043808*^9},
 CellLabel->
  "During evaluation of \
In[24]:=",ExpressionUUID->"52f4b24f-cda7-4894-a4f5-32ca47c6a6c4"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"4", "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   FractionBox["1", "2"], "\[InvisibleSpace]", "\<\"\\t\"\>", 
   "\[InvisibleSpace]", 
   "21.34447149235518294941521684645604673793342561475722374568475520929341402\
143896069324216117053245846267027818443473975700272909802049565574917202437343\
9886`128."}],
  SequenceForm[4, "\t", 
   Rational[1, 2], "\t", 
   21.344471492355182949415216846456046737933425614757223745684755209293414021\
438960693242161170532458462670278184434739757002729098020495655749172024373439\
886`128.],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7938712594786835`*^9, 3.793871277323574*^9}, {
   3.793871311140438*^9, 3.793871324965104*^9}, 3.793871373309658*^9, 
   3.793871640518152*^9},
 CellLabel->
  "During evaluation of \
In[24]:=",ExpressionUUID->"cb1c98fd-cc73-4b40-924e-a24ec65f344e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2020", ",", "3", ",", "22", ",", "14", ",", "14", ",", 
   "0.5171516`7.466192861832901"}], "}"}]], "Print",
 CellChangeTimes->{{3.7938712594786835`*^9, 3.793871277323574*^9}, {
   3.793871311140438*^9, 3.793871324965104*^9}, 3.793871373309658*^9, 
   3.7938716405191536`*^9},
 CellLabel->
  "During evaluation of \
In[24]:=",ExpressionUUID->"9fb83d2b-95b3-47cf-9ab0-143d4f92f199"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "5", "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", "0", 
   "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   "10.00004539889921686464676948782930710559678150228178755879426406319548891\
805065900885876195835123147629897341320225891480730633190434911153971578800147\
51541`128."}],
  SequenceForm[
  5, "\t", 0, "\t", 
   10.000045398899216864646769487829307105596781502281787558794264063195488918\
050659008858761958351231476298973413202258914807306331904349111539715788001475\
1541`128.],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7938712594786835`*^9, 3.793871277323574*^9}, {
   3.793871311140438*^9, 3.793871324965104*^9}, 3.793871373309658*^9, 
   3.7938716405912256`*^9},
 CellLabel->
  "During evaluation of \
In[24]:=",ExpressionUUID->"aae62ff1-91f7-4ca5-8bee-fedd0fac93da"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2020", ",", "3", ",", "22", ",", "14", ",", "14", ",", 
   "0.5912254`7.524328072941311"}], "}"}]], "Print",
 CellChangeTimes->{{3.7938712594786835`*^9, 3.793871277323574*^9}, {
   3.793871311140438*^9, 3.793871324965104*^9}, 3.793871373309658*^9, 
   3.7938716405932207`*^9},
 CellLabel->
  "During evaluation of \
In[24]:=",ExpressionUUID->"4b2f72a5-2c5d-447b-a6f6-aa52930587dd"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"6", "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"-", 
    FractionBox["1", "2"]}], "\[InvisibleSpace]", "\<\"\\t\"\>", 
   "\[InvisibleSpace]", 
   "6.297137244533847844164096843716848550301231929469158938883091897953712840\
786112714757351191402682246138819913157483768869952701279844810451155165116057\
5993`128."}],
  SequenceForm[6, "\t", 
   Rational[-1, 2], "\t", 
   6.2971372445338478441640968437168485503012319294691589388830918979537128407\
861127147573511914026822461388199131574837688699527012798448104511551651160575\
993`128.],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7938712594786835`*^9, 3.793871277323574*^9}, {
   3.793871311140438*^9, 3.793871324965104*^9}, 3.793871373309658*^9, 
   3.793871640731346*^9},
 CellLabel->
  "During evaluation of \
In[24]:=",ExpressionUUID->"2637033c-8ac4-4997-8d28-33097ee9a58c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2020", ",", "3", ",", "22", ",", "14", ",", "14", ",", 
   "0.7303452`7.616103168485683"}], "}"}]], "Print",
 CellChangeTimes->{{3.7938712594786835`*^9, 3.793871277323574*^9}, {
   3.793871311140438*^9, 3.793871324965104*^9}, 3.793871373309658*^9, 
   3.793871640733348*^9},
 CellLabel->
  "During evaluation of \
In[24]:=",ExpressionUUID->"a9f0b4fe-cb2d-406c-80aa-7bdfba821daa"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"7", "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"-", 
    FractionBox["3", "5"]}], "\[InvisibleSpace]", "\<\"\\t\"\>", 
   "\[InvisibleSpace]", 
   "6.253385329085755229473326556147384447289309502802510801416691456170164447\
466685938088061500102557569755120224888629692526902522772702535879512255112430\
3636`128."}],
  SequenceForm[7, "\t", 
   Rational[-3, 5], "\t", 
   6.2533853290857552294733265561473844472893095028025108014166914561701644474\
666859380880615001025575697551202248886296925269025227727025358795122551124303\
636`128.],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7938712594786835`*^9, 3.793871277323574*^9}, {
   3.793871311140438*^9, 3.793871324965104*^9}, 3.793871373309658*^9, 
   3.7938716408974967`*^9},
 CellLabel->
  "During evaluation of \
In[24]:=",ExpressionUUID->"4308d7e3-7620-4256-8a20-bcfc1c0360e0"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2020", ",", "3", ",", "22", ",", "14", ",", "14", ",", 
   "0.8974967`7.705607849558583"}], "}"}]], "Print",
 CellChangeTimes->{{3.7938712594786835`*^9, 3.793871277323574*^9}, {
   3.793871311140438*^9, 3.793871324965104*^9}, 3.793871373309658*^9, 
   3.793871640899499*^9},
 CellLabel->
  "During evaluation of \
In[24]:=",ExpressionUUID->"b1831697-95ee-4e94-8886-e55f6d5b20a8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"8", "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"-", 
    FractionBox["7", "10"]}], "\[InvisibleSpace]", "\<\"\\t\"\>", 
   "\[InvisibleSpace]", 
   "6.626258915314093847463496033005029160850874970792182336444549395500077549\
049021198155053878939339257812927355629835636857602462534042982210470873542155\
9692`128."}],
  SequenceForm[8, "\t", 
   Rational[-7, 10], "\t", 
   6.6262589153140938474634960330050291608508749707921823364445493955000775490\
490211981550538789393392578129273556298356368576024625340429822104708735421559\
692`128.],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7938712594786835`*^9, 3.793871277323574*^9}, {
   3.793871311140438*^9, 3.793871324965104*^9}, 3.793871373309658*^9, 
   3.7938716410806627`*^9},
 CellLabel->
  "During evaluation of \
In[24]:=",ExpressionUUID->"890fcf71-ad32-45d0-a64f-58439ff47dde"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2020", ",", "3", ",", "22", ",", "14", ",", "14", ",", 
   "1.079662`7.785862802558415"}], "}"}]], "Print",
 CellChangeTimes->{{3.7938712594786835`*^9, 3.793871277323574*^9}, {
   3.793871311140438*^9, 3.793871324965104*^9}, 3.793871373309658*^9, 
   3.7938716410826645`*^9},
 CellLabel->
  "During evaluation of \
In[24]:=",ExpressionUUID->"6d5a2ded-aa71-4ffe-aff4-42942e3ad39f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"9", "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"-", 
    FractionBox["4", "5"]}], "\[InvisibleSpace]", "\<\"\\t\"\>", 
   "\[InvisibleSpace]", 
   "7.901865656995655199989816058233237055715227964865968615616984121207437437\
946929589140828475410074098360758694072914757755515824411783751888298729439840\
617`128."}],
  SequenceForm[9, "\t", 
   Rational[-4, 5], "\t", 
   7.9018656569956551999898160582332370557152279648659686156169841212074374379\
469295891408284754100740983607586940729147577555158244117837518882987294398406\
17`128.],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7938712594786835`*^9, 3.793871277323574*^9}, {
   3.793871311140438*^9, 3.793871324965104*^9}, 3.793871373309658*^9, 
   3.79387164126483*^9},
 CellLabel->
  "During evaluation of \
In[24]:=",ExpressionUUID->"bac5c409-1b25-4334-98ab-e32428af67d6"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2020", ",", "3", ",", "22", ",", "14", ",", "14", ",", 
   "1.2648302`7.854607213009304"}], "}"}]], "Print",
 CellChangeTimes->{{3.7938712594786835`*^9, 3.793871277323574*^9}, {
   3.793871311140438*^9, 3.793871324965104*^9}, 3.793871373309658*^9, 
   3.7938716412678328`*^9},
 CellLabel->
  "During evaluation of \
In[24]:=",ExpressionUUID->"66d8cffe-6250-4880-abad-9b3e86228eb4"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"10", "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"-", 
    FractionBox["9", "10"]}], "\[InvisibleSpace]", "\<\"\\t\"\>", 
   "\[InvisibleSpace]", 
   "12.56864756799700371412446545493255840926943874779137321247324579412234444\
171325763328540298436727099406067524093189515291702565982636543839211040759980\
61164`128."}],
  SequenceForm[10, "\t", 
   Rational[-9, 10], "\t", 
   12.568647567997003714124465454932558409269438747791373212473245794122344441\
713257633285402984367270994060675240931895152917025659826365438392110407599806\
1164`128.],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7938712594786835`*^9, 3.793871277323574*^9}, {
   3.793871311140438*^9, 3.793871324965104*^9}, 3.793871373309658*^9, 
   3.7938716414920363`*^9},
 CellLabel->
  "During evaluation of \
In[24]:=",ExpressionUUID->"410b1c65-4008-4566-ade8-4c0103f37eea"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2020", ",", "3", ",", "22", ",", "14", ",", "14", ",", 
   "1.4910355`7.926062970107127"}], "}"}]], "Print",
 CellChangeTimes->{{3.7938712594786835`*^9, 3.793871277323574*^9}, {
   3.793871311140438*^9, 3.793871324965104*^9}, 3.793871373309658*^9, 
   3.793871641495039*^9},
 CellLabel->
  "During evaluation of \
In[24]:=",ExpressionUUID->"3024389c-2371-4aaa-a18a-38ccf0c58279"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"11", "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"-", 
    FractionBox["91", "100"]}], "\[InvisibleSpace]", "\<\"\\t\"\>", 
   "\[InvisibleSpace]", 
   "13.64921945549032804843724918021450938739980346356475366737985382126679191\
773266684409745288153021552259862382094499446669308030346298563280117431777415\
53031`128."}],
  SequenceForm[11, "\t", 
   Rational[-91, 100], "\t", 
   13.649219455490328048437249180214509387399803463564753667379853821266791917\
732666844097452881530215522598623820944994466693080303462985632801174317774155\
3031`128.],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7938712594786835`*^9, 3.793871277323574*^9}, {
   3.793871311140438*^9, 3.793871324965104*^9}, 3.793871373309658*^9, 
   3.793871641760891*^9},
 CellLabel->
  "During evaluation of \
In[24]:=",ExpressionUUID->"acafb5c5-fec7-47b8-9047-e57a55e4137e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2020", ",", "3", ",", "22", ",", "14", ",", "14", ",", 
   "1.7598902`7.998060559347915"}], "}"}]], "Print",
 CellChangeTimes->{{3.7938712594786835`*^9, 3.793871277323574*^9}, {
   3.793871311140438*^9, 3.793871324965104*^9}, 3.793871373309658*^9, 
   3.793871641763894*^9},
 CellLabel->
  "During evaluation of \
In[24]:=",ExpressionUUID->"fd86a530-f0c7-4c6c-a63e-1c91c0358030"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"12", "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"-", 
    FractionBox["23", "25"]}], "\[InvisibleSpace]", "\<\"\\t\"\>", 
   "\[InvisibleSpace]", 
   "15.00803204377614960586698130708177870740161681436924150346613099278484777\
046506535837341331131183856822363811911766161991523098699747758720672376353075\
24864`128."}],
  SequenceForm[12, "\t", 
   Rational[-23, 25], "\t", 
   15.008032043776149605866981307081778707401616814369241503466130992784847770\
465065358373413311311838568223638119117661619915230986997477587206723763530752\
4864`128.],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7938712594786835`*^9, 3.793871277323574*^9}, {
   3.793871311140438*^9, 3.793871324965104*^9}, 3.793871373309658*^9, 
   3.7938716420191255`*^9},
 CellLabel->
  "During evaluation of \
In[24]:=",ExpressionUUID->"abb8d80e-99a7-4a79-aae8-d1b24311335b"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2020", ",", "3", ",", "22", ",", "14", ",", "14", ",", 
   "2.0181244`8.0575229169479"}], "}"}]], "Print",
 CellChangeTimes->{{3.7938712594786835`*^9, 3.793871277323574*^9}, {
   3.793871311140438*^9, 3.793871324965104*^9}, 3.793871373309658*^9, 
   3.793871642021127*^9},
 CellLabel->
  "During evaluation of \
In[24]:=",ExpressionUUID->"e18d820e-f37e-49be-b265-19c6655aa39d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"13", "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"-", 
    FractionBox["93", "100"]}], "\[InvisibleSpace]", "\<\"\\t\"\>", 
   "\[InvisibleSpace]", 
   "16.76411922338285546156287440143183163721258201284633606671994360848974453\
080717404192513857100544522352614636594155129819909256143503120229191097064786\
79437`128."}],
  SequenceForm[13, "\t", 
   Rational[-93, 100], "\t", 
   16.764119223382855461562874401431831637212582012846336066719943608489744530\
807174041925138571005445223526146365941551298199092561435031202291910970647867\
9437`128.],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7938712594786835`*^9, 3.793871277323574*^9}, {
   3.793871311140438*^9, 3.793871324965104*^9}, 3.793871373309658*^9, 
   3.7938716423068914`*^9},
 CellLabel->
  "During evaluation of \
In[24]:=",ExpressionUUID->"cb8a5735-8959-4c14-b465-7a4feda3a2da"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2020", ",", "3", ",", "22", ",", "14", ",", "14", ",", 
   "2.3068912`8.115602096061327"}], "}"}]], "Print",
 CellChangeTimes->{{3.7938712594786835`*^9, 3.793871277323574*^9}, {
   3.793871311140438*^9, 3.793871324965104*^9}, 3.793871373309658*^9, 
   3.7938716423098936`*^9},
 CellLabel->
  "During evaluation of \
In[24]:=",ExpressionUUID->"8c0fcc22-8c8d-47ae-b049-348e9ce0362a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"14", "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"-", 
    FractionBox["47", "50"]}], "\[InvisibleSpace]", "\<\"\\t\"\>", 
   "\[InvisibleSpace]", 
   "19.11587651679632661903074909977836816752741639931753090953001987217584688\
981108252269195476721934958484716412194042990689116301670300101771199249273338\
46359`128."}],
  SequenceForm[14, "\t", 
   Rational[-47, 50], "\t", 
   19.115876516796326619030749099778368167527416399317530909530019872175846889\
811082522691954767219349584847164121940429906891163016703001017711992492733384\
6359`128.],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7938712594786835`*^9, 3.793871277323574*^9}, {
   3.793871311140438*^9, 3.793871324965104*^9}, 3.793871373309658*^9, 
   3.7938716426251802`*^9},
 CellLabel->
  "During evaluation of \
In[24]:=",ExpressionUUID->"7a79501e-7d5c-4f7f-a2b6-c8b68cbd089c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2020", ",", "3", ",", "22", ",", "14", ",", "14", ",", 
   "2.6071634`8.168743234472196"}], "}"}]], "Print",
 CellChangeTimes->{{3.7938712594786835`*^9, 3.793871277323574*^9}, {
   3.793871311140438*^9, 3.793871324965104*^9}, 3.793871373309658*^9, 
   3.7938716426281824`*^9},
 CellLabel->
  "During evaluation of \
In[24]:=",ExpressionUUID->"7027ac69-adee-4173-a638-16321420486d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"15", "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"-", 
    FractionBox["19", "20"]}], "\[InvisibleSpace]", "\<\"\\t\"\>", 
   "\[InvisibleSpace]", 
   "22.42042255178086547485070076840881192739695968983165720779567493471105713\
920778332185362107999273162112781694315405188727551794552830630564799001496837\
52108`128."}],
  SequenceForm[15, "\t", 
   Rational[-19, 20], "\t", 
   22.420422551780865474850700768408811927396959689831657207795674934711057139\
207783321853621079992731621127816943154051887275517945528306305647990014968375\
2108`128.],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7938712594786835`*^9, 3.793871277323574*^9}, {
   3.793871311140438*^9, 3.793871324965104*^9}, 3.793871373309658*^9, 
   3.793871642914442*^9},
 CellLabel->
  "During evaluation of \
In[24]:=",ExpressionUUID->"4cf716b5-02b3-479d-aa3e-20ab3258858b"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2020", ",", "3", ",", "22", ",", "14", ",", "14", ",", 
   "2.9134413`8.216981256056272"}], "}"}]], "Print",
 CellChangeTimes->{{3.7938712594786835`*^9, 3.793871277323574*^9}, {
   3.793871311140438*^9, 3.793871324965104*^9}, 3.793871373309658*^9, 
   3.7938716429164443`*^9},
 CellLabel->
  "During evaluation of \
In[24]:=",ExpressionUUID->"f3392c07-b200-4156-b2b1-666519c9a813"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"16", "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"-", 
    FractionBox["24", "25"]}], "\[InvisibleSpace]", "\<\"\\t\"\>", 
   "\[InvisibleSpace]", 
   "27.39200274930077143429368155226998397951052524011450668291613847353800248\
278840870820594300088728131336669014595731409548439335535231459625370980389685\
15625`128."}],
  SequenceForm[16, "\t", 
   Rational[-24, 25], "\t", 
   27.392002749300771434293681552269983979510525240114506682916138473538002482\
788408708205943000887281313366690145957314095484393355352314596253709803896851\
5625`128.],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7938712594786835`*^9, 3.793871277323574*^9}, {
   3.793871311140438*^9, 3.793871324965104*^9}, 3.793871373309658*^9, 
   3.793871643273768*^9},
 CellLabel->
  "During evaluation of \
In[24]:=",ExpressionUUID->"9f92c537-272f-4669-8621-57148c498a01"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2020", ",", "3", ",", "22", ",", "14", ",", "14", ",", 
   "3.2727673`8.267490108216732"}], "}"}]], "Print",
 CellChangeTimes->{{3.7938712594786835`*^9, 3.793871277323574*^9}, {
   3.793871311140438*^9, 3.793871324965104*^9}, 3.793871373309658*^9, 
   3.793871643275773*^9},
 CellLabel->
  "During evaluation of \
In[24]:=",ExpressionUUID->"a88be061-19cb-46ac-965a-71618186b264"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"17", "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"-", 
    FractionBox["97", "100"]}], "\[InvisibleSpace]", "\<\"\\t\"\>", 
   "\[InvisibleSpace]", 
   "35.69720039329999279844911298566459357024333318365804211321015292200412743\
491299763040389956323458965259416421390423188448080602852329940667723737305727\
4714`128."}],
  SequenceForm[17, "\t", 
   Rational[-97, 100], "\t", 
   35.697200393299992798449112985664593570243333183658042113210152922004127434\
912997630403899563234589652594164213904231884480806028523299406677237373057274\
714`128.],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7938712594786835`*^9, 3.793871277323574*^9}, {
   3.793871311140438*^9, 3.793871324965104*^9}, 3.793871373309658*^9, 
   3.793871643736188*^9},
 CellLabel->
  "During evaluation of \
In[24]:=",ExpressionUUID->"6b5e976b-96b8-43a7-be55-52daa31660be"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2020", ",", "3", ",", "22", ",", "14", ",", "14", ",", 
   "3.735187`8.324887330377814"}], "}"}]], "Print",
 CellChangeTimes->{{3.7938712594786835`*^9, 3.793871277323574*^9}, {
   3.793871311140438*^9, 3.793871324965104*^9}, 3.793871373309658*^9, 
   3.7938716437381897`*^9},
 CellLabel->
  "During evaluation of \
In[24]:=",ExpressionUUID->"8cb9a8a6-497e-44ff-bbd5-0ba6504a527e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"18", "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"-", 
    FractionBox["49", "50"]}], "\[InvisibleSpace]", "\<\"\\t\"\>", 
   "\[InvisibleSpace]", 
   "52.33578091863208462969570538612427216040330224014544168131885025730144429\
925420294513231401338772368781827979697407664858864245295136929483042084258602\
52033`128."}],
  SequenceForm[18, "\t", 
   Rational[-49, 50], "\t", 
   52.335780918632084629695705386124272160403302240145441681318850257301444299\
254202945132314013387723687818279796974076648588642452951369294830420842586025\
2033`128.],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7938712594786835`*^9, 3.793871277323574*^9}, {
   3.793871311140438*^9, 3.793871324965104*^9}, 3.793871373309658*^9, 
   3.7938716444298277`*^9},
 CellLabel->
  "During evaluation of \
In[24]:=",ExpressionUUID->"34067601-d7f0-4c7a-b132-89ee0583cbda"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2020", ",", "3", ",", "22", ",", "14", ",", "14", ",", 
   "4.4288263`8.398863625698555"}], "}"}]], "Print",
 CellChangeTimes->{{3.7938712594786835`*^9, 3.793871277323574*^9}, {
   3.793871311140438*^9, 3.793871324965104*^9}, 3.793871373309658*^9, 
   3.793871644430828*^9},
 CellLabel->
  "During evaluation of \
In[24]:=",ExpressionUUID->"8d37f930-ca67-4d1c-87bb-9b0251b7015e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"19", "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"-", 
    FractionBox["99", "100"]}], "\[InvisibleSpace]", "\<\"\\t\"\>", 
   "\[InvisibleSpace]", 
   "102.3066019437804789650805255309532894085779390208598502974449466181962255\
763204187105760143746662845088512182798865373185756509890104392543321455112567\
628158`128."}],
  SequenceForm[19, "\t", 
   Rational[-99, 100], "\t", 
   102.30660194378047896508052553095328940857793902085985029744494661819622557\
632041871057601437466628450885121827988653731857565098901043925433214551125676\
28158`128.],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7938712594786835`*^9, 3.793871277323574*^9}, {
   3.793871311140438*^9, 3.793871324965104*^9}, 3.793871373309658*^9, 
   3.793871646251515*^9},
 CellLabel->
  "During evaluation of \
In[24]:=",ExpressionUUID->"ee04cfbe-ed13-4369-b836-e193fae1d84c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2020", ",", "3", ",", "22", ",", "14", ",", "14", ",", 
   "6.2505138`8.548490691152184"}], "}"}]], "Print",
 CellChangeTimes->{{3.7938712594786835`*^9, 3.793871277323574*^9}, {
   3.793871311140438*^9, 3.793871324965104*^9}, 3.793871373309658*^9, 
   3.793871646253516*^9},
 CellLabel->
  "During evaluation of \
In[24]:=",ExpressionUUID->"616cdf59-876f-4f07-8506-f8ff747e155a"]
}, Open  ]],

Cell[BoxData["$Aborted"], "Output",
 CellChangeTimes->{{3.7938713049833117`*^9, 3.7938713154033318`*^9}, 
   3.7938713536781454`*^9, 3.7938715782961483`*^9, 3.793871660447879*^9},
 CellLabel->"Out[24]=",ExpressionUUID->"bd8dcf0a-cdda-4521-b649-3a2e9cd5d068"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tbl1", "=", 
  RowBox[{"N", "[", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       SuperscriptBox["2", 
        RowBox[{"-", "k"}]], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox["2", "k"]}], ")"}], " ", 
       RowBox[{"Gamma", "[", 
        RowBox[{"1", "+", "k"}], "]"}], " ", 
       RowBox[{"Zeta", "[", 
        RowBox[{"1", "+", "k"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", "kVALS"}], "}"}]}], "]"}], ",", "64"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.552882173871283*^9, 3.552882207394146*^9}, {
   3.5528870101137114`*^9, 3.552887010360982*^9}, {3.55288748905231*^9, 
   3.552887502612685*^9}, {3.552887627481963*^9, 3.552887629505406*^9}, {
   3.552887675356023*^9, 3.5528876756435747`*^9}, 3.552896727638626*^9, 
   3.5528973848151827`*^9, 3.552899052829918*^9, {3.5930924696410847`*^9, 
   3.593092472560092*^9}, {3.5930927017415743`*^9, 3.593092728873786*^9}, {
   3.5930928849572678`*^9, 3.593092887442399*^9}, {3.593093743848627*^9, 
   3.593093745437517*^9}, {3.593094213963828*^9, 3.5930942161452293`*^9}, {
   3.593094250681963*^9, 3.5930942575220737`*^9}, {3.7938716024888597`*^9, 
   3.7938716118319063`*^9}},
 CellLabel->"In[22]:=",ExpressionUUID->"8a63c01d-8726-42e0-beae-7010ee6857d1"],

Cell[BoxData[
 TemplateBox[{
  "Infinity","indet",
   "\"Indeterminate expression \\!\\(\\*RowBox[{\\\"0\\\", \\\" \\\", \
\\\"ComplexInfinity\\\"}]\\) encountered.\"",2,22,3,24770923576276005209,
   "Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{{3.593094252371209*^9, 3.593094258105052*^9}, 
   3.593778979013671*^9, 3.593858203444645*^9, 3.5938591802853403`*^9, 
   3.593860467580514*^9, 3.7938703987711697`*^9, 3.7938716121221695`*^9},
 CellLabel->
  "During evaluation of \
In[22]:=",ExpressionUUID->"656fe578-2351-4569-a23a-11f3fce0a4d9"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "23.330874490725823342455723445283268781284320688793038269419335252835580770\
19331`64.", ",", 
   "1.803085354739391428099607242267174986147479438510748322688407333012757308\
67975`64.", ",", 
   "0.822467033424113218236207583323012594609474950603399218867779114685003735\
20157`64.", ",", 
   "0.678093895153101007312308851916590455650452254894785713652747046870786390\
75648`64.", ",", "Indeterminate", ",", 
   "1.072154929940191339530897446575632665786377507637416078164503193387383679\
18442`64.", ",", 
   "1.298142419651069567959215841236357216412640093941768635604142030090481349\
21829`64.", ",", 
   "1.689942082069844217686714770602930900671201078330503565666824674432854165\
89055`64.", ",", 
   "2.497004078476951397980741569014232323613084668100192052427635645682365733\
59386`64.", ",", 
   "4.968622353012584681311135630641922951927995958824210671724293418800261386\
57316`64.", ",", 
   "5.521189921826484211173541527105669107259482772150263823325043501565555261\
46148`64.", ",", 
   "6.212615000264106719757001109317667812789443462761104095436771924285209753\
42319`64.", ",", 
   "7.102420248123802260268297125741419490002855686513881861199828703946504877\
57377`64.", ",", 
   "8.289810824818017391611680436050382019207377171943772474496387767056816751\
1401`64.", ",", 
   "9.953356927101239824295276322308958584397086426908057517889879027097414564\
31002`64.", ",", 
   "12.45020013620965502325106248545318882757654770445560577038149346889251599\
172589`64.", ",", 
   "16.61367246329377450420632015225785159915066798197658448886751780430325045\
763551`64.", ",", 
   "24.94377253758025291812015233827140817253031233419577803501199376802158078\
61341`64.", ",", 
   "49.94049893725401506813660842804194247203770866958669469004588715146000147\
283343`64.", ",", 
   "499.9375169868556689643081293763321470615725587202878944182177891508002755\
1978133`64.", ",", 
   "4999.937216886339042464251639049043273589221236358978525979738902773981302\
77450021`64.", ",", 
   "499999.9371838538768643182303373528136234527851331262237984545916363851728\
1335346922`64.", ",", 
   "4.503599627370495937183520193961039106109848969713978604528170590655189795\
75250652865861475198`64.*^15"}], "}"}]], "Output",
 CellChangeTimes->{
  3.5528822078753653`*^9, 3.552887010771278*^9, 3.552887103305414*^9, {
   3.552887486695191*^9, 3.552887524380199*^9}, 3.552887630755094*^9, 
   3.552887676464653*^9, 3.55289672807318*^9, 3.552897385259412*^9, 
   3.552899053448805*^9, {3.593092467095392*^9, 3.593092491191175*^9}, {
   3.593092732994644*^9, 3.593092748030727*^9}, 3.5930929326107397`*^9, 
   3.593092975404789*^9, 3.5930932978013067`*^9, 3.593093722562766*^9, 
   3.593093781969294*^9, 3.593094004615745*^9, 3.593094087673195*^9, 
   3.593094219446094*^9, {3.5930942523859177`*^9, 3.593094258108575*^9}, 
   3.593778979019422*^9, 3.593858203448512*^9, 3.593859180291099*^9, 
   3.593860467584978*^9, 3.793870398780178*^9, 3.793871612160204*^9},
 CellLabel->"Out[22]=",ExpressionUUID->"f41e0051-bacc-4794-b082-eba4d156995c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"4999.\
937216886339042464251639049043273589221236358978525979738902773981302806377991\
405257805986021478437297040296113910525408834161116416613`128.", "-", 
  "4999.9372168863390424642516390490432735892212363589785259797389027739813027\
7450021`64."}]], "Input",
 CellChangeTimes->{{3.793871622031229*^9, 3.793871622807934*^9}},
 CellLabel->"In[23]:=",ExpressionUUID->"ebc50c34-8244-4871-a973-a468bb18a996"],

Cell[BoxData["0``60.301035448970175"], "Output",
 CellChangeTimes->{3.793871623341425*^9},
 CellLabel->"Out[23]=",ExpressionUUID->"d83c6dc9-a292-4d68-9315-363e38f3beb8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SetDirectory", "[", 
  "\"\</home/misiek/programy/biblioteki/libfermidirac/src\>\"", 
  "]"}]], "Input",
 CellLabel->"In[5]:=",ExpressionUUID->"72541105-6df6-4cfe-ade6-4493ac94e0b5"],

Cell[BoxData[
 TemplateBox[{
  "SetDirectory","cdir",
   "\"Cannot set current directory to \
\\!\\(\\*RowBox[{\\\"\\\\\\\"/home/misiek/programy/biblioteki/libfermidirac/\
src\\\\\\\"\\\"}]\\).\"",2,5,1,24764620408447177139,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.792908867667202*^9},
 CellLabel->
  "During evaluation of \
In[5]:=",ExpressionUUID->"5657ce79-3f0b-49e1-abf9-529e1816825d"],

Cell[BoxData["$Failed"], "Output",
 CellChangeTimes->{3.593092767236103*^9, 3.5930933023993473`*^9, 
  3.5930934358118343`*^9, 3.593093498887043*^9, 3.593093714499998*^9, 
  3.5930942687569027`*^9, 3.593672671255269*^9, 3.593778945451544*^9, 
  3.593778984365348*^9, 3.593858216154364*^9, 3.593858386302589*^9, 
  3.5938588595600224`*^9, 3.5938591813680487`*^9, 3.593860467675538*^9, 
  3.593862010989457*^9, 3.593863804578824*^9, 3.59386409189326*^9, 
  3.7929088677232533`*^9},
 CellLabel->"Out[5]=",ExpressionUUID->"671c8ac0-3e6f-41a8-8e40-c0184946fff9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SetDirectory", "[", 
  "\"\<H:\\\\misiek/programy/biblioteki/libfermidirac/src\>\"", 
  "]"}]], "Input",
 CellChangeTimes->{{3.7929088801741505`*^9, 3.79290888134122*^9}},
 CellLabel->"In[6]:=",ExpressionUUID->"985a4a7a-86c1-4f19-ba65-0e4635972671"],

Cell[BoxData["\<\"H:\\\\misiek\\\\programy\\\\biblioteki\\\\libfermidirac\\\\\
src\"\>"], "Output",
 CellChangeTimes->{3.7929088817345777`*^9},
 CellLabel->"Out[6]=",ExpressionUUID->"5086969b-ee24-4d3a-b837-826fabf767c7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Install", "[", "\"\<Fermi-Dirac\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.593672672962447*^9, 3.593672675347184*^9}},
 CellLabel->"In[7]:=",ExpressionUUID->"f2907183-3242-4438-8aac-fc04ba62045f"],

Cell[BoxData[
 TemplateBox[{
  "LinkOpen","linke",
   "\"\\!\\(\\*RowBox[{\\\"\\\\\\\"Could not find MathLink executable\\\\\\\"\
\\\"}]\\).\"",2,7,2,24764620408447177139,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.7929089326209335`*^9},
 CellLabel->
  "During evaluation of \
In[7]:=",ExpressionUUID->"adb399f4-3abd-4cfb-b184-863361477f47"],

Cell[BoxData["$Failed"], "Output",
 CellChangeTimes->{3.5930933037593317`*^9, 3.593093436508786*^9, 
  3.593093499568448*^9, 3.5930937152247963`*^9, 3.593094270089672*^9, 
  3.5936726771306887`*^9, 3.593778946507679*^9, 3.5937789908663282`*^9, 
  3.593858217121119*^9, 3.593858387069579*^9, 3.5938588606107273`*^9, 
  3.593859182561203*^9, 3.593860467770485*^9, 3.593862011328821*^9, 
  3.593863805414226*^9, 3.593864093075678*^9, 3.792908932632945*^9},
 CellLabel->"Out[7]=",ExpressionUUID->"63e60132-e8f3-4e57-991d-1ae2bc0b0b06"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "FFermi"}]], "Input",
 CellChangeTimes->{{3.5930930186090393`*^9, 3.593093019783134*^9}, {
  3.593672680524067*^9, 
  3.593672681116177*^9}},ExpressionUUID->"3a777453-49d5-4b01-811c-\
8e9f695530a7"],

Cell[CellGroupData[{

Cell["Global`FFermi", "Print", "PrintUsage",
 CellChangeTimes->{3.593860468071239*^9},
 CellTags->
  "Info3593864067-1021897",ExpressionUUID->"4afd9680-0e77-480e-80c0-\
38c9571109e3"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {GridBox[{
       {
        RowBox[{
         RowBox[{"FFermi", "[", 
          RowBox[{
           RowBox[{"k_", "?", "NumericQ"}], ",", 
           RowBox[{"eta_", "?", "NumericQ"}], ",", 
           RowBox[{"theta_", "?", "NumericQ"}]}], "]"}], ":=", 
         RowBox[{"ExternalCall", "[", 
          RowBox[{
           RowBox[{"LinkObject", "[", 
            
            RowBox[{"\<\"'/home/misiek/programy/biblioteki/libfermidirac/src/\
Fermi-Dirac'\"\>", ",", "155", ",", "4"}], "]"}], ",", 
           RowBox[{"CallPacket", "[", 
            RowBox[{"0", ",", 
             RowBox[{"{", 
              RowBox[{"k", ",", "eta", ",", "theta"}], "}"}]}], "]"}]}], 
          "]"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`FFermi],
  Editable->False]], "Print",
 CellChangeTimes->{3.59386046814098*^9},
 CellTags->
  "Info3593864067-1021897",ExpressionUUID->"2d333413-3f7c-44c5-b18c-\
916598c00369"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"FFermi", "[", 
    RowBox[{"k", ",", "0.0", ",", "0.0"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", 
     RowBox[{"N", "@", "kVALS"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.593672685783389*^9, 3.593672694642851*^9}, {
  3.593778997575214*^9, 3.593779013329163*^9}, {3.593779111709199*^9, 
  3.593779112126525*^9}},ExpressionUUID->"4945da89-0e2d-4d20-ba06-\
b09365d0a206"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "4.503599627370497`*^15", ",", "499999.9371694761`", ",", 
   "4999.93721688689`", ",", "499.93751698685526`", ",", "49.94049893725398`",
    ",", "24.94377253758023`", ",", "16.613672463293753`", ",", 
   "12.450200136209613`", ",", "9.953356927101229`", ",", 
   "8.289810824818009`", ",", "7.102420248123806`", ",", "6.212615000264108`",
    ",", "5.521189921826487`", ",", "4.968622353012584`", ",", 
   "2.4970040784769516`", ",", "1.689942082069844`", ",", 
   "1.2981424196510694`", ",", "1.0721549299401913`", ",", 
   "0.6931471805599452`", ",", "0.678093895153101`", ",", 
   "0.8224670334241133`", ",", "1.8030853547393915`", ",", 
   "23.330874490725822`"}], "}"}]], "Output",
 CellChangeTimes->{3.593779391827114*^9, 
  3.593860468543857*^9},ExpressionUUID->"b15d58d0-1c4b-4eb1-b3eb-\
5f9d73fa4586"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"1", "/", "2"}], "/", 
     RowBox[{"(", 
      RowBox[{"k", "+", "1"}], ")"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", "kVALS"}], "}"}]}], "]"}], "//", "N"}]], "Input",
 CellChangeTimes->{{3.59377939321801*^9, 
  3.593779408531246*^9}},ExpressionUUID->"f07e6867-81fe-4142-9423-\
2797e41ce6ae"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "4.503599627370496`*^15", ",", "500000.`", ",", "5000.`", ",", "500.`", ",",
    "50.`", ",", "25.`", ",", "16.666666666666668`", ",", "12.5`", ",", 
   "10.`", ",", "8.333333333333334`", ",", "7.142857142857143`", ",", "6.25`",
    ",", "5.555555555555555`", ",", "5.`", ",", "2.5`", ",", 
   "1.6666666666666667`", ",", "1.25`", ",", "1.`", ",", "0.5`", ",", 
   "0.3333333333333333`", ",", "0.25`", ",", "0.16666666666666666`", ",", 
   "0.1`"}], "}"}]], "Output",
 CellChangeTimes->{{3.5937794036474648`*^9, 3.5937794089582453`*^9}, 
   3.59386046862574*^9},ExpressionUUID->"9d10fa09-ee43-4a69-bc78-\
952eae0e6ba2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FFermi", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "1.0"}], "+", "$MachineEpsilon"}], ",", "0.0", ",", "0.0"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.59377907356205*^9, 3.593779090140959*^9}, {
  3.593779470777199*^9, 
  3.593779484659049*^9}},ExpressionUUID->"055ce74b-d546-4627-b3c1-\
820a3a0f62a0"],

Cell[BoxData["2.2517998136852475`*^15"], "Output",
 CellChangeTimes->{{3.593779082114703*^9, 3.5937790905628242`*^9}, {
   3.593779475393372*^9, 3.593779486539481*^9}, 3.593779519765526*^9, 
   3.593860468639518*^9},ExpressionUUID->"6161f2a8-6dfc-4a2d-a32f-\
a59791dca0d6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    SuperscriptBox["2", 
     RowBox[{"-", "k"}]], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      SuperscriptBox["2", "k"]}], ")"}], " ", 
    RowBox[{"Gamma", "[", 
     RowBox[{"1", "+", "k"}], "]"}], " ", 
    RowBox[{"Zeta", "[", 
     RowBox[{"1", "+", "k"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", 
     RowBox[{"-", "1"}], ",", "2"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.59377934181148*^9, 
  3.593779346769435*^9}},ExpressionUUID->"049acda9-5af6-4a2d-b37f-\
1da7fe98784a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox["1", 
    RowBox[{"2", " ", 
     RowBox[{"(", 
      RowBox[{"k", "+", "1"}], ")"}]}]], "+", 
   RowBox[{
    FractionBox["1", "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "EulerGamma"}], "-", 
      RowBox[{"2", " ", 
       RowBox[{"Log", "[", "2", "]"}]}], "+", 
      RowBox[{"Log", "[", 
       RowBox[{"2", " ", "\[Pi]"}], "]"}]}], ")"}]}], "+", 
   RowBox[{
    FractionBox["1", "16"], " ", 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["\[Pi]", "2"], "+", 
      RowBox[{"16", " ", "EulerGamma", " ", 
       RowBox[{"Log", "[", "2", "]"}]}], "+", 
      RowBox[{"12", " ", 
       SuperscriptBox[
        RowBox[{"Log", "[", "2", "]"}], "2"]}], "+", 
      RowBox[{"8", " ", 
       RowBox[{"Log", "[", "2", "]"}], " ", 
       RowBox[{"Log", "[", "\[Pi]", "]"}]}], "+", 
      RowBox[{"4", " ", 
       SuperscriptBox[
        RowBox[{"Log", "[", "\[Pi]", "]"}], "2"]}], "-", 
      RowBox[{"8", " ", "EulerGamma", " ", 
       RowBox[{"Log", "[", 
        RowBox[{"2", " ", "\[Pi]"}], "]"}]}], "-", 
      RowBox[{"16", " ", 
       RowBox[{"Log", "[", "2", "]"}], " ", 
       RowBox[{"Log", "[", 
        RowBox[{"2", " ", "\[Pi]"}], "]"}]}], "-", 
      RowBox[{"8", " ", 
       RowBox[{"StieltjesGamma", "[", "1", "]"}]}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{"k", "+", "1"}], ")"}]}], "+", 
   RowBox[{
    FractionBox["1", "48"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "3"}], " ", "EulerGamma", " ", 
       SuperscriptBox["\[Pi]", "2"]}], "-", 
      RowBox[{"6", " ", 
       SuperscriptBox["\[Pi]", "2"], " ", 
       RowBox[{"Log", "[", "2", "]"}]}], "-", 
      RowBox[{"36", " ", "EulerGamma", " ", 
       SuperscriptBox[
        RowBox[{"Log", "[", "2", "]"}], "2"]}], "-", 
      RowBox[{"32", " ", 
       SuperscriptBox[
        RowBox[{"Log", "[", "2", "]"}], "3"]}], "-", 
      RowBox[{"24", " ", "EulerGamma", " ", 
       RowBox[{"Log", "[", "2", "]"}], " ", 
       RowBox[{"Log", "[", "\[Pi]", "]"}]}], "-", 
      RowBox[{"48", " ", 
       SuperscriptBox[
        RowBox[{"Log", "[", "2", "]"}], "2"], " ", 
       RowBox[{"Log", "[", "\[Pi]", "]"}]}], "-", 
      RowBox[{"12", " ", "EulerGamma", " ", 
       SuperscriptBox[
        RowBox[{"Log", "[", "\[Pi]", "]"}], "2"]}], "-", 
      RowBox[{"24", " ", 
       RowBox[{"Log", "[", "2", "]"}], " ", 
       SuperscriptBox[
        RowBox[{"Log", "[", "\[Pi]", "]"}], "2"]}], "+", 
      RowBox[{"3", " ", 
       SuperscriptBox["\[Pi]", "2"], " ", 
       RowBox[{"Log", "[", 
        RowBox[{"2", " ", "\[Pi]"}], "]"}]}], "+", 
      RowBox[{"48", " ", "EulerGamma", " ", 
       RowBox[{"Log", "[", "2", "]"}], " ", 
       RowBox[{"Log", "[", 
        RowBox[{"2", " ", "\[Pi]"}], "]"}]}], "+", 
      RowBox[{"24", " ", 
       SuperscriptBox[
        RowBox[{"Log", "[", "2", "]"}], "2"], " ", 
       RowBox[{"Log", "[", 
        RowBox[{"2", " ", "\[Pi]"}], "]"}]}], "+", 
      RowBox[{"4", " ", 
       SuperscriptBox[
        RowBox[{"Log", "[", 
         RowBox[{"2", " ", "\[Pi]"}], "]"}], "3"]}], "+", 
      RowBox[{"4", " ", 
       RowBox[{"PolyGamma", "[", 
        RowBox[{"2", ",", "1"}], "]"}]}], "+", 
      RowBox[{"48", " ", 
       RowBox[{"Log", "[", "2", "]"}], " ", 
       RowBox[{"StieltjesGamma", "[", "1", "]"}]}], "-", 
      RowBox[{"24", " ", 
       RowBox[{"Log", "[", 
        RowBox[{"2", " ", "\[Pi]"}], "]"}], " ", 
       RowBox[{"StieltjesGamma", "[", "1", "]"}]}], "-", 
      RowBox[{"12", " ", 
       RowBox[{"StieltjesGamma", "[", "2", "]"}]}], "+", 
      RowBox[{"8", " ", 
       RowBox[{"Zeta", "[", "3", "]"}]}]}], ")"}], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"k", "+", "1"}], ")"}], "2"]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", 
      RowBox[{"k", "+", "1"}], "]"}], "3"],
    SeriesData[$CellContext`k, -1, {}, -1, 3, 1],
    Editable->False]}],
  SeriesData[$CellContext`k, -1, {
    Rational[1, 2], Rational[1, 2] (-EulerGamma - 2 Log[2] + Log[2 Pi]), 
    Rational[1, 16] (Pi^2 + (16 EulerGamma) Log[2] + 
     12 Log[2]^2 + (8 Log[2]) Log[Pi] + 4 Log[Pi]^2 - (8 EulerGamma) 
     Log[2 Pi] - (16 Log[2]) Log[2 Pi] - 8 StieltjesGamma[1]), 
    Rational[1, 48] (((-3) EulerGamma) Pi^2 - (6 Pi^2) 
     Log[2] - (36 EulerGamma) Log[2]^2 - 32 
     Log[2]^3 - ((24 EulerGamma) Log[2]) Log[Pi] - (48 Log[2]^2) 
     Log[Pi] - (12 EulerGamma) Log[Pi]^2 - (24 Log[2]) 
     Log[Pi]^2 + (3 Pi^2) Log[2 Pi] + ((48 EulerGamma) Log[2]) 
      Log[2 Pi] + (24 Log[2]^2) Log[2 Pi] + 4 Log[2 Pi]^3 + 
     4 PolyGamma[2, 1] + (48 Log[2]) StieltjesGamma[1] - (24 Log[2 Pi]) 
     StieltjesGamma[1] - 12 StieltjesGamma[2] + 8 Zeta[3])}, -1, 3, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.593779347354808*^9, 
  3.593860469035049*^9},ExpressionUUID->"b66a04ce-da2a-4b8e-91d1-\
b259fd93870a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"X", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"RandomReal", "[", "30", "]"}], ",", 
    RowBox[{"RandomReal", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "2000"}], ",", "2000"}], "}"}], "]"}], ",", 
    RowBox[{"RandomReal", "[", "10", "]"}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.5937798927323236`*^9, 3.59377989806278*^9}, {
  3.5937799968819036`*^9, 3.593780024390725*^9}, {3.593780074976879*^9, 
  3.5937800980718412`*^9}},ExpressionUUID->"6e33f99b-5504-4fb9-9ef5-\
38e905f64dec"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.039155854638178056`", ",", 
   RowBox[{"-", "1443.6161536323743`"}], ",", "1.9049944110633987`"}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.5937798936298656`*^9, 3.593779898578376*^9}, {
   3.593779973631255*^9, 3.593780044669155*^9}, 3.5937800987916803`*^9, {
   3.593780139510913*^9, 3.593780149647566*^9}, 3.593858257152362*^9, 
   3.593859189330824*^9, 
   3.5938604690487137`*^9},ExpressionUUID->"373a5397-fa00-49fe-a640-\
4f776c464afc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FFermi", "@@", "X"}]], "Input",
 CellChangeTimes->{{3.593859205646677*^9, 
  3.593859211707369*^9}},ExpressionUUID->"27927b49-8306-4ada-b3ad-\
ae0f8f2f8b77"],

Cell[BoxData["0.`"], "Output",
 CellChangeTimes->{3.593859212165316*^9, 
  3.593860469127225*^9},ExpressionUUID->"9d136198-dc05-4a77-ae40-\
c6d8e7d8b092"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fFermi", "@@", "X"}]], "Input",
 CellChangeTimes->{{3.5938592154600058`*^9, 
  3.5938592183071823`*^9}},ExpressionUUID->"1cd7eac1-0211-4be9-9d63-\
898acd230a16"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"NIntegrate", "::", "precw"}], "MessageName"], ":", 
  " ", "\<\"The precision of the argument function \
(\[NoBreak]\\!\\(\\(\\@\\(1 + \\(\\(0.9524972055316994`\\\\ x\\)\\)\\)\\\\ \
x\\^0.039155854638178056`\\)\\/\\(1 + \
\[ExponentialE]\\^\\(\\(\\(1443.6161536323743` \[VeryThinSpace]\\)\\) + \
x\\)\\)\\)\[NoBreak]) is less than WorkingPrecision (\[NoBreak]\\!\\(128.`\\)\
\[NoBreak]). \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/precw\\\", ButtonNote -> \
\\\"NIntegrate::precw\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.593859219619451*^9, 
  3.593860469238655*^9},ExpressionUUID->"4dd90489-bb68-4ea7-a42b-\
170845dc4ee8"],

Cell[BoxData["1.\
496487986214129387045397257059429142691733218881765080872951412991568312384407\
318099901241867905362177915374794225878067050706803023762745270710788887130777\
8657024`128.*^-627"], "Output",
 CellChangeTimes->{3.5938592198749847`*^9, 
  3.593860469643484*^9},ExpressionUUID->"1250fd0a-e045-420f-8340-\
1d699426db55"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"FFermi", "@@", "X"}], "/", 
    RowBox[{"fFermi", "@@", "X"}]}], "}"}], "-", "1"}]], "Input",
 CellChangeTimes->{{3.59377983805223*^9, 3.5937799359179087`*^9}, {
  3.593779987937104*^9, 3.593779988549861*^9}, {3.5937800328162622`*^9, 
  3.593780033590711*^9}, {3.593780106776025*^9, 3.593780134757531*^9}, {
  3.593858258994029*^9, 
  3.593858260242128*^9}},ExpressionUUID->"bec6cb0b-169a-4421-bed7-\
75bfe35e9f53"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"NIntegrate", "::", "precw"}], "MessageName"], ":", 
  " ", "\<\"The precision of the argument function \
(\[NoBreak]\\!\\(\\(\\@\\(1 + \\(\\(0.9524972055316994`\\\\ x\\)\\)\\)\\\\ \
x\\^0.039155854638178056`\\)\\/\\(1 + \
\[ExponentialE]\\^\\(\\(\\(1443.6161536323743` \[VeryThinSpace]\\)\\) + \
x\\)\\)\\)\[NoBreak]) is less than WorkingPrecision (\[NoBreak]\\!\\(128.`\\)\
\[NoBreak]). \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/precw\\\", ButtonNote -> \
\\\"NIntegrate::precw\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{{3.59377992064424*^9, 3.5937799364699*^9}, {
   3.5937799744878597`*^9, 3.593780045500058*^9}, {3.593780099784431*^9, 
   3.5937801509382343`*^9}, 3.5937802116568823`*^9, 3.593858261776091*^9, 
   3.59385919011038*^9, 
   3.5938604699234667`*^9},ExpressionUUID->"99e96cea-63d2-40e6-8d3a-\
6ae118f9e69b"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"-", "1.`"}], "}"}]], "Output",
 CellChangeTimes->{{3.593779859584332*^9, 3.593779936827601*^9}, {
   3.5937799748028517`*^9, 3.59378004650375*^9}, {3.593780100007927*^9, 
   3.5937801519751387`*^9}, 3.59378034489583*^9, 3.593858262105506*^9, 
   3.593859190392922*^9, 
   3.593860470298417*^9},ExpressionUUID->"5de88334-86b8-4074-a683-\
61dde939346a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"gFermi", "[", 
  RowBox[{"1.0", ",", "1.0", ",", "1.0"}], "]"}]], "Input",
 CellChangeTimes->{{3.593673251618593*^9, 3.593673257039867*^9}, {
  3.593858392333109*^9, 
  3.593858392713501*^9}},ExpressionUUID->"277be86e-0e08-4225-b98d-\
89d591791510"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"NIntegrate", "::", "precw"}], "MessageName"], ":", 
  " ", "\<\"The precision of the argument function \
(\[NoBreak]\\!\\(\\(x\\^3.`\\\\ \\@\\(\\(\\(-1.`\\)\\) + x\\^2\\)\\)\\/\\(1 + \
\[ExponentialE]\\^\\(\\(\\(-1.`\\)\\) + x\\)\\)\\)\[NoBreak]) is less than \
WorkingPrecision (\[NoBreak]\\!\\(128.`\\)\[NoBreak]). \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/precw\\\", \
ButtonNote -> \\\"NIntegrate::precw\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.5938589124312077`*^9, 3.5938592362816267`*^9, 
  3.593860470354493*^9},ExpressionUUID->"912736b4-7576-4a8c-8dd2-\
94230f877fe3"],

Cell[BoxData["58.67600157338548`"], "Output",
 CellChangeTimes->{
  3.593673257493986*^9, 3.5937789494046383`*^9, {3.5938583664423847`*^9, 
   3.593858393473641*^9}, 3.593858912730267*^9, 3.593859236554708*^9, 
   3.593860470631386*^9},ExpressionUUID->"3a555530-fd8f-42a1-b8eb-\
7eafebdc087b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "GFermi"}]], "Input",
 CellChangeTimes->{{3.5938588719625463`*^9, 
  3.593858873895569*^9}},ExpressionUUID->"62dd5168-6525-4a83-b6cd-\
e243ee307f92"],

Cell[CellGroupData[{

Cell["Global`GFermi", "Print", "PrintUsage",
 CellChangeTimes->{3.593860470861665*^9},
 CellTags->
  "Info3593864070-1805780",ExpressionUUID->"e695d451-00f9-447c-9bb3-\
7e9031f7d72c"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {GridBox[{
       {
        RowBox[{
         RowBox[{"GFermi", "[", 
          RowBox[{
           RowBox[{"n_", "?", "NumericQ"}], ",", 
           RowBox[{"alpha_", "?", "NumericQ"}], ",", 
           RowBox[{"beta_", "?", "NumericQ"}]}], "]"}], ":=", 
         RowBox[{"ExternalCall", "[", 
          RowBox[{
           RowBox[{"LinkObject", "[", 
            
            RowBox[{"\<\"'/home/misiek/programy/biblioteki/libfermidirac/src/\
Fermi-Dirac'\"\>", ",", "155", ",", "4"}], "]"}], ",", 
           RowBox[{"CallPacket", "[", 
            RowBox[{"1", ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", "alpha", ",", "beta"}], "}"}]}], "]"}]}], 
          "]"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`GFermi],
  Editable->False]], "Print",
 CellChangeTimes->{3.5938604709282627`*^9},
 CellTags->
  "Info3593864070-1805780",ExpressionUUID->"be4097ac-03cb-4115-adac-\
90643a1d1b73"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"GFermi", "[", 
  RowBox[{"1.0", ",", "1.0", ",", "1.0"}], "]"}]], "Input",
 CellChangeTimes->{{3.5938583959897757`*^9, 
  3.5938584025052958`*^9}},ExpressionUUID->"9fe1bfae-3d42-437f-89c9-\
9bb1dd18b6ee"],

Cell[BoxData["58.67600157338548`"], "Output",
 CellChangeTimes->{3.59385840304193*^9, 3.593858867863905*^9, 
  3.593858914149247*^9, 3.59385923975743*^9, 
  3.5938604713430967`*^9},ExpressionUUID->"7d478dcf-9acc-48a1-8591-\
bc0716f6d036"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "/", "%%"}]], "Input",
 CellChangeTimes->{{3.5938589155705137`*^9, 
  3.59385891602918*^9}},ExpressionUUID->"b4f713c4-2941-4400-9911-\
40db3a7c34ea"],

Cell[BoxData[
 RowBox[{"{", 
  FractionBox["58.67600157338548`", "Null"], "}"}]], "Output",
 CellChangeTimes->{3.593858916412595*^9, 3.5938592467690907`*^9, 
  3.5938604713521957`*^9},ExpressionUUID->"82d9dcf4-0679-4136-ab1d-\
ad799f35ba68"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "-", "1"}]], "Input",
 CellChangeTimes->{{3.5938592480812893`*^9, 
  3.593859249250988*^9}},ExpressionUUID->"7d32549e-fe40-465c-8528-\
f95642e818f0"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "1"}], "+", 
   FractionBox["58.67600157338548`", "Null"]}], "}"}]], "Output",
 CellChangeTimes->{3.5938592496355124`*^9, 
  3.593860471432568*^9},ExpressionUUID->"a932c29e-eb6e-4886-82c9-\
ce34758ae254"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"gPlus", "=", 
   RowBox[{"Function", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"n", ",", " ", "\[Alpha]", ",", "\[Beta]"}], "}"}], ",", 
     RowBox[{"gFermi", "[", 
      RowBox[{"n", ",", "\[Alpha]", ",", 
       RowBox[{"-", "\[Beta]"}]}], "]"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.552899271374229*^9, 3.552899302713357*^9}, {
   3.593858468835087*^9, 3.593858474654624*^9}, {3.593858507734881*^9, 
   3.593858509786696*^9}, 
   3.5938592581452227`*^9},ExpressionUUID->"437ac05e-327a-46f3-9a49-\
e4cd06f448c0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"gMinus", "=", 
   RowBox[{"Function", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"n", ",", " ", "\[Alpha]", ",", "\[Beta]"}], "}"}], ",", 
     RowBox[{"gFermi", "[", 
      RowBox[{"n", ",", "\[Alpha]", ",", "\[Beta]"}], "]"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.552899307585533*^9, 3.5528993101457577`*^9}, {
   3.5938584775231323`*^9, 3.593858514041747*^9}, 
   3.5938592621926537`*^9},ExpressionUUID->"589adab6-80b7-4904-a38d-\
4d04e6221266"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"gPlus", "[", 
  RowBox[{"1", ",", "1", ",", "1"}], "]"}]], "Input",
 CellChangeTimes->{{3.552899312066083*^9, 3.552899318414831*^9}, {
  3.593858524540118*^9, 
  3.593858526420575*^9}},ExpressionUUID->"fd723ac3-7ad8-4e35-9439-\
ddb25c4a9979"],

Cell[BoxData["8.\
354967490688371753460684443124888092823122050233644405675571484507022692613387\
5853400416916980184011433639053145467658459488234299440541130233025258436597`\
128."], "Output",
 CellChangeTimes->{3.55289931914088*^9, 3.5938584852507763`*^9, 
  3.5938585272022142`*^9, 3.593859266154127*^9, 
  3.593860471777976*^9},ExpressionUUID->"006acb43-9c53-4983-b99c-\
3676cf2d186f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"gMinus", "[", 
  RowBox[{"1", ",", "1", ",", "1"}], "]"}]], "Input",
 CellChangeTimes->{{3.552899323583685*^9, 3.552899324055355*^9}, {
  3.593858528268025*^9, 
  3.593858530396646*^9}},ExpressionUUID->"69acf5ee-b769-4f99-b07a-\
bc2fa95489d7"],

Cell[BoxData["58.\
676001573385478663496785571226902432064887893274314523865895386795270715573512\
1734708271648702641510850248299020192620063718360692389374788525591459448822`\
128."], "Output",
 CellChangeTimes->{3.552899324550251*^9, 3.593858486751391*^9, 
  3.593858530928976*^9, 3.593859271832069*^9, 
  3.5938604720271273`*^9},ExpressionUUID->"b0e601b8-33e1-4284-b7f8-\
4131e52ac1e2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FFermi", "[", 
  RowBox[{"0.5", ",", "0.5", ",", "2.0"}], "]"}]], "Input",
 CellChangeTimes->{{3.5938600504882812`*^9, 
  3.593860089271167*^9}},ExpressionUUID->"0e76c2fb-0610-4403-ac05-\
243160610439"],

Cell[BoxData["1.613304128015299`"], "Output",
 CellChangeTimes->{3.593860056968952*^9, 3.593860089822782*^9, 
  3.5938604721074123`*^9, 
  3.593862019872508*^9},ExpressionUUID->"63a5ebc5-c061-495b-9c9a-\
53ecec34fa1d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "FFermi"}]], "Input",
 CellChangeTimes->{{3.593860249351685*^9, 
  3.593860251547495*^9}},ExpressionUUID->"bb119df2-1b37-4e52-9f37-\
aa77fc776ff5"],

Cell[CellGroupData[{

Cell["Global`FFermi", "Print", "PrintUsage",
 CellChangeTimes->{3.593860472329154*^9},
 CellTags->
  "Info3593864072-1805780",ExpressionUUID->"3d719588-07ec-49c9-a6d6-\
087f8dfd0a71"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {GridBox[{
       {
        RowBox[{
         RowBox[{"FFermi", "[", 
          RowBox[{
           RowBox[{"k_", "?", "NumericQ"}], ",", 
           RowBox[{"eta_", "?", "NumericQ"}], ",", 
           RowBox[{"theta_", "?", "NumericQ"}]}], "]"}], ":=", 
         RowBox[{"ExternalCall", "[", 
          RowBox[{
           RowBox[{"LinkObject", "[", 
            
            RowBox[{"\<\"'/home/misiek/programy/biblioteki/libfermidirac/src/\
Fermi-Dirac'\"\>", ",", "155", ",", "4"}], "]"}], ",", 
           RowBox[{"CallPacket", "[", 
            RowBox[{"0", ",", 
             RowBox[{"{", 
              RowBox[{"k", ",", "eta", ",", "theta"}], "}"}]}], "]"}]}], 
          "]"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`FFermi],
  Editable->False]], "Print",
 CellChangeTimes->{3.5938604724023857`*^9},
 CellTags->
  "Info3593864072-1805780",ExpressionUUID->"38730339-e9c8-434c-8cd6-\
32e1f67a228d"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "NumberQ"}]], "Input",
 CellChangeTimes->{{3.593860270467986*^9, 
  3.593860273789103*^9}},ExpressionUUID->"a9a81bd2-15d0-4482-890f-\
8d2f40bee8ff"],

Cell[BoxData[
 RowBox[{
  StyleBox["\<\"\!\(\*RowBox[{\\\"NumberQ\\\", \\\"[\\\", StyleBox[\\\"expr\\\
\", \\\"TI\\\"], \\\"]\\\"}]\) gives True if \!\(\*StyleBox[\\\"expr\\\", \
\\\"TI\\\"]\) is a number, and False otherwise. \"\>", "MSG"], 
  "\[NonBreakingSpace]", 
  ButtonBox[
   StyleBox["\[RightSkeleton]", "SR"],
   Active->True,
   BaseStyle->"Link",
   ButtonData->"paclet:ref/NumberQ"]}]], "Print", "PrintUsage",
 CellChangeTimes->{3.593860472913011*^9},
 CellTags->
  "Info3593864072-1805780",ExpressionUUID->"9b73a979-0471-434e-98be-\
5394f0abc645"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Attributes", "[", "FFermi", "]"}]], "Input",
 CellChangeTimes->{{3.593860340753955*^9, 
  3.593860345420382*^9}},ExpressionUUID->"28c7d0d7-d71b-4f14-9d12-\
9a34ab5178f1"],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellChangeTimes->{{3.593860345917275*^9, 3.593860364280971*^9}, 
   3.5938604731534157`*^9},ExpressionUUID->"8baa8720-3e08-4427-a285-\
72f05c2ba0d7"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"SetAttributes", "[", 
  RowBox[{"FFermi", ",", "NumericFunction"}], "]"}]], "Input",
 CellChangeTimes->{{3.593860348302655*^9, 
  3.593860362324232*^9}},ExpressionUUID->"9d69f4b9-962b-49ab-8c86-\
9275ca1b63e9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NumericQ", "[", "Pi", "]"}]], "Input",
 CellChangeTimes->{{3.593860277104579*^9, 
  3.5938602906051483`*^9}},ExpressionUUID->"8a4e4381-d74f-424a-a9a3-\
b43801efd743"],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{{3.593860279743585*^9, 3.5938602910568027`*^9}, 
   3.5938604732879953`*^9},ExpressionUUID->"5127d39f-7a52-417d-b45e-\
fae8cbec0224"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FFermi", "[", 
  RowBox[{"Pi", ",", "0", ",", "2"}], "]"}]], "Input",
 CellChangeTimes->{{3.593860258169898*^9, 3.593860265484988*^9}, {
  3.5938605059270573`*^9, 
  3.593860514852579*^9}},ExpressionUUID->"50dadb38-8b85-46c4-9a9d-\
d6c0472ace6e"],

Cell[BoxData["15.382960307741612`"], "Output",
 CellChangeTimes->{
  3.593860265916314*^9, 3.593860367237118*^9, {3.593860473380315*^9, 
   3.593860515356241*^9}, 
   3.593862023998595*^9},ExpressionUUID->"2ccf419a-c82a-4b87-9210-\
96cfab85a3a2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fFermi", "[", 
  RowBox[{"Pi", ",", "0", ",", "2"}], "]"}]], "Input",
 CellChangeTimes->{{3.593862031891801*^9, 
  3.593862054854665*^9}},ExpressionUUID->"9b4c39fa-d37e-48bf-a7fa-\
b45958d6ee79"],

Cell[BoxData["15.\
382960307741615424292742337691474914068174467905868780227602999731687810622302\
3671549091161011857573333718877803890058227132159292246680384656381951794429`\
128."], "Output",
 CellChangeTimes->{
  3.593862055642338*^9},ExpressionUUID->"b6c095f0-6ac7-45c4-a0ff-\
24311a986e94"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"GFermi", "[", 
  RowBox[{"1", ",", "1", ",", "1"}], "]"}]], "Input",
 CellChangeTimes->{{3.593861780004229*^9, 
  3.5938617957381287`*^9}},ExpressionUUID->"b28e9727-0ef4-459a-b1af-\
75320c9d3e61"],

Cell[BoxData["58.67600157338548`"], "Output",
 CellChangeTimes->{{3.593861783817718*^9, 3.593861796044918*^9}, 
   3.593862025093536*^9},ExpressionUUID->"164d550e-b55c-41ec-bd96-\
6781b8fc0a16"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fFermi", "[", 
  RowBox[{
   RowBox[{"1", "/", "2"}], ",", 
   RowBox[{"1", "/", "2"}], ",", "2"}], "]"}]], "Input",
 CellChangeTimes->{{3.593860066425438*^9, 
  3.59386009715897*^9}},ExpressionUUID->"74ef6292-2c80-419d-9095-\
333a09cb2656"],

Cell[BoxData["1.\
613304128015298983535721430705053100187187839329680010643699181089421660333283\
3969311107189006814887810249818533370759354074065631048544708615674909753016`\
128."], "Output",
 CellChangeTimes->{{3.593860077378437*^9, 3.593860097692477*^9}, 
   3.593860473645681*^9},ExpressionUUID->"50118aad-5b7a-47db-8a5a-\
5e137c69c9b2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"gFermi", "[", 
  RowBox[{
   RowBox[{"1", "/", "2"}], ",", 
   RowBox[{"10", "^", "1"}], ",", "2"}], "]"}]], "Input",
 CellChangeTimes->{{3.593863966620186*^9, 3.5938639768499727`*^9}, 
   3.5938640784664783`*^9},ExpressionUUID->"43e6026a-ab8c-4c81-bd2b-\
adca57378598"],

Cell[BoxData["0.\
000018545935774538557966847373787251950734638440862245657151848079158123980220\
2065112145975045565930197909674818579975935163787604463416053039122719139159`\
128."], "Output",
 CellChangeTimes->{{3.593864075780588*^9, 
  3.593864079014756*^9}},ExpressionUUID->"3f0f2eaf-4350-4e1e-844a-\
1a2f83fa3dd0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"cmp", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"SetPrecision", "[", 
       RowBox[{
        RowBox[{"GFermi", "[", 
         RowBox[{
          RowBox[{"1", "/", "2"}], ",", 
          RowBox[{"10", "^", "lgeta"}], ",", "2"}], "]"}], ",", "128"}], 
       "]"}], ",", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"MachineNumberQ", "[", 
            RowBox[{"N", "[", "#", "]"}], "]"}], ",", "#", ",", "0."}], "]"}],
          "&"}], ")"}], "[", 
       RowBox[{"gFermi", "[", 
        RowBox[{
         RowBox[{"1", "/", "2"}], ",", 
         RowBox[{"10", "^", "lgeta"}], ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"lgeta", ",", 
      RowBox[{"-", "4"}], ",", "4", ",", 
      RowBox[{"1", "/", "2"}]}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.593859892210744*^9, 3.593860044656629*^9}, {
   3.593860101491764*^9, 3.5938601121684713`*^9}, {3.5938628231994534`*^9, 
   3.5938628648644238`*^9}, {3.59386290622234*^9, 3.5938629459115868`*^9}, {
   3.593862996833659*^9, 3.593863007928176*^9}, {3.593863101857452*^9, 
   3.593863195613985*^9}, {3.593863247528059*^9, 3.593863248462472*^9}, {
   3.593863542174835*^9, 3.593863546252*^9}, {3.593863757172183*^9, 
   3.593863758417829*^9}, {3.593863832734935*^9, 3.593863833855796*^9}, 
   3.5938639538312693`*^9, {3.593864099828682*^9, 3.593864121956493*^9}, {
   3.593864372787581*^9, 3.593864380483101*^9}, {3.5938644252911577`*^9, 
   3.593864443957192*^9}},ExpressionUUID->"5095fdb0-b8be-48e8-81d1-\
8cd37c352d32"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "3.42982832455528512`128.*^17", ",", 
     "3.4298283245552852095569481299883124961361463308229776600159638402015116\
464357325563096690369972523714729586340732830151383756456403259058492759481420\
3455`128.*^17"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "3.429828308742637`128.*^15", ",", 
     "3.4298283087426370964122748949023749229053173829998350442072923743399166\
251271852850893496356960113622846416847915729485485450901231741943310531474082\
5`128.*^15"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "3.429828150616078515625`128.*^13", ",", 
     "3.4298281506160790950689514011214732315207383699390426380114856301037038\
8010920731998823657093824401125095822804013979462056590249195235204425649102`\
128.*^13"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "3.4298265693439404296875`128.*^11", ",", 
     "3.4298265693439414975022257690935625964413708318126791586127296272456094\
875667213667339000481987642148470747005448422485494838771979293670363909084241\
25255620424024567`128.*^11"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "3.42981075607974910736083984375`128.*^9", ",", 
     "3.4298107560797488862912765580935968921950063483064820892079954260047788\
692852638307314975406351894918424707356296862824467605921515873657719226306203\
217720613254018`128.*^9"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "3.42965258045133054256439208984375`128.*^7", ",", 
     "3.4296525804513317429473030112565045751023245138718067807200941529936607\
651040489467189308304954671140057729233940755467608677248344979177202939629251\
9334326778358`128.*^7"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "342806.7655799280037172138690948486328125`128.", ",", 
     "342806.76557992805594890734133346296998465455940245912464460613922662440\
501633124474622962449143644042407341454069307978379711675658068600471862184554\
03728286775`128."}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "3412.0151314086442653206177055835723876953125`128.", ",", 
     "3412.0151314086439540279638536643978946216433300300497637461387967092897\
407188449421051070978804862574913027953887607874884278681456947371240735362497\
475209096`128."}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "32.42794951914263634762392030097544193267822265625`128.", ",", 
     "32.427949519142632348713944103363835798899740828817571764472356634590677\
923198399550021936479058784319922986558093500446435862581574398215890147262336\
9928972`128."}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.17620725952176619077960140202776528894901275634765625`128.", ",", 
     "0.1762072595217662581618039166548949438753337396081697556176550616639776\
309675315001924620142512387058259823002929777987183160630292113071432936559118\
838338`128."}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.0000185459357745385589326565789480838475355994887650012969970703125`\
128.", ",", 
     "0.0000185459357745385579668473737872519507346384408622456571518480791581\
239802202065112145975045565930197909674818579975935163787604463416053039122719\
139159`128."}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1.06974238926136475204068488314251605932716550090982865484079411544371396\
3031768798828125`128.*^-15", ",", 
     "1.0697423892613675728094294842110674751154623174429300497496937391484345\
572949627837443895293371851993965619605859165153297262486653741984009272483058\
0352909318`128.*^-15"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "3.56326922250010789602944021473216034189381679646752163924565795188596317\
812380319637959544818832450584736259761132548887219151367844460764899849892`\
128.*^-46", ",", 
     "3.5632692225001083168494643833425186401661474711525548331581071518593322\
2401558494072565155524534058019429122572881070961464532938704972943275755979`\
128.*^-46"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "7.67908239608315989854317812835711345515253309412795418462850952099632578\
87961547025696933555160812503324830285679216179608534400131476930935549088704`\
128.*^-141", ",", 
     "7.6790823960834114528975340345856911467401968478714350182995415867929876\
657184134174681806100300248434815475250660425887472112692969437510632601843025\
`128.*^-141"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0.`"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.5938641077486343`*^9, 3.593864126061068*^9}, 
   3.59386438475184*^9, {3.593864433125457*^9, 
   3.593864449212229*^9}},ExpressionUUID->"e3447110-6ddc-4ff7-9bdc-\
48885254b7c1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"#1", "/", "#2"}], "-", "1"}], "&"}], ")"}], "@@", 
      RowBox[{"cmp", "[", 
       RowBox[{"[", "k", "]"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "1", ",", 
       RowBox[{"Length", "[", "cmp", "]"}]}], "}"}]}], "]"}], "//", "Abs"}], "//",
   "Log10"}]], "Input",
 CellChangeTimes->{{3.593863236325177*^9, 3.5938633158405733`*^9}, {
  3.593864461602152*^9, 
  3.593864476030332*^9}},ExpressionUUID->"e2872171-140b-4a91-bbb7-\
4b4d9cdaea56"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Power", "::", "infy"}], "MessageName"], ":", 
  " ", "\<\"Infinite expression \[NoBreak]\\!\\(1\\/0.`\\)\[NoBreak] \
encountered. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/infy\\\", ButtonNote -> \
\\\"Power::infy\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.593864131859329*^9, 3.593864389577887*^9, {3.593864454008377*^9, 
   3.593864476438744*^9}},ExpressionUUID->"c62275f3-dea9-4d97-bfe5-\
f5c5123b0f7f"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Infinity", "::", "indet"}], "MessageName"], ":", 
  " ", "\<\"Indeterminate expression \[NoBreak]\\!\\(0\\\\ ComplexInfinity\\)\
\[NoBreak] encountered. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/indet\\\", ButtonNote -> \
\\\"Infinity::indet\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.593864131859329*^9, 3.593864389577887*^9, {3.593864454008377*^9, 
   3.593864476440915*^9}},ExpressionUUID->"3601625b-012c-4c79-8d39-\
a3d9e633a3d2"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Power", "::", "infy"}], "MessageName"], ":", 
  " ", "\<\"Infinite expression \[NoBreak]\\!\\(1\\/0.`\\)\[NoBreak] \
encountered. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/infy\\\", ButtonNote -> \
\\\"Power::infy\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.593864131859329*^9, 3.593864389577887*^9, {3.593864454008377*^9, 
   3.593864476464992*^9}},ExpressionUUID->"b8300ddb-c46a-4475-b231-\
b84cb365ad0a"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Infinity", "::", "indet"}], "MessageName"], ":", 
  " ", "\<\"Indeterminate expression \[NoBreak]\\!\\(0\\\\ ComplexInfinity\\)\
\[NoBreak] encountered. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/indet\\\", ButtonNote -> \
\\\"Infinity::indet\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.593864131859329*^9, 3.593864389577887*^9, {3.593864454008377*^9, 
   3.593864476490925*^9}},ExpressionUUID->"fbc737d8-a1cf-453b-a836-\
58cfd0783d59"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Power", "::", "infy"}], "MessageName"], ":", 
  " ", "\<\"Infinite expression \[NoBreak]\\!\\(1\\/0.`\\)\[NoBreak] \
encountered. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/infy\\\", ButtonNote -> \
\\\"Power::infy\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.593864131859329*^9, 3.593864389577887*^9, {3.593864454008377*^9, 
   3.593864476516983*^9}},ExpressionUUID->"f3742bf1-8482-47f1-8912-\
303fa73da074"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "stop"}], "MessageName"], ":", 
  " ", "\<\"Further output of \[NoBreak]\\!\\(\\*StyleBox[\\(Power :: \
infy\\), \\\"MessageName\\\"]\\)\[NoBreak] will be suppressed during this \
calculation. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/stop\\\", ButtonNote -> \
\\\"General::stop\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.593864131859329*^9, 3.593864389577887*^9, {3.593864454008377*^9, 
   3.593864476537835*^9}},ExpressionUUID->"f0947477-50ec-49ec-adc7-\
61ad540159cd"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Infinity", "::", "indet"}], "MessageName"], ":", 
  " ", "\<\"Indeterminate expression \[NoBreak]\\!\\(0\\\\ ComplexInfinity\\)\
\[NoBreak] encountered. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/indet\\\", ButtonNote -> \
\\\"Infinity::indet\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.593864131859329*^9, 3.593864389577887*^9, {3.593864454008377*^9, 
   3.593864476558289*^9}},ExpressionUUID->"5b77d89f-b335-43c7-8bb6-\
e3c675c9eb24"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "stop"}], "MessageName"], ":", 
  " ", "\<\"Further output of \[NoBreak]\\!\\(\\*StyleBox[\\(Infinity :: \
indet\\), \\\"MessageName\\\"]\\)\[NoBreak] will be suppressed during this \
calculation. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/stop\\\", ButtonNote -> \
\\\"General::stop\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.593864131859329*^9, 3.593864389577887*^9, {3.593864454008377*^9, 
   3.593864476580407*^9}},ExpressionUUID->"a29752e0-d007-44e4-976c-\
cffb78e4c81b"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
   "-", "16.583173097038137773515851176759016343617869642739922747948299130635\
120789769510862313159747580054631236249447774974926642638559654824933`112.\
697680229973"}], ",", 
   RowBox[{
   "-", "16.551140050184978870203747666221397453222242609241303635487266258509\
752090216627536831505973428962085205928112725303213550832367403118143`112.\
72887355639742"}], ",", 
   RowBox[{
   "-", "15.772260926749461111455794205889013974430059321457803478555145152024\
011849652869019395936412934474918135502282744537900036139722199840968`113.\
48681871945199"}], ",", 
   RowBox[{
   "-", "15.506776254580889924881646366841124922742857643888166045833610611097\
957950351363907767516238185151528067146843043552433985938847875817098`113.\
74493095900404"}], ",", 
   RowBox[{
   "-", "16.190741204673739650061109305829195901114220214621236251708443671439\
485826353956542186469674475871599773651410811283407940059994491182901`113.\
07971121937153"}], ",", 
   RowBox[{
   "-", "15.455930324753075768738554267346705419205555586092883809861257090188\
273356750638263486364096970848802371361071381162336510877769984677168`113.\
79435051956116"}], ",", 
   RowBox[{
   "-", "15.817115277606458736384257353251966458820152733869171379945832823432\
270018595297189391844472094140550895742193688749982606437781241724956`113.\
44319769526989"}], ",", 
   RowBox[{
   "-", "16.039842076530073191055223746280481191159264205440900585234895443671\
868343305886321908691806981681584687710371007967933964053939517055366`113.\
2265437045415"}], ",", 
   RowBox[{
   "-", "15.908977860906793084020686339117065906839640852722964217352814970301\
976146917368281636492208817613396922253022036628950511200747801955795`113.\
35385010959877"}], ",", 
   RowBox[{
   "-", "15.417478594228648567582419921661222810404394399227139701382409067528\
88858835515548088793843948065082077969840072518768751813752025169898`113.\
83172045292707"}], ",", 
   RowBox[{
   "-", "16.283357411107284243512929939865116760706996379901079796814541229708\
598638342403788988686457864110998371363964448797985793525265965371855`112.\
98957223744368"}], ",", 
   RowBox[{
   "-", "14.578911722554187486286285533634765635314592345886683209137060819123\
153844035628719106236917358978841926189548036934483090150710851065291`114.\
64599907673144"}], ",", 
   RowBox[{
   "-", "15.927752239702593921318770906579376797709184681960200074457268163719\
999537306635384745969088537286474319423683996396501825040164870429732`113.\
33558794484202"}], ",", 
   RowBox[{
   "-", "13.484677488289092123705594169301768363862600348284450725852624876666\
033734451747603302659291800325716030386914861213405224116822525909713`115.\
70634876868093"}], ",", "Indeterminate", ",", "Indeterminate", ",", 
   "Indeterminate"}], "}"}]], "Output",
 CellChangeTimes->{{3.5938632681737223`*^9, 3.5938632789794064`*^9}, 
   3.59386331642292*^9, {3.593864112052638*^9, 3.593864132075513*^9}, 
   3.593864389747615*^9, {3.5938644541698637`*^9, 
   3.593864476581911*^9}},ExpressionUUID->"704432d4-63b1-4592-86fb-\
fc8354a00e46"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.593864481956254*^9, 
  3.593864483565793*^9}},ExpressionUUID->"e74716d6-fc1c-44e3-8469-\
724ca6a126bb"],

Cell[BoxData[
 GraphicsBox[{{}, {{}, 
    {RGBColor[0.24720000000000014`, 0.24, 0.6], 
     PointBox[{{1., -16.583173097038138`}, {2., -16.55114005018498}, {
      3., -15.77226092674946}, {4., -15.50677625458089}, {
      5., -16.19074120467374}, {6., -15.455930324753076`}, {
      7., -15.817115277606458`}, {8., -16.039842076530075`}, {
      9., -15.908977860906793`}, {10., -15.41747859422865}, {
      11., -16.283357411107286`}, {12., -14.578911722554187`}, {
      13., -15.927752239702594`}, {14., -13.484677488289092`}}]}, {}}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, -16.6},
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  Method->{"ScalingFunctions" -> None},
  PlotRange->{{0, 14.}, {-16.583173097038138`, -13.484677488289092`}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.02]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.593864483910273*^9},ExpressionUUID->"d44e1b29-8c53-4c24-bc93-\
b1528624d754"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$MachineEpsilon"], "Input",
 CellChangeTimes->{{3.5938633515990963`*^9, 
  3.5938633570707827`*^9}},ExpressionUUID->"790b474e-8a24-4b2d-9822-\
e17507514134"],

Cell[BoxData["2.220446049250313`*^-16"], "Output",
 CellChangeTimes->{
  3.593863357644169*^9},ExpressionUUID->"5993025e-ecd0-42c8-b78d-\
47fb6c457f2b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "N"}]], "Input",
 CellChangeTimes->{{3.593862967627667*^9, 
  3.5938629679922256`*^9}},ExpressionUUID->"1ef2f62a-c8cd-45c3-9cf3-\
fc75499a7396"],

Cell[BoxData[
 RowBox[{
  StyleBox["\<\"\\!\\(\\*RowBox[{\\\"N\\\", \\\"[\\\", StyleBox[\\\"expr\\\", \
\\\"TI\\\"], \\\"]\\\"}]\\) gives the numerical value of \\!\\(\\*StyleBox[\\\
\"expr\\\", \\\"TI\\\"]\\). \\n\\!\\(\\*RowBox[{\\\"N\\\", \\\"[\\\", \
RowBox[{StyleBox[\\\"expr\\\", \\\"TI\\\"], \\\",\\\", StyleBox[\\\"n\\\", \\\
\"TI\\\"]}], \\\"]\\\"}]\\) attempts to give a result with \\!\\(\\*StyleBox[\
\\\"n\\\", \\\"TI\\\"]\\)\[Hyphen]digit precision. \"\>", "MSG"], 
  "\[NonBreakingSpace]", 
  ButtonBox[
   StyleBox["\[RightSkeleton]", "SR"],
   Active->True,
   BaseStyle->"Link",
   ButtonData->"paclet:ref/N"]}]], "Print", "PrintUsage",
 CellChangeTimes->{3.593862968608917*^9},
 CellTags->
  "Info3593866568-9659176",ExpressionUUID->"b34ea39b-b09b-4623-ade6-\
5d12dbddc73c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Block", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"k", "=", "4"}], ",", 
     RowBox[{"\[Theta]", "=", "1"}], ",", 
     RowBox[{"\[Eta]", "=", "10"}]}], "}"}], ",", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"x", "^", "k"}], " ", 
        RowBox[{
         RowBox[{"Sqrt", "[", 
          RowBox[{"1", "+", 
           RowBox[{"\[Theta]", " ", 
            RowBox[{"x", "/", "2"}]}]}], "]"}], "/", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           RowBox[{"Exp", "[", 
            RowBox[{"x", "-", "\[Eta]"}], "]"}]}], ")"}]}]}], ",", 
       RowBox[{"5000", "/", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{"Exp", "[", 
           RowBox[{"x", "-", "\[Eta]"}], "]"}]}], ")"}]}], ",", 
       RowBox[{
        RowBox[{"x", "^", "k"}], " ", 
        RowBox[{"Sqrt", "[", 
         RowBox[{"1", "+", 
          RowBox[{"\[Theta]", " ", 
           RowBox[{"x", "/", "2"}]}]}], "]"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", "29"}], "}"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "20000"}], "}"}]}]}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7929132348554125`*^9, 3.7929132814175854`*^9}, {
  3.7932508714850636`*^9, 3.793250875981211*^9}, {3.793508356336857*^9, 
  3.7935084569364*^9}},
 CellLabel->"In[27]:=",ExpressionUUID->"47db145e-a1db-420d-a0ff-63afc7814537"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
      1.], LineBox[CompressedData["
1:eJwVl3VYFl0Txmnp7oaH7m45AxKCgqBISYmCBUpIGEhICAKS0q2UCEpI89IP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       "]]},
     Annotation[#, "Charting`Private`Tag$5216#1"]& ], 
    TagBox[
     {RGBColor[0.880722, 0.611041, 0.142051], AbsoluteThickness[1.6], Opacity[
      1.], LineBox[CompressedData["
1:eJwV13c8ld8fAHA7hOy99x7Xta5xPgqhCCGkkjJSyo5sMrIyM0I0SGRd4mtV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       "]]},
     Annotation[#, "Charting`Private`Tag$5216#2"]& ], 
    TagBox[
     {RGBColor[0.560181, 0.691569, 0.194885], AbsoluteThickness[1.6], Opacity[
      1.], LineBox[CompressedData["
1:eJwVl2c8Fg4bhe2VvffjIWVVkiLkvrNnolJomRX6h8xEaCBSISuUGSplJytb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       "]]},
     Annotation[#, "Charting`Private`Tag$5216#3"]& ]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0., 28.999999408163266`}, {0, 20000}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.7929132628925514`*^9, 3.792913281966589*^9}, {
  3.7932508720585847`*^9, 3.7932508761523666`*^9}, {3.793508356651143*^9, 
  3.7935083689093466`*^9}, {3.793508400425749*^9, 3.793508457122569*^9}},
 CellLabel->"Out[27]=",ExpressionUUID->"6b982fde-d305-4c23-b34f-512958528758"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"x", "^", "k"}], " ", 
   RowBox[{
    RowBox[{"Sqrt", "[", 
     RowBox[{"1", "+", 
      RowBox[{"\[Theta]", " ", 
       RowBox[{"x", "/", "2"}]}]}], "]"}], "/", 
    RowBox[{"(", 
     RowBox[{"1", "+", 
      RowBox[{"Exp", "[", 
       RowBox[{"x", "-", "\[Eta]"}], "]"}]}], ")"}]}]}], "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"k", "\[Rule]", "4"}], ",", 
    RowBox[{"\[Theta]", "\[Rule]", "1"}], ",", 
    RowBox[{"\[Eta]", "\[Rule]", "1"}], ",", 
    RowBox[{"x", "\[Rule]", "1"}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.792913542270481*^9, 3.7929135522145815`*^9}},
 CellLabel->"In[17]:=",ExpressionUUID->"aaca4b9d-27e0-4f54-89c8-a9a66fd050db"],

Cell[BoxData[
 FractionBox[
  SqrtBox[
   FractionBox["3", "2"]], "2"]], "Output",
 CellChangeTimes->{3.792913552664496*^9},
 CellLabel->"Out[17]=",ExpressionUUID->"f0cf7898-6dcb-4e16-9d39-9072c882aac8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"N", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.7929135539196377`*^9, 3.7929135544781456`*^9}},
 CellLabel->"In[18]:=",ExpressionUUID->"a22720b2-bfaa-4a75-a163-d6055e7683ea"],

Cell[BoxData["0.6123724356957945`"], "Output",
 CellChangeTimes->{3.7929135547263713`*^9},
 CellLabel->"Out[18]=",ExpressionUUID->"c20db700-d673-4d3d-a54b-35da4552cf32"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Limit", "[", 
  RowBox[{
   RowBox[{"Exp", "[", 
    RowBox[{"t", "-", 
     RowBox[{"Exp", "[", 
      RowBox[{"-", "t"}], "]"}], "+", "\[Eta]"}], "]"}], ",", 
   RowBox[{"t", "\[Rule]", 
    RowBox[{"-", "Infinity"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7935197333813505`*^9, 3.793519743144261*^9}},
 CellLabel->
  "In[209]:=",ExpressionUUID->"b15a2a1e-df07-490a-a4d2-28aaefbad09d"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.793519739702119*^9, 3.7935197433314314`*^9}},
 CellLabel->
  "Out[209]=",ExpressionUUID->"8464be46-c90a-4062-85e0-c05ebec57a27"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{"\[Eta]", " ", 
      RowBox[{"Exp", "[", 
       RowBox[{"t", "-", 
        RowBox[{"Exp", "[", 
         RowBox[{"-", "t"}], "]"}]}], "]"}]}], ",", "t"}], "]"}], 
   RowBox[{"x", "^", "k"}], " ", 
   RowBox[{
    RowBox[{"Sqrt", "[", 
     RowBox[{"1", "+", 
      RowBox[{"\[Theta]", " ", 
       RowBox[{"x", "/", "2"}]}]}], "]"}], "/", 
    RowBox[{"(", 
     RowBox[{"1", "+", 
      RowBox[{"Exp", "[", 
       RowBox[{"x", "-", "\[Eta]"}], "]"}]}], ")"}]}]}], "/.", 
  RowBox[{"x", "\[Rule]", 
   RowBox[{"\[Eta]", " ", 
    RowBox[{"Exp", "[", 
     RowBox[{"t", "-", 
      RowBox[{"Exp", "[", 
       RowBox[{"-", "t"}], "]"}]}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.7929136098385553`*^9, 3.792913641405493*^9}, {
   3.793510999673483*^9, 3.793511000976172*^9}, {3.793511047169137*^9, 
   3.7935110473202744`*^9}, {3.7935111172089467`*^9, 3.79351113127136*^9}, {
   3.793511461278341*^9, 3.7935114962773266`*^9}, 3.7935158608095174`*^9, {
   3.793519137211707*^9, 3.793519138657525*^9}, {3.79351930200243*^9, 
   3.793519344640183*^9}, {3.793519637159616*^9, 3.7935196437591248`*^9}, {
   3.793519700712055*^9, 3.7935197034700727`*^9}, {3.7935197870712643`*^9, 
   3.7935198494851475`*^9}, {3.7935199159346833`*^9, 
   3.7935199842204227`*^9}, {3.7935202248520746`*^9, 
   3.7935202657468553`*^9}, {3.793520324979829*^9, 3.7935203428020267`*^9}, {
   3.79352037994788*^9, 3.793520445768858*^9}, {3.793520516186531*^9, 
   3.793520518328478*^9}},
 CellLabel->
  "In[256]:=",ExpressionUUID->"1100e39c-35cf-469f-a56b-3ed0682828d4"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{
     RowBox[{"-", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"-", "t"}]]}], "+", "t"}]], " ", 
   RowBox[{"(", 
    RowBox[{"1", "+", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"-", "t"}]]}], ")"}], " ", "\[Eta]", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "t"}]]}], "+", "t"}]], " ", "\[Eta]"}], ")"}], "k"], 
   " ", 
   SqrtBox[
    RowBox[{"1", "+", 
     RowBox[{
      FractionBox["1", "2"], " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "t"}]]}], "+", "t"}]], " ", "\[Eta]", " ", 
      "\[Theta]"}]}]]}], 
  RowBox[{"1", "+", 
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{
     RowBox[{"-", "\[Eta]"}], "+", 
     RowBox[{
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "t"}]]}], "+", "t"}]], " ", "\[Eta]"}]}]]}]]], "Output",\

 CellChangeTimes->{{3.7929136208881855`*^9, 3.792913664874028*^9}, 
   3.7929144821093407`*^9, 3.7929210642582464`*^9, 3.79292109829138*^9, 
   3.7929212024016376`*^9, 3.792921289568335*^9, 3.792921585198396*^9, 
   3.792921763646617*^9, 3.7935110037452273`*^9, 3.793511048045946*^9, 
   3.793511131727775*^9, 3.793511461897904*^9, 3.7935114967187357`*^9, 
   3.7935158617909126`*^9, 3.7935191405462933`*^9, 3.793519313038035*^9, 
   3.793519345132639*^9, 3.7935196444107237`*^9, 3.7935197038173885`*^9, {
   3.793519790139053*^9, 3.7935198177487173`*^9}, 3.7935198498735003`*^9, 
   3.793519952601101*^9, 3.7935199850882115`*^9, 3.793520235062874*^9, 
   3.793520266063143*^9, 3.7935203443644466`*^9, 3.793520384502019*^9, {
   3.793520420176024*^9, 3.7935204460541162`*^9}, 3.793520520160143*^9},
 CellLabel->
  "Out[256]=",ExpressionUUID->"c7fd795f-abaf-4453-b349-3ccb0b0b894b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{"\[Eta]", " ", 
      RowBox[{"Exp", "[", 
       RowBox[{"Sinh", "[", "t", "]"}], "]"}]}], ",", "t"}], "]"}], 
   RowBox[{"x", "^", "k"}], " ", 
   RowBox[{
    RowBox[{"Sqrt", "[", 
     RowBox[{"1", "+", 
      RowBox[{"\[Theta]", " ", 
       RowBox[{"x", "/", "2"}]}]}], "]"}], "/", 
    RowBox[{"(", 
     RowBox[{"1", "+", 
      RowBox[{"Exp", "[", 
       RowBox[{"x", "-", "\[Eta]"}], "]"}]}], ")"}]}]}], "/.", 
  RowBox[{"x", "\[Rule]", 
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{"\[Eta]", " ", 
      RowBox[{"Exp", "[", 
       RowBox[{"Sinh", "[", "t", "]"}], "]"}]}], ",", "t"}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.7935207649664164`*^9, 3.7935207778311605`*^9}, {
  3.793520833529501*^9, 3.7935208665581164`*^9}},
 CellLabel->
  "In[263]:=",ExpressionUUID->"896164b2-77ba-4de0-b8a6-b3adc0ade953"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{"Sinh", "[", "t", "]"}]], " ", "\[Eta]", " ", 
   RowBox[{"Cosh", "[", "t", "]"}], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"Sinh", "[", "t", "]"}]], " ", "\[Eta]", " ", 
      RowBox[{"Cosh", "[", "t", "]"}]}], ")"}], "k"], " ", 
   SqrtBox[
    RowBox[{"1", "+", 
     RowBox[{
      FractionBox["1", "2"], " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"Sinh", "[", "t", "]"}]], " ", "\[Eta]", " ", "\[Theta]", " ", 
      
      RowBox[{"Cosh", "[", "t", "]"}]}]}]]}], 
  RowBox[{"1", "+", 
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{
     RowBox[{"-", "\[Eta]"}], "+", 
     RowBox[{
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"Sinh", "[", "t", "]"}]], " ", "\[Eta]", " ", 
      RowBox[{"Cosh", "[", "t", "]"}]}]}]]}]]], "Output",
 CellChangeTimes->{
  3.7935207788901296`*^9, {3.793520838375415*^9, 3.7935208669184437`*^9}},
 CellLabel->
  "Out[263]=",ExpressionUUID->"8bc7b154-14a9-4404-a9e1-f33939cc1f76"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Block", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"k", "=", "3"}], ",", 
     RowBox[{"\[Theta]", "=", "1"}], ",", 
     RowBox[{"\[Eta]", "=", "1111"}]}], "}"}], ",", 
   RowBox[{"LogPlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       FractionBox[
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"-", "t"}]]}], "+", "t"}]], " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{"-", "t"}]]}], ")"}], " ", "\[Eta]", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["\[ExponentialE]", 
                RowBox[{"-", "t"}]]}], "+", "t"}]], " ", "\[Eta]"}], ")"}], 
          "k"], " ", 
         SqrtBox[
          RowBox[{"1", "+", 
           RowBox[{
            FractionBox["1", "2"], " ", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["\[ExponentialE]", 
                RowBox[{"-", "t"}]]}], "+", "t"}]], " ", "\[Eta]", " ", 
            "\[Theta]"}]}]]}], 
        RowBox[{"1", "+", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"-", "\[Eta]"}], "+", 
           RowBox[{
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["\[ExponentialE]", 
                RowBox[{"-", "t"}]]}], "+", "t"}]], " ", "\[Eta]"}]}]]}]], 
       ",", 
       FractionBox[
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{
             RowBox[{"-", 
              SuperscriptBox["\[ExponentialE]", 
               RowBox[{"-", "t"}]]}], "+", "t"}]], ")"}], 
          RowBox[{"1", "+", "k"}]], " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{"-", "t"}]]}], ")"}], " ", 
         SqrtBox[
          RowBox[{"1", "+", 
           RowBox[{
            FractionBox["1", "2"], " ", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["\[ExponentialE]", 
                RowBox[{"-", "t"}]]}], "+", "t"}]], " ", "\[Theta]"}]}]]}], 
        RowBox[{"1", "+", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{
             RowBox[{"-", 
              SuperscriptBox["\[ExponentialE]", 
               RowBox[{"-", "t"}]]}], "+", "t"}]], "-", "\[Eta]"}]]}]]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", 
       RowBox[{"-", "6.5"}], ",", "16.5"}], "}"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"2", "^", 
         RowBox[{"-", "27"}]}], ",", "All"}], "}"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Black", ",", "Red"}], "}"}]}]}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7932503016904597`*^9, 3.7932503502184105`*^9}, {
   3.793250633959779*^9, 3.793250657462777*^9}, {3.793250720799796*^9, 
   3.793250721039014*^9}, {3.7932507546482325`*^9, 3.7932508108556404`*^9}, {
   3.7935110105269446`*^9, 3.7935110934271507`*^9}, {3.793511139646038*^9, 
   3.79351117137761*^9}, {3.793511451177616*^9, 3.793511501633218*^9}, {
   3.7935116426399164`*^9, 3.793511727063395*^9}, {3.7935176556246634`*^9, 
   3.793517697824285*^9}, {3.793518105453561*^9, 3.7935181246036377`*^9}, {
   3.793518345259411*^9, 3.7935183539693737`*^9}, 3.793519149936989*^9, {
   3.793519325223819*^9, 3.793519349435061*^9}, {3.7935196559737716`*^9, 
   3.793519709934459*^9}, {3.793519752793059*^9, 3.7935198622557917`*^9}, {
   3.793519958099616*^9, 3.7935199704468594`*^9}, {3.793520240640971*^9, 
   3.793520284158145*^9}, {3.7935203496893015`*^9, 3.7935203942609034`*^9}, {
   3.793520426385172*^9, 3.793520532130068*^9}, 3.7935207841204004`*^9, {
   3.7935208427774296`*^9, 3.7935208712794275`*^9}, 3.7935209041779175`*^9, {
   3.793521053776187*^9, 3.7935210540624466`*^9}, {3.7936226061678*^9, 
   3.7936226438030214`*^9}, {3.7936229262747126`*^9, 3.7936229373327875`*^9}},
 
 CellLabel->"In[42]:=",ExpressionUUID->"06b016ba-39f5-424e-92de-32348b08e8f7"],

Cell[BoxData[
 TemplateBox[{
  "General","munfl",
   "\"\\!\\(\\*SuperscriptBox[\\\"3.0999705649056155`*^-289\\\", \
\\\"3\\\"]\\) is too small to represent as a normalized machine number; \
precision may be lost.\"",2,42,17,24769296578482765475,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{{3.793517659256979*^9, 3.793517698196126*^9}, {
   3.7935181058554306`*^9, 3.7935181249414487`*^9}, {3.7935183484458256`*^9, 
   3.79351835462597*^9}, 3.793519151502932*^9, {3.793519326519508*^9, 
   3.7935193496912937`*^9}, {3.793519647033122*^9, 3.7935197109974403`*^9}, {
   3.7935197533010244`*^9, 3.793519862576082*^9}, {3.793519959369771*^9, 
   3.7935199713536916`*^9}, {3.7935202422113986`*^9, 
   3.7935202843623304`*^9}, {3.793520350808318*^9, 3.7935203946792836`*^9}, {
   3.7935204267815323`*^9, 3.7935205323602767`*^9}, 3.793520785349525*^9, {
   3.793520843964012*^9, 3.7935208723944407`*^9}, 3.7935209044761877`*^9, 
   3.7935210549132204`*^9, {3.793622607592098*^9, 3.7936226441483345`*^9}, {
   3.7936229272586145`*^9, 3.7936229387790995`*^9}},
 CellLabel->
  "During evaluation of \
In[42]:=",ExpressionUUID->"96d7f48b-7e5c-4553-a79b-6a5216314d21"],

Cell[BoxData[
 TemplateBox[{
  "General","munfl",
   "\"\\!\\(\\*RowBox[{\\\"Exp\\\", \\\"[\\\", RowBox[{\\\"-\\\", \
\\\"1111.`\\\"}], \\\"]\\\"}]\\) is too small to represent as a normalized \
machine number; precision may be lost.\"",2,42,18,24769296578482765475,
   "Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{{3.793517659256979*^9, 3.793517698196126*^9}, {
   3.7935181058554306`*^9, 3.7935181249414487`*^9}, {3.7935183484458256`*^9, 
   3.79351835462597*^9}, 3.793519151502932*^9, {3.793519326519508*^9, 
   3.7935193496912937`*^9}, {3.793519647033122*^9, 3.7935197109974403`*^9}, {
   3.7935197533010244`*^9, 3.793519862576082*^9}, {3.793519959369771*^9, 
   3.7935199713536916`*^9}, {3.7935202422113986`*^9, 
   3.7935202843623304`*^9}, {3.793520350808318*^9, 3.7935203946792836`*^9}, {
   3.7935204267815323`*^9, 3.7935205323602767`*^9}, 3.793520785349525*^9, {
   3.793520843964012*^9, 3.7935208723944407`*^9}, 3.7935209044761877`*^9, 
   3.7935210549132204`*^9, {3.793622607592098*^9, 3.7936226441483345`*^9}, {
   3.7936229272586145`*^9, 3.793622938823139*^9}},
 CellLabel->
  "During evaluation of \
In[42]:=",ExpressionUUID->"3ca0c269-bf6b-480a-9296-7006acc89648"],

Cell[BoxData[
 TemplateBox[{
  "General","munfl",
   "\"\\!\\(\\*SuperscriptBox[\\\"7.217790691459255`*^-181\\\", \\\"3\\\"]\\) \
is too small to represent as a normalized machine number; precision may be \
lost.\"",2,42,19,24769296578482765475,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{{3.793517659256979*^9, 3.793517698196126*^9}, {
   3.7935181058554306`*^9, 3.7935181249414487`*^9}, {3.7935183484458256`*^9, 
   3.79351835462597*^9}, 3.793519151502932*^9, {3.793519326519508*^9, 
   3.7935193496912937`*^9}, {3.793519647033122*^9, 3.7935197109974403`*^9}, {
   3.7935197533010244`*^9, 3.793519862576082*^9}, {3.793519959369771*^9, 
   3.7935199713536916`*^9}, {3.7935202422113986`*^9, 
   3.7935202843623304`*^9}, {3.793520350808318*^9, 3.7935203946792836`*^9}, {
   3.7935204267815323`*^9, 3.7935205323602767`*^9}, 3.793520785349525*^9, {
   3.793520843964012*^9, 3.7935208723944407`*^9}, 3.7935209044761877`*^9, 
   3.7935210549132204`*^9, {3.793622607592098*^9, 3.7936226441483345`*^9}, {
   3.7936229272586145`*^9, 3.793622938845159*^9}},
 CellLabel->
  "During evaluation of \
In[42]:=",ExpressionUUID->"7c2e224c-5bc9-42e9-96eb-206f40c21b19"],

Cell[BoxData[
 TemplateBox[{
  "General","stop",
   "\"Further output of \\!\\(\\*StyleBox[RowBox[{\\\"General\\\", \
\\\"::\\\", \\\"munfl\\\"}], \\\"MessageName\\\"]\\) will be suppressed \
during this calculation.\"",2,42,20,24769296578482765475,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{{3.793517659256979*^9, 3.793517698196126*^9}, {
   3.7935181058554306`*^9, 3.7935181249414487`*^9}, {3.7935183484458256`*^9, 
   3.79351835462597*^9}, 3.793519151502932*^9, {3.793519326519508*^9, 
   3.7935193496912937`*^9}, {3.793519647033122*^9, 3.7935197109974403`*^9}, {
   3.7935197533010244`*^9, 3.793519862576082*^9}, {3.793519959369771*^9, 
   3.7935199713536916`*^9}, {3.7935202422113986`*^9, 
   3.7935202843623304`*^9}, {3.793520350808318*^9, 3.7935203946792836`*^9}, {
   3.7935204267815323`*^9, 3.7935205323602767`*^9}, 3.793520785349525*^9, {
   3.793520843964012*^9, 3.7935208723944407`*^9}, 3.7935209044761877`*^9, 
   3.7935210549132204`*^9, {3.793622607592098*^9, 3.7936226441483345`*^9}, {
   3.7936229272586145`*^9, 3.7936229388851957`*^9}},
 CellLabel->
  "During evaluation of \
In[42]:=",ExpressionUUID->"b6450351-79c8-4392-a117-913da9cc2f6d"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwBcQWO+iFib1JlAgAAAFYAAAACAAAAisrdkoVoAsDiICOHCLcywAMYGDpX
UgLAdCc+T4E6MsDM2o+BuEICwFBEkwuX5zHAlJ0HyRkzAsBn9s9LQZUxwCQj
91fcEwLAHIdrn07yMMBELtZ1YdUBwGgxrbRXZi/AhkSUsWtYAcC1+S1k3p0q
wApxECmAXgDAAnB2U4XNIcDSM4hw4U4AwPN8sKlqSCHAmvb/t0I/AMDETr1g
McQgwCt870YFIADA8tOFgrR8H8CXDp3JFMP/v8z0FRa6eRvAGjsZQSnJ/r+M
uQfxg8ETwCCUETBS1fy/rWR13fmo9b9Y8p8kKLj8v5BiAec2evK/kVAuGf6a
/L+cbatbjZ/uvwINSwKqYPy/YG2JTV4P4r/lhYTUAez7vwfSUCHetMo/qnf3
eLEC+78wtKag2VT7PzVb3cEQMPm/4ZjPQ/MkEkBuuWu25hL5v0PgW8ef0hJA
phf6qrz1+L9IwoeFd38TQBjUFpRou/i/n868iazWFED6TFBmwEb4v+lTYztF
exdAwD7DCnBd97/tHDQt2Z0cQEoiqVPPivW/g4tVfWcmI0DKIRcoOG71v20j
RC8rbyNASiGF/KBR9b9uZhSVkrcjQEkgYaVyGPW/vJf1qE1HJEBIHhn3Fab0
v+KLMHB9YiVARhqJmlzB87/wcy64C4gnQEISaeHp9/G/xf0yX2aSK0DCEde1
Utvxv4ZX+rVJ0CtAQhFFiru+8b8Nhudr3A0sQEEQITONhfG/qyRvpxGILEBA
DtmEMBPxv8rPUVbHeC1APgpJKHcu8L8+nHp5wEsvQHIEUt4Iyuy/LxTHQXxd
MUB7aPAv/ovsvw86RKUKejFAhMyOgfNN7L9v17bEcZYxQJaUyyTe0eu/m+N1
TsvOMUC5JEVrs9nqv13DDCGzPTJAAEU4+F3p6L94yKaEkRQzQI+FHhKzCOW/
/A4JjleoNECY6bxjqMrkv+hJy0l/wDRAoE1btZ2M5L+sww7qh9g0QLIVmFiI
EOS/uNWAxjwINUDWpRGfXRjjv0a9iV87ZjVAHsYELAgo4b/HZtljvhw2QFkN
1ou6jtq//sOcNlt1N0AMOI7F8hravyXOknKqiDdAvmJG/yqn2b/PXT555Js3
QCS4tnKbv9i/U4RdgxnCN0DwYpdZfPDWv/2O78SLDThAhrhYJz5S07+zUlz6
saA4QGfHtoWDK8i/aZZzLgC5OUCQL/owuBmjPz4+3ym6uDtAYokS17sFpz+u
SSIkDck7QDTjKn2/8ao/Vaa0k1DZO0Bsy61k42SxP3oKsVKp+TtAEX/esOo8
uT8lyKLBpTk8QC3zn6R8dsQ/xEj7JeW2PEA7rYCeRRPSP0X5qgJIpz1AdrhD
E8aQ0j+HgDgp47U9QLDDBohGDtM/ib6fU3LEPUAk2oxxRwnUPwokdBdt4T1A
DgeZREn/1T+t+IsI1xo+QOBgsepM69k/yWeYWpGLPkAabHRfzWjaP01d/gB4
mT5AVHc31E3m2j9FjAwjVKc+QMmNvb1O4ds/GbGtMe3CPkCyusmQUNfdPyeI
G9Sk+T5A7MWMBdFU3j/tNRq0OQc/QCbRT3pR0t4/IBZeusQUP0Cb59VjUs3f
P01Bzou9Lz9AQgpxG6rh4D+nGtN3PGU/QFFNE5ZEH+E/u/2IqEZyP0BgkLUQ
31zhP5W/u/RHfz9Ab9NXi3ma4T9YSqpuQIw/QH4W+gUU2OE/XOBBJzCZP0CN
WZyArhXiPzHrFydDnj9AnJw++0hT4j/kTpCU3Qw2QKvf4HXjkOI/20O61364
IUC6IoPwfc7iP4UsXsWrzBHAyWUlaxgM4z+wKnI+lOExwODHzqHiD+M/4iAj
hwi3MsCNJaA0
       "]]},
     Annotation[#, "Charting`Private`Tag$3590#1"]& ], 
    TagBox[
     {RGBColor[1, 0, 0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJw1lGk41HscxacZNEo0RDP/mYZhbFmbIu4s/y9FKUq0qSRSKkpUIzc3lUaL
Gt0WWbJ1K1JpLi22/H6VyqVFhFCWaGOeMiQiue6L++I858U5z/m8O7ygcJ9N
VAqF4jeu/7zypGmogckAemdkcoR+V4A9jAIvRzIHUPdYSX1HngAv5LIG9a98
Q/LaHyN7ZwqwO3Esdd39fvQgys7eQjALu+pu7fg8qEKM/hFGwQNb/IDReNun
RYWEbxxJMsEWuzLcjpeWq1A19WwXc7ktdpnKm31SpkIv1oRvvPnBBoN202F7
PRWyuvtzyE/HBksmeVhE2faiGG33atsdVjhSzaeVXqVE1C+pRt7rLfC+Lb12
vxKU6LXD4ZRIKwt8+Kn8YL+XEm3zX+z5ZsgcJ52t5re+7EHPJztw4s6a42K+
W2hhUze6t9K8SvuFGaa4OQ35f/6ENi/81n3J2xQnyri6hfT3qFKlLJ9zyBgn
fy7bmFvVhSKjwjSdVxnjLK+1t9NPdCH1OzF+u62NcYF+8uqjU7sQ/edFF3kj
DzdcZmT6MzuR4hPucrXnYe5jNWu6RQfKXxl/NLPBEPtNaUgokTejaN5Bo4WT
2FjLSf6oj2hGCuQMwY8IXB7kPjYzpwl5cFvVqg4QmF90JzINvUZ9gTTHnUMs
3Bt03i+mtwE96Qw4OL2HieOLVptLfOqQVGTiv+qtAQ55ckcWZ1WJ5kbv3fxT
pYtP2Q3bF7H+IuP7ovSvxk3EQcd0G0vVc8jj2GFGzZSJeE7nzD+QKo90nzaw
NiBZA4dV3wjuDP6bPCczfFeQr44Zsa2KblExGe+i7qDfTsM2/ZmXYqQV5M3e
rpkaKyhYeONAhpteLbniRUpEO60fuU6KYOd1tJPJ7VszZJRmcsJHShCf30s+
667Jqn2sCS+5Z5ak+gySg+fmRa0MM4Bdt18bp3HGyIjozGKZrhHQGLcWdNjT
wK3W3lcSzodb0vqI33gTwTjJK5KjZQlxhdSsuWOTwP/XoeuJB21gUctyojJV
G0L3zQjwrbEHsR+o6bgygOs28J2qORuWlWzJjtPXA9s9a65pEQ7wTeM8VLVN
g+9yhtdpw7mw2Kogpb/GALiC0hxHb2fgPmpL/pDFBE3eZsuva4TQZVvx9X4u
E/pVtacrNwohLznXPV3BhDakNZgdJgTHsIhvvpgJsROmKpbvF8JSPZr3/TYm
pCZsf1+cLYQDgWYTL3BZUJhH3xz3SQjvRsP2LLvAgqVV08Z0pSLIDVn21PoS
CxgFO1/17BfBjpcOJvTrLPheVnq54ogIhi/9qikvZcENTVIkTRGBnucpa+sW
FkwurnduKhPB/NTCTg2CgKlpPX9k0MRwxXF4Wdl5Akr46uvM/hQDUfShNzKT
gIcMnZD6FDEkOtclWuYQcHcJPfzwRTHsFV1/lnSHAJpL+553hWLwcF3vEVFP
wIBnZUBGgxiUXg/ATI8Ns7ghV/U5EtjwIr/tDcEGqgUjvoIvgXrvtP1njNnw
JJ+2YZeNBMp9d5dRBGyQaTdOfimRQKKfmVOLNxsSPj6edyJQAoJNx+1Oycf7
cktnao4ErnyQPndPYoO4rkipuCkB9paN20fT2SBIb0sPKJKAWqjo2rYbbCgX
a/wo+2ect/OLmdtTNgjN556JUkpgUV/zo5E6NtR4UueYDYzzdz0JLmhhw3yt
Y7WvRsf3pVkXDXvYUI2a6QIdEoihEy4NfeO5T35W+3QSEqOj208Ms6GT7umY
aESC2sim2HlUDkw7JM0WW5KwN8aHO6zJAXW70rpwOxKUo5J7CgYHUKa/91Kp
EDbEWq0LYXHg02jubF/92fCKwhyZweNAdDDTUEtkCh6H1FJfWXBg2KYizrSA
AuU0lVOCPQd+f+ilcKETWCB72+jixIGkuswiwUpb3JSzYEOgkAP//++//cGJ
OQ==
       "]]},
     Annotation[#, "Charting`Private`Tag$3590#2"]& ]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, -18.714973875118524`},
  CoordinatesToolOptions:>{"DisplayFunction" -> ({
      Part[#, 1], 
      Exp[
       Part[#, 2]]}& ), "CopiedValueFunction" -> ({
      Part[#, 1], 
      Exp[
       Part[#, 2]]}& )},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Quiet[
      Charting`ScaledTicks[{Log, Exp}][#, #2, {6, 6}]]& , 
     Charting`ScaledFrameTicks[{Log, Exp}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  ImageSize->{723.9999999999985, Automatic},
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None},
  PlotRange->
   NCache[{{-5.243492777279149, 
     7.526168359578866}, {-Log[134217728], All}}, {{-5.243492777279149, 
     7.526168359578866}, {-18.714973875118524`, All}}],
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {0, 
     Scaled[0.05]}},
  Ticks->FrontEndValueCache[{Automatic, Quiet[
      Charting`ScaledTicks[{Log, Exp}][#, #2, {6, 6}]]& }, {
    Automatic, {{-18.420680743952367`, 
       FormBox[
        TemplateBox[{"10", 
          RowBox[{"-", "8"}]}, "Superscript", SyntaxForm -> SuperscriptBox], 
        TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {-9.210340371976182, 
       FormBox[
        TemplateBox[{"10", 
          RowBox[{"-", "4"}]}, "Superscript", SyntaxForm -> SuperscriptBox], 
        TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {0., 
       FormBox["1", TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {9.210340371976184, 
       FormBox[
        TemplateBox[{"10", "4"}, "Superscript", SyntaxForm -> SuperscriptBox],
         TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {18.420680743952367`, 
       FormBox[
        TemplateBox[{"10", "8"}, "Superscript", SyntaxForm -> SuperscriptBox],
         TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {27.631021115928547`, 
       FormBox[
        TemplateBox[{"10", "12"}, "Superscript", SyntaxForm -> 
         SuperscriptBox], TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {-13.815510557964274`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-4.605170185988091, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {4.605170185988092, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {13.815510557964274`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {23.025850929940457`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {32.23619130191664, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}}}]]], "Output",
 CellChangeTimes->{{3.7932503086478157`*^9, 3.793250350546709*^9}, {
   3.793250634635905*^9, 3.793250657847126*^9}, 3.793250721438882*^9, {
   3.793250755416931*^9, 3.793250811178934*^9}, {3.79351101185966*^9, 
   3.793511094071745*^9}, {3.793511133436336*^9, 3.793511171845035*^9}, {
   3.7935114521515093`*^9, 3.793511502781269*^9}, {3.7935116447643642`*^9, 
   3.793511727417717*^9}, {3.793517659326042*^9, 3.793517698264188*^9}, {
   3.793518105922499*^9, 3.7935181251055975`*^9}, {3.7935183486149797`*^9, 
   3.793518354799127*^9}, 3.793519151649064*^9, {3.793519326672647*^9, 
   3.7935193498274174`*^9}, {3.793519647175251*^9, 3.7935197110474854`*^9}, {
   3.79351975339511*^9, 3.7935198626631613`*^9}, {3.793519959472864*^9, 
   3.7935199714527817`*^9}, {3.793520242327504*^9, 3.7935202844394007`*^9}, {
   3.7935203509054065`*^9, 3.7935203947793746`*^9}, {3.7935204268896303`*^9, 
   3.793520532500404*^9}, 3.793520785521681*^9, {3.793520844114148*^9, 
   3.793520872542576*^9}, 3.793520904653349*^9, 3.7935210551073966`*^9, {
   3.793622607761757*^9, 3.793622644316487*^9}, {3.7936229274497876`*^9, 
   3.793622938959263*^9}},
 CellLabel->"Out[42]=",ExpressionUUID->"9590f5d3-2e17-48af-bd2e-11d6e86ce387"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Reduce", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"x", "^", "5"}], "\[Equal]", 
    RowBox[{"x", "+", "5"}]}], ",", "x"}], "]"}]], "Input",
 CellChangeTimes->{{3.7935212064532595`*^9, 3.7935212539070296`*^9}},
 CellLabel->
  "In[271]:=",ExpressionUUID->"5d4311d8-3785-4f36-928f-b1c77739292b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"x", "\[Equal]", 
   InterpretationBox[
    TemplateBox[{"Root",TemplateBox[{"\"1.45\"", 
        DynamicBox[
         FEPrivate`FrontEndResource[
         "FEExpressions", "NumericalApproximationElider"]]}, "RowDefault"],
      TagBox[
       RowBox[{"Root", "[", 
         RowBox[{
           RowBox[{
             RowBox[{
               RowBox[{"-", "5"}], "-", "#1", "+", 
               SuperscriptBox["#1", "5"]}], "&"}], ",", "1"}], "]"}], 
       Short[#, 7]& ],1.4519028714517146`},
     "NumericalApproximation"],
    Root[-5 - # + #^5& , 1, 0]]}], "||", 
  RowBox[{"x", "\[Equal]", 
   InterpretationBox[
    TemplateBox[{"Root",RowBox[{
        TemplateBox[{"\"-1.09\"", 
          DynamicBox[
           FEPrivate`FrontEndResource[
           "FEExpressions", "NumericalApproximationElider"]]}, "RowDefault"], 
        "-", 
        RowBox[{
          TemplateBox[{"\"0.734\"", 
            DynamicBox[
             FEPrivate`FrontEndResource[
             "FEExpressions", "NumericalApproximationElider"]]}, 
           "RowDefault"], " ", "\[ImaginaryI]"}]}],TagBox[
       RowBox[{"Root", "[", 
         RowBox[{
           RowBox[{
             RowBox[{
               RowBox[{"-", "5"}], "-", "#1", "+", 
               SuperscriptBox["#1", "5"]}], "&"}], ",", "2"}], "]"}], 
       Short[#, 7]& ],Complex[-1.0941779906641493`, -0.7344299578717278]},
     "NumericalApproximation"],
    Root[-5 - # + #^5& , 2, 0]]}], "||", 
  RowBox[{"x", "\[Equal]", 
   InterpretationBox[
    TemplateBox[{"Root",RowBox[{
        TemplateBox[{"\"-1.09\"", 
          DynamicBox[
           FEPrivate`FrontEndResource[
           "FEExpressions", "NumericalApproximationElider"]]}, "RowDefault"], 
        "+", 
        RowBox[{
          TemplateBox[{"\"0.734\"", 
            DynamicBox[
             FEPrivate`FrontEndResource[
             "FEExpressions", "NumericalApproximationElider"]]}, 
           "RowDefault"], " ", "\[ImaginaryI]"}]}],TagBox[
       RowBox[{"Root", "[", 
         RowBox[{
           RowBox[{
             RowBox[{
               RowBox[{"-", "5"}], "-", "#1", "+", 
               SuperscriptBox["#1", "5"]}], "&"}], ",", "3"}], "]"}], 
       Short[#, 7]& ],Complex[-1.0941779906641493`, 0.7344299578717278]},
     "NumericalApproximation"],
    Root[-5 - # + #^5& , 3, 0]]}], "||", 
  RowBox[{"x", "\[Equal]", 
   InterpretationBox[
    TemplateBox[{"Root",RowBox[{
        TemplateBox[{"\"0.368\"", 
          DynamicBox[
           FEPrivate`FrontEndResource[
           "FEExpressions", "NumericalApproximationElider"]]}, "RowDefault"], 
        "-", 
        RowBox[{
          TemplateBox[{"\"1.36\"", 
            DynamicBox[
             FEPrivate`FrontEndResource[
             "FEExpressions", "NumericalApproximationElider"]]}, 
           "RowDefault"], " ", "\[ImaginaryI]"}]}],TagBox[
       RowBox[{"Root", "[", 
         RowBox[{
           RowBox[{
             RowBox[{
               RowBox[{"-", "5"}], "-", "#1", "+", 
               SuperscriptBox["#1", "5"]}], "&"}], ",", "4"}], "]"}], 
       Short[#, 7]& ],Complex[0.36822655493829215`, -1.35920560698555]},
     "NumericalApproximation"],
    Root[-5 - # + #^5& , 4, 0]]}], "||", 
  RowBox[{"x", "\[Equal]", 
   InterpretationBox[
    TemplateBox[{"Root",RowBox[{
        TemplateBox[{"\"0.368\"", 
          DynamicBox[
           FEPrivate`FrontEndResource[
           "FEExpressions", "NumericalApproximationElider"]]}, "RowDefault"], 
        "+", 
        RowBox[{
          TemplateBox[{"\"1.36\"", 
            DynamicBox[
             FEPrivate`FrontEndResource[
             "FEExpressions", "NumericalApproximationElider"]]}, 
           "RowDefault"], " ", "\[ImaginaryI]"}]}],TagBox[
       RowBox[{"Root", "[", 
         RowBox[{
           RowBox[{
             RowBox[{
               RowBox[{"-", "5"}], "-", "#1", "+", 
               SuperscriptBox["#1", "5"]}], "&"}], ",", "5"}], "]"}], 
       Short[#, 7]& ],Complex[0.36822655493829215`, 1.35920560698555]},
     "NumericalApproximation"],
    Root[-5 - # + #^5& , 5, 0]]}]}]], "Output",
 CellChangeTimes->{{3.793521213183376*^9, 3.7935212541392407`*^9}},
 CellLabel->
  "Out[271]=",ExpressionUUID->"7e99486f-6119-4c62-a079-68deb3a1c6f1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Block", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"k", "=", 
      RowBox[{"2", "/", "3"}]}], ",", 
     RowBox[{"\[Theta]", "=", "1"}], ",", 
     RowBox[{"\[Eta]", "=", "111"}]}], "}"}], ",", 
   RowBox[{"LogPlot", "[", 
    RowBox[{
     FractionBox[
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"-", "t"}]]}], "+", "t"}]], ")"}], 
        RowBox[{"1", "+", "k"}]], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "t"}]]}], ")"}], " ", 
       SqrtBox[
        RowBox[{"1", "+", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", 
             SuperscriptBox["\[ExponentialE]", 
              RowBox[{"-", "t"}]]}], "+", "t"}]], " ", "\[Theta]"}]}]]}], 
      RowBox[{"1", "+", 
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"-", "t"}]]}], "+", "t"}]], "-", "\[Eta]"}]]}]], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", 
       RowBox[{"-", "6.5"}], ",", "6.5"}], "}"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"$MachineEpsilon", "/", 
         RowBox[{"2", "^", "6"}]}], ",", "All"}], "}"}]}], ",", 
     RowBox[{"GridLines", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Log", "[", "\[Eta]", "]"}], "+", 
          RowBox[{"ProductLog", "[", 
           FractionBox["1", "\[Eta]"], "]"}]}], "}"}], ",", "None"}], 
       "}"}]}]}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.79325038428856*^9, 3.793250452007943*^9}, {
   3.793250854438512*^9, 3.7932508550055313`*^9}, 3.7935083435701637`*^9, {
   3.7935104742546268`*^9, 3.793510529638424*^9}, {3.7935175142890425`*^9, 
   3.7935175400306406`*^9}, {3.7935176253373475`*^9, 3.793517639448347*^9}},
 CellLabel->
  "In[155]:=",ExpressionUUID->"61c63c3a-b391-4333-a494-571e0f9ad485"],

Cell[BoxData[
 TemplateBox[{
  "General","munfl",
   "\"\\!\\(\\*SuperscriptBox[\\\"2.435370355001359`*^-292\\\", RowBox[{\\\"5\
\\\", \\\"/\\\", \\\"3\\\"}]]\\) is too small to represent as a normalized \
machine number; precision may be lost.\"",2,155,84,24768544697250016557,
   "Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{{3.793510524757392*^9, 3.793510529990744*^9}, {
   3.7935175214771223`*^9, 3.793517540702755*^9}, 3.793517640787583*^9},
 CellLabel->
  "During evaluation of \
In[155]:=",ExpressionUUID->"d2769f56-b670-4e0c-835c-c35d27eee099"],

Cell[BoxData[
 TemplateBox[{
  "General","munfl",
   "\"\\!\\(\\*SuperscriptBox[\\\"6.285538588514231`*^-225\\\", RowBox[{\\\"5\
\\\", \\\"/\\\", \\\"3\\\"}]]\\) is too small to represent as a normalized \
machine number; precision may be lost.\"",2,155,85,24768544697250016557,
   "Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{{3.793510524757392*^9, 3.793510529990744*^9}, {
   3.7935175214771223`*^9, 3.793517540702755*^9}, 3.7935176408476377`*^9},
 CellLabel->
  "During evaluation of \
In[155]:=",ExpressionUUID->"020553f9-c517-4c07-bb50-7c822ea84d23"],

Cell[BoxData[
 TemplateBox[{
  "General","munfl",
   "\"\\!\\(\\*SuperscriptBox[\\\"2.435370355001359`*^-292\\\", RowBox[{\\\"5\
\\\", \\\"/\\\", \\\"3\\\"}]]\\) is too small to represent as a normalized \
machine number; precision may be lost.\"",2,155,86,24768544697250016557,
   "Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{{3.793510524757392*^9, 3.793510529990744*^9}, {
   3.7935175214771223`*^9, 3.793517540702755*^9}, 3.793517640854644*^9},
 CellLabel->
  "During evaluation of \
In[155]:=",ExpressionUUID->"24953f20-791d-45b2-9c82-1ce46898a4aa"],

Cell[BoxData[
 TemplateBox[{
  "General","stop",
   "\"Further output of \\!\\(\\*StyleBox[RowBox[{\\\"General\\\", \
\\\"::\\\", \\\"munfl\\\"}], \\\"MessageName\\\"]\\) will be suppressed \
during this calculation.\"",2,155,87,24768544697250016557,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{{3.793510524757392*^9, 3.793510529990744*^9}, {
   3.7935175214771223`*^9, 3.793517540702755*^9}, 3.7935176408616505`*^9},
 CellLabel->
  "During evaluation of \
In[155]:=",ExpressionUUID->"e3b9de3d-fcfa-4f2f-982b-2286895d604c"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
      1.], LineBox[CompressedData["
1:eJw1llk81Asfh2esI1vzH9kSmbGTY4lQzC9Kkr0kZSsp4pRzUEjJVrQQFZJs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       "]]},
     Annotation[#, "Charting`Private`Tag$562373#1"]& ]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, -40.20253647247683},
  CoordinatesToolOptions:>{"DisplayFunction" -> ({
      Part[#, 1], 
      Exp[
       Part[#, 2]]}& ), "CopiedValueFunction" -> ({
      Part[#, 1], 
      Exp[
       Part[#, 2]]}& )},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Quiet[
      Charting`ScaledTicks[{Log, Exp}][#, #2, {6, 6}]]& , 
     Charting`ScaledFrameTicks[{Log, Exp}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  GridLines->NCache[{{Log[111] + ProductLog[
        Rational[1, 111]]}, None}, {{4.718459127602356}, None}],
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None},
  PlotRange->{{-6.089003506317558, 
    6.499999734693877}, {-40.20253647247683, All}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {0, 
     Scaled[0.05]}},
  Ticks->FrontEndValueCache[{Automatic, Quiet[
      Charting`ScaledTicks[{Log, Exp}][#, #2, {6, 6}]]& }, {
    Automatic, {{-34.538776394910684`, 
       FormBox[
        TemplateBox[{"10", 
          RowBox[{"-", "15"}]}, "Superscript", SyntaxForm -> SuperscriptBox], 
        TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {-23.025850929940457`, 
       FormBox[
        TemplateBox[{"10", 
          RowBox[{"-", "10"}]}, "Superscript", SyntaxForm -> SuperscriptBox], 
        TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {-11.512925464970229`, 
       FormBox[
        TemplateBox[{"10", 
          RowBox[{"-", "5"}]}, "Superscript", SyntaxForm -> SuperscriptBox], 
        TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {0., 
       FormBox["1", TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {11.512925464970229`, 
       FormBox[
        TemplateBox[{"10", "5"}, "Superscript", SyntaxForm -> SuperscriptBox],
         TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {-39.14394658089878, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-36.841361487904734`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-32.23619130191664, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-29.933606208922594`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-27.631021115928547`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-25.328436022934504`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-20.72326583694641, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-18.420680743952367`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-16.11809565095832, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-13.815510557964274`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-9.210340371976182, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-6.907755278982137, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-4.605170185988091, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-2.3025850929940455`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {2.302585092994046, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {4.605170185988092, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {6.907755278982137, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {9.210340371976184, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {13.815510557964274`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}}}]]], "Output",
 CellChangeTimes->{{3.7932503849156337`*^9, 3.7932504014087296`*^9}, {
   3.79325043781301*^9, 3.7932504525379295`*^9}, 3.7932508569372864`*^9, 
   3.7935083463542075`*^9, {3.793510474879699*^9, 3.7935105301148567`*^9}, {
   3.7935175215902257`*^9, 3.7935175408148565`*^9}, 3.793517640920704*^9},
 CellLabel->
  "Out[155]=",ExpressionUUID->"a11f0fed-32fe-4f8c-abb6-30da73cd5ea0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Solve", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Exp", "[", 
     RowBox[{"t", "-", 
      RowBox[{"Exp", "[", 
       RowBox[{"-", "t"}], "]"}]}], "]"}], "\[Equal]", "\[Eta]"}], ",", "t"}],
   "]"}]], "Input",
 CellChangeTimes->{{3.7935176009184875`*^9, 3.7935176327246847`*^9}},
 CellLabel->
  "In[154]:=",ExpressionUUID->"b9b8748b-d069-47e6-b524-e7eaff32c2bb"],

Cell[BoxData[
 TemplateBox[{
  "Solve","ifun",
   "\"Inverse functions are being used by \
\\!\\(\\*RowBox[{\\\"Solve\\\"}]\\), so some solutions may not be found; use \
Reduce for complete solution information.\"",2,154,83,24768544697250016557,
   "Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{{3.7935176125801754`*^9, 3.7935176332321463`*^9}},
 CellLabel->
  "During evaluation of \
In[154]:=",ExpressionUUID->"1fe9c246-63e5-4857-b123-43d237296d82"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"t", "\[Rule]", 
    RowBox[{
     RowBox[{"Log", "[", "\[Eta]", "]"}], "+", 
     RowBox[{"ProductLog", "[", 
      FractionBox["1", "\[Eta]"], "]"}]}]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{{3.7935176125881824`*^9, 3.7935176332401533`*^9}},
 CellLabel->
  "Out[154]=",ExpressionUUID->"106b3ca6-c066-4fe4-8413-6e73a4177058"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"N", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.7935176152536345`*^9, 3.7935176157806177`*^9}},
 CellLabel->
  "In[153]:=",ExpressionUUID->"09619871-297f-41be-bb4e-c1846ee80f85"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"t", "\[Rule]", "4.718459127602356`"}], "}"}], "}"}]], "Output",
 CellChangeTimes->{3.793517616040854*^9},
 CellLabel->
  "Out[153]=",ExpressionUUID->"0cb3d099-a62c-4de9-919b-8c327d783ceb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"D", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"x", "^", 
     RowBox[{"(", 
      RowBox[{"k", "+", 
       RowBox[{"1", "/", "2"}]}], ")"}]}], 
    RowBox[{"Exp", "[", 
     RowBox[{"-", "x"}], "]"}]}], ",", "x"}], "]"}]], "Input",
 CellChangeTimes->{{3.793508089363308*^9, 3.7935081260979757`*^9}},
 CellLabel->"In[7]:=",ExpressionUUID->"19eb6346-4c07-41a5-aa13-48944aa96422"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{"-", "x"}]], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox["1", "2"], "+", "k"}], ")"}], " ", 
   SuperscriptBox["x", 
    RowBox[{
     RowBox[{"-", 
      FractionBox["1", "2"]}], "+", "k"}]]}], "-", 
  RowBox[{
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{"-", "x"}]], " ", 
   SuperscriptBox["x", 
    RowBox[{
     FractionBox["1", "2"], "+", "k"}]]}]}]], "Output",
 CellChangeTimes->{3.793508126780616*^9},
 CellLabel->"Out[7]=",ExpressionUUID->"d0d9c1c2-1d1e-4292-aaa9-ae7ba5e0abbc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Solve", "[", 
  RowBox[{
   RowBox[{"%", "\[Equal]", "0"}], ",", "x"}], "]"}]], "Input",
 CellChangeTimes->{{3.793508127994727*^9, 3.7935081306577063`*^9}},
 CellLabel->"In[8]:=",ExpressionUUID->"38055604-f9a5-4177-a12d-6e8c3586f124"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"x", "\[Rule]", 
    RowBox[{
     FractionBox["1", "2"], " ", 
     RowBox[{"(", 
      RowBox[{"1", "+", 
       RowBox[{"2", " ", "k"}]}], ")"}]}]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{3.793508131068079*^9},
 CellLabel->"Out[8]=",ExpressionUUID->"03b2549a-b1ee-4ee0-806e-eca61b206509"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Block", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"k", "=", "4"}], ",", 
     RowBox[{"\[Eta]", "=", "10"}], ",", 
     RowBox[{"\[Theta]", "=", "1"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"k", "+", "0.5"}], ",", 
     RowBox[{"x", "/.", 
      RowBox[{
       RowBox[{"NMaximize", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"x", "^", "k"}], " ", 
            RowBox[{
             RowBox[{"Sqrt", "[", 
              RowBox[{"1", "+", 
               RowBox[{"\[Theta]", " ", 
                RowBox[{"x", "/", "2"}]}]}], "]"}], "/", 
             RowBox[{"(", 
              RowBox[{"1", "+", 
               RowBox[{"Exp", "[", 
                RowBox[{"x", "-", "\[Eta]"}], "]"}]}], ")"}]}]}], ",", 
           RowBox[{"x", ">", "0"}]}], "}"}], ",", "x"}], "]"}], "[", 
       RowBox[{"[", "2", "]"}], "]"}]}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.79350816405028*^9, 3.793508318608342*^9}},
 CellLabel->"In[18]:=",ExpressionUUID->"2c7a2c72-59b5-4941-9a0a-3b5cb386b26a"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"4.5`", ",", "9.80126429708614`"}], "}"}]], "Output",
 CellChangeTimes->{{3.7935082030619354`*^9, 3.793508319246426*^9}},
 CellLabel->"Out[18]=",ExpressionUUID->"83e6c5e4-12ab-415c-a259-73e48a48a0c2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"D", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"x", "^", 
     RowBox[{"(", "k", ")"}]}], " ", "/", 
    RowBox[{"(", 
     RowBox[{"1", "+", 
      RowBox[{"Exp", "[", 
       RowBox[{"x", "-", "\[Eta]"}], "]"}]}], ")"}]}], ",", "x"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.793508535334668*^9, 3.7935085847104797`*^9}, {
  3.7935086389992833`*^9, 3.793508639637863*^9}},
 CellLabel->"In[35]:=",ExpressionUUID->"94e1ce36-2bbb-4b6a-98a6-99d362c38fe0"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"k", " ", 
    SuperscriptBox["x", 
     RowBox[{
      RowBox[{"-", "1"}], "+", "k"}]]}], 
   RowBox[{"1", "+", 
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"x", "-", "\[Eta]"}]]}]], "-", 
  FractionBox[
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"x", "-", "\[Eta]"}]], " ", 
    SuperscriptBox["x", "k"]}], 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"1", "+", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"x", "-", "\[Eta]"}]]}], ")"}], "2"]]}]], "Output",
 CellChangeTimes->{{3.793508537651288*^9, 3.7935085522541347`*^9}, {
   3.7935085855472403`*^9, 3.7935085931111956`*^9}, 3.7935086402133865`*^9},
 CellLabel->"Out[35]=",ExpressionUUID->"4913ddc3-b57b-4d8a-95b7-2720e742b333"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Solve", "[", 
   RowBox[{
    RowBox[{"%", "\[Equal]", "0"}], ",", "x"}], "]"}], "//", 
  "Expand"}]], "Input",
 CellChangeTimes->{{3.7935085542164764`*^9, 3.7935085567422757`*^9}, {
  3.7935085942647486`*^9, 3.793508595230688*^9}},
 CellLabel->"In[36]:=",ExpressionUUID->"41b51fb0-8418-4ae8-8237-642566fafb0d"],

Cell[BoxData[
 TemplateBox[{
  "Solve","ifun",
   "\"Inverse functions are being used by \
\\!\\(\\*RowBox[{\\\"Solve\\\"}]\\), so some solutions may not be found; use \
Reduce for complete solution information.\"",2,36,13,24768544697250016557,
   "Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{{3.7935085570951643`*^9, 3.7935085957431536`*^9}, 
   3.7935086416517286`*^9},
 CellLabel->
  "During evaluation of \
In[36]:=",ExpressionUUID->"f9502188-21e0-4c35-8d0f-a4281d16d275"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"x", "\[Rule]", 
    RowBox[{"k", "+", 
     RowBox[{"ProductLog", "[", 
      RowBox[{
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{
         RowBox[{"-", "k"}], "+", "\[Eta]"}]], " ", "k"}], "]"}]}]}], "}"}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.793508557106174*^9, 3.7935085957511606`*^9}, 
   3.793508641659735*^9},
 CellLabel->"Out[36]=",ExpressionUUID->"7232f311-dc79-430c-9a04-86e132f55417"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Evaluate", "@", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"k", "+", 
       RowBox[{"ProductLog", "[", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"-", "k"}], "+", "\[Eta]"}]], " ", "k"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"\[Eta]", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "100"}], ",", 
          RowBox[{"-", "10"}], ",", "0", ",", "10"}], "}"}]}], "}"}]}], 
     "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", 
     RowBox[{"-", "1"}], ",", "6"}], "}"}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Black", ",", "Red", ",", "Green", ",", "Blue", ",", "Yellow"}], 
     "}"}]}], ",", 
   RowBox[{"Epilog", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Dotted", ",", 
      RowBox[{"Line", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"6", ",", "6"}], "}"}]}], "}"}], "]"}]}], "}"}]}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.7935086972781296`*^9, 3.7935087985257673`*^9}, {
  3.793508828534728*^9, 3.7935088289651194`*^9}, {3.7935092785244474`*^9, 
  3.7935093034833045`*^9}, {3.7935093417913637`*^9, 3.7935093492582474`*^9}},
 CellLabel->"In[51]:=",ExpressionUUID->"206d7147-3ec3-400c-b7ea-ef3751d15622"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJxFxW0w03EcAPB/k2cZo7hCnnLGlXN6QR6z2lWXeUgyeahlMZcjotX1oNzl
4ZzmkMdUqITUrFSMPF24o5uniZmrpc3D4iYP8zCrXuz7e/G5jxUtIYiOwzDM
/5//Wwn9OErl4mfVGrO3wxkL6Lnl1+rDk+hGPf3QF5/Qvh5ft04no2llFHKp
eAGupPqPHx74DdvwA5SM0nl4JpbIseOL4TjLjJ52mgjelkXaM3Qn4QZ+WN5K
/hBsfdJgKXxoEK7T7ky9casLfnvUJSusgA4HriTJfdJlbar95/06ElI7vVWf
1wp5L1QOwpkSavPUPQFc0Ua8S3AWwfQZwYwgWwzHMT/OBZHm4caf+Bxp7SJc
NtErKnFdgkeSoqtYrGX4DbOVY9q+CtewHVlrFuswKfQcN+bsJqxwLn53qEUB
FwmpsdM6mI9qjEq22LDZAcvjPY+0BOPgDjej7WNX1eDjEfwzrpk7YereavxY
kzrslRuQ7DWoATeWaXoGqmnBP7D64gEnbbSZUznhhA6cOMRVV2Pqwjwvogk3
Xw+W4tKbp17tgosuSLrqx/RhoxSHFJIMDz809Pjim2cAb5OGDvTuN4RPWUdR
7tehI/1kRAKJAE8MJ1Ef8NAWL9fdeQwj2NvuuoSCGcN92LSYnYPeZx9SMme7
Gx6t/fBEk4OOH8cnUL32wP3B8bK0UXSBY3NPDs0EHpm9VoCjo41rnC4yY9CF
ts83Ll1BPzJnHXRPRRfjL+fPZqHL/xhGkdnoSXa/I5eDNkvMkDs3oR9Lt/LM
W9AVvyTdy93op2OtDlXf0N8LmWumArRlsEt3rhD9jFcTcVOEruzLZwVK0aIM
SkTPAtqarO3gKUNXdd7psl9FT6e5sSrkaFvv5XDjTXS0ooGYrUBXtzBWlUr0
XxNiZHk=
       "]]},
     Annotation[#, "Charting`Private`Tag$156512#1"]& ], 
    TagBox[
     {RGBColor[1, 0, 0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwV0Gs4lGkcx/EHkaIwjEelkqw11M6l2kri+a/BbgdESlNUqxTttqzTznZt
G+pyvhjRVrQ60GbTaUzZnOYmitoOE0UZ05aVYcjT2Cmnhr3vF7/r8+734rso
PDooQp+iqAA84iKln3RqikU5CRt9kqn3yKj/cGjUEIs6Am/Q37EsUmuvGrZ1
saizUnKxTcmiCtPZ2/6oYtGJx9FNpdUs8lr7+NPGOBbFHr9n+nU8i8KL/H0L
e4cQ3bG+JUs1hC4IA16uePQOHVnB6+U+focWt2+aiiocQBvakwqXFA2gvkie
1LG9F8VVrDsgwR6wS2uuD+9GuokH2kV7utGkZqdTlEkXcpnJP6zGXmvfnvch
vxXZpC9NZApakf068+HQ1qdIt2TH/hJs+Yw7iT//0ohczbvGarE3vlqesb0g
Arm3BfcXYgM/xI7CUY3M9KbgHErTyAIG/BqiE+8wbqMmAWexO4y33lJOPWVy
Gm3tjahWJl0lrH6VrGDq+b7jlikKpljGO8Jx7WaOcyYdXbERfYo+RWYv41O1
xUKHPSC6rQ4SDDDyz2uOJWAr/jXLHrzMMgo+97hZOcsUdbZ0n149zMw7XOJZ
jn0Wu7dELNYyWdK43PPY66I6qU39R2Zk1UZjHrZM4iIeWTDGWP1TZjt94Rgj
2BZSu3/LBJM6PEuUiNW5nrr5RY2OEa1wT1qLPakURvbMpKB5xPu5GksJfReM
L9YD1fzwuZSDHowe9FhTE6wPP2i+lNVjG9wsJ71/NADlmX3c9VifsPbNq9On
wUudZpoHVji31Kyj0hAyS6NCFFjPnE1xnk+NwFURs9MLW1E03SPQwBiuHHV5
EIx9Q1059Yg/A5pmL5TLsW9s+Wc438yEimdpGVxsTGutoYHIBJT16jJDrNyT
R9fmm8IG68pDMuyg/tHqV3/Ogu160p7X2JO7VY1XOmaDRwPv1jWsZYJzgkBj
BloZtdIHm2ux9p5Xnjm82Px3jgA7KWj9rGWhBZRK+J3E9fa7/FPKLSBoFnpP
3Omn4XEEHMjKK68mdrbFClPlHIhcFqggLrg05i6PsgRxw7brRMbxJ5U/ZQUp
J7n+Adj7VE+vJNsKpO1yrwrsPKetp9UOXDBwU6iJzy//dXa6lAuwK6OPePCl
WbTQ0xoO+a28QXwYfFCT9NwaglR2LsnYApfq5uxwGhrzVk0Qn/XHF+hH0GBu
/aKZaFXG/1a0nwanS6IC4gmHi+N7vqfhPFu1dC/2t/nipe6JNHDmeOwmnjLb
l9+fQUNvi89d4pn/LHb5SmiIj9+dS+ySPHSpldIwnqofSrSNSRt1rcS/F0ud
lmF/H/yUN7+GBq1RfwOx+K2qSdtEw21hrJZ4rqPOueQFDblr0oTE1ydEIzYK
Gp6YODvOwdoFL2/KUdLwqO/hMPG8vCzsUDcNA3c52cQL9/PFgYM0zDE9KyN2
p/mHNQ/RcHWNVxbR3neGs4cGd4h/G0IsufNro9NHGppMlmiIPUlu4uJRGlIi
n9QRHRhtqNUEDXXy2EziXt01XqaOhhhv6xBiaU3Ux6kp3KmxajFF2cD/IQRa
IQ==
       "]]},
     Annotation[#, "Charting`Private`Tag$156512#2"]& ], 
    TagBox[
     {RGBColor[0, 1, 0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwVjHk01Hsfx6eJZKnJWH4TQi63JEmoEN/PTRsl3UKpRNYWpYgs9xblQR4n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       "]]},
     Annotation[#, "Charting`Private`Tag$156512#3"]& ], 
    TagBox[
     {RGBColor[0, 0, 1], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwV1Xk41PsXB/DJSGW5wzC+Y4yxzDeh1c0Wmc/5JSpbimw3S2LK/SVESF3h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       "]]},
     Annotation[#, "Charting`Private`Tag$156512#4"]& ]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Epilog->{
    Dashing[{0, Small}], 
    LineBox[{{0, 0}, {6, 6}}]},
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  ImageSize->{470.6666666666664, Automatic},
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{-1, 6}, {-1.2577795434067502`, 10.326906548653566`}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.793508735235326*^9, 3.793508799112301*^9}, 
   3.7935088296587567`*^9, 3.7935091408874393`*^9, {3.7935092947498074`*^9, 
   3.793509303809601*^9}, 3.7935093497226696`*^9},
 CellLabel->"Out[51]=",ExpressionUUID->"7f61c09c-f65b-47a8-ba01-0ce03cfda4bb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Evaluate", "@", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"k", "+", 
       RowBox[{"1", "/", "2"}], "+", 
       RowBox[{"ProductLog", "[", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"-", "k"}], "+", "\[Eta]", "-", 
           RowBox[{"1", "/", "2"}]}]], " ", 
         RowBox[{"(", 
          RowBox[{"k", "+", 
           RowBox[{"1", "/", "2"}]}], ")"}]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"\[Eta]", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "100"}], ",", 
          RowBox[{"-", "10"}], ",", "0", ",", "10"}], "}"}]}], "}"}]}], 
     "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", 
     RowBox[{"-", "1"}], ",", "6"}], "}"}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Black", ",", "Red", ",", "Green", ",", "Blue", ",", "Yellow"}], 
     "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.793509125075467*^9, 3.7935091355080214`*^9}},
 CellLabel->"In[44]:=",ExpressionUUID->"6f89147b-4aa5-4de0-955c-1367f16b9a15"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwtzmlQ1GUcwPGV+5LlWHj4F5oCORwFkdSIAs+PQ8YYLpGM5dAkQNZiIAla
LUuyCWEYhQHiRhE0BFJgi5TDB4EJLGhgWZZzWSXihnUFudnNpufFdz5vv/sj
44OiVVgsVsCr/nO/xE+gVMqIR2NRjFIpJRqzl8J5SzKiJ9x6IByTkrmVn9X7
x2RENBume+ehlNTr6YfceSgjUYx5rW+ilHi4/LXtmygj3/OLNwqmxklkkb93
4dQS6Xi/JMOpR0JucQOGnXoWiZegtJ5XOEosxYFKXuE88a4pU/Q7DRJkpXXB
fnaGvHPM4EW4sI/MxNoIDoinyM3y292FIX+Sc/tSO1sjJ0igqrOLhqmAdD9P
0bBkPSW8sJh1uCJ/pJCfsubpjhGDBK2Whor7+J44NOtltpBUBPlIOEN/4Grt
tuQLX7cT261Sr3Z3Ma51P5gWmhNNLhUs+gyKpDhg3u9xfHIbFl088byoZBKH
aZ38VaLsw/Zq1SNLyhl8dZrbOJ4yijuW34qQtS7i0kc23xo5TuAAaQ5OM5Pj
6JnRmdH0KfzuStxK3NFlfI7/YC7Icx6/5xKedLfsJa7/m52xUCXDw3JN7+SB
NVw00jVRcOgFdROLzkeVZ2auULfxfX6LwKx1larAlXV2mWt7N7BoyKTrq+ss
8Az5qPnsh1vYosZuXFC1C3Yc83+xb9rBCjPf0DyJCuRJuLGTOiyqGrC43ns3
LXdR1WE9zvVwU7AKVQMeOxsrvD5XpWrC0QjxiUNX1ahawH2tgj3YoE7VBrdr
gYlufRpUHagv0nQ9rqpF1YNnrJr8Hgdt6m54Zu5QbHRMh6oPCcJmdVW+LpUN
vW42qDlbD2Jv5OiOf2AACypXGsfv7obkFPcImcgA8j6ebq8Z1Aff2uUz4k8N
wTjJNslTzob0w7mNZeuGcN3Q5XePLAOqESg8hW92vWFINQYfi9P+31UbUo3h
lJ/cxsjTiMqBkf7z3B96jagc2PvTxpFenjHVBPCBL6f9WRyqKTxhTU7VZXCo
pvC69cmCOSsTKoKBqt9uaApMqAjihtnxXDdTqhl0B8fJLw+YUs0gx66xMyMS
URkQzX6RoxKNqAxwKh3O8M8iKgO5Vrc3P/kMURn4cU/m20eSEZWBfHZM9mwa
ojJQvGx42rsOURkYq+u2a3719b8MmCekrjs2ICoDJQvbWXuaEJWB0n+mO1Y6
EJWBm4MttuVDiMrA01z+mtkoojKwL/hgxzUJojJQ1lsZcXECURm49SQ78/gC
ojIwkeof0bmEqAxYeGvbusoRlYHytm/arVcRlYHJy86ZpeuIyoAVXgnnbCEq
A1E792zSdxCVgYom3qpSiagM/AtDGV7I
       "]]},
     Annotation[#, "Charting`Private`Tag$5700#1"]& ], 
    TagBox[
     {RGBColor[1, 0, 0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwVjnk41Hkcx3+NWxjGmJ9foYTW0ZKtnrSY70eTiTajcmzTTVlNx5baNHQI
RWQZD60zHbQ5Sg2tiqmfa8PKOgo5hpqEcU8khZm1f7yf9x/v5/W8X6b+J3YE
UDAM81zI/20q9ihWKMbJA1VjqznYO1JVemEPb2ycJFK6hb+Ke8mhqQcqr7vH
yU+0WopLaS9ZpKWz889n42RGsN+9j6d7yY1O/85tPT1ONtrEztoO9JD+GRx2
ev8YmdvDaKxoEJN3uJ4daxtGydDfvUwG07tIs7ZtCl76MEnYpzqsX9dO4ubq
IbbSQbJh/URSTkszOXjYqnhlWz+ZbG98TbGznjyyPLqm3F9CLl1tcJTFKCZf
TYSrmi14Dm3jO6mIZC/ksn2WvMXd5BrXSib17kNU2LYr8XNSC+kYknrT5+0/
qECjMjjkfBXpg9/Q+OTShh65rInZlRxAuggtPui29iLPYY+KE8GVqCBEy0J0
ow/tVvf9S6xoRrGirEFdTIquDnBLe8K7kCgseiutYhRlvbAKo9lL0Kq6uqfp
hjIUMNg12BXbj/6efG0R5jqJjvCfDu1gDaOMMEej0tufUdEHatxI/jjS7Rnd
GNX6BWV01krSHD4hyebLGnkO39CbU4eyBYIppG5K/5glmEMP+c+LDcunEUlV
xVeWy1Gu0EbwxeQrkuvnKcITMGDt/FkU6DOL1o7X5DzLXwTz9qmPbcvmkat7
ZF6mmAIpYu7hPk0MnPY0sqWayoBx2SbfzBbB/rOHU+VmKjBz3PnHMm8KTGRf
8SC9VaFig758U5AShGxyeOIWpAaue9u8HK4qg+d37FLHq+rAXZJDbS9RAcfV
whWdJRrAjN92mtmsCh0okOnSrAlFGWrO25XUgRHEKfdS0oL32P3UBjsNqD93
sqvRThveG9ll0tw0wdS/+x7dTQdOtohUlPiLYV3mh05lPhWamFa4KEkLBtKw
3h53XRihRJb25GlDkNnc0ok3upByYKDqfrsO1D/w1Go/qgf6Z6zPsGRU2CR6
4XVnRg8S9Jxebkxc4IoEHFYiDeSsFovaZXrgUSu/WbtMH7as2M+JKNCDKe1F
oogCfdjnIbOisWjQc8X3Go1Fh87Xp7hRTTQY9U55FNVEB5N7Xx2bePpQb2YV
08QzALTy7AAHo4MVe8zGE2NAHdbXL4yjQ20CzbwojgFLLX3ThswN4KX1mcYh
cxxa85/cVCs2ANfEqUa1YhyOd1BPcJkMuMUzTecyDeGV93HZpVYGGF+4gIe3
GkKyTWlNnD8OUd23pHH+BLyR/pZMCcDhss6WEkoAAfRcOz9+IA6b3Scj+IEE
XDe/++3gMRw0O1yNDh0j4A9jwfeOwTho+A1zHIMJSKX+kiSNweEA1eGxNIaA
zEm9/Wzhwl7XfpEtJKBb+MpGtOB1d3HET6JiAoxORs/Ylyz8+a4y/KGEgBsj
c4nGZTjMKYcLjcsIyPo4UD1VjYNftXXfVDUBt9qfW2e/xSGtLsw9+y0B767z
vxh24ZAQb80gughY7r2mOl6MQ8zuVkm8mIDbTbl7QyU4XNS2OR8qIeBOXZJg
+wgOM01thdtHCJBEc/bWjOGQ3xp+rmaMgBVsDWtnGQ4uklVuzjICsisvVllO
42CgH/necpqAvksbBFkzOGxZb1uYNUOAOZraQ5/FwedgRyh9loBD84VWsfM4
rE25vDl2noCcMt60QoGDpMWOjmFL4D8cyU4O
       "]]},
     Annotation[#, "Charting`Private`Tag$5700#2"]& ], 
    TagBox[
     {RGBColor[0, 1, 0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwVzXs8lIkawPExYoaSXF8vio3c2pR0Ktp6H5TkJBEyFZVctosUKjpd1x4K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       "]]},
     Annotation[#, "Charting`Private`Tag$5700#3"]& ], 
    TagBox[
     {RGBColor[0, 0, 1], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwV1fk/1PsfBXDZkmQZYz6MmcHMp2yl63ZtKZ9XXN0ISSpLXISWG8mW7aa6
vleLyyRuqSRCbhOKlLW3ZRJF2ZeZMbYaLSTXLsvX/eE8zuP5OH/A0fI57eQn
LiYmlrya//qZt8i4cqUfPdd5e8Dbs5WIzt7b2S7oRyqzp749TZIGGHkc8qWs
H9X5OkSVlcmCpB6FJHGjH1W75pzRttgAjaeiH1ND+5GLN2cwVEEBEgsHHH7c
3486lzQC7S0Uwelf6zEbg34kmD/M5XYoAmbEueq9vh+R6PluPGclEJxV1Iv8
KESp+S31p7hKcK88rIH9UoiGk489sNcmgd8Szz8vS4jabews6edJoAcgVR0r
RJ/NpL5XtZDg68Wc+91HVvdGSncqVRmKX8pajpsJ0ZUFk6kST2WIkAkakMaE
iOZ8JmIyXRl27O08x5jqQz01PrOzPcpQ35JRYV/QhzZtMe31/pkMV5Sl3Pyu
9iGZrVzD1DAy7Dt0ci7meB96M2ZANcomQw//J6NHzD7UlXhBu2KBDOmMW+11
KwJUuM3RZj1LBXy8V87wBQKkukOJnmGjAl9EjQWyNwTod0dDgpmsAssTnjon
1gtQqZ9v2mNlClwbFHe7+oGPyBsuuHRvowDemns1H606913jsBMFbB5//ToR
wkf+P5lIz/1FgZTAcyVRAh7i/152smyeAtqezJE7z3jI5cUYaiBhUG5fr4rY
PNRh3tiwWR+D/s3yMRLWPHQ86FsCxQ0DvS/plgn5vYjHFNntfoJBFW9XaEF8
LzqQX+bT9RIDx9cfclq8e1GAGBY52YtB2D9b1qlQetGF+gT/j2KqUH2s6l36
uR4UfiJu0NhWFQ69Fxwp3NeN3FNfbgxuVoVP7ecTW3W7kWVGpl6GQBVi6vDq
SYlu5JPsJJv4RRUys06xTEu7UHy95+4yGTUY9Vr8VK3ZhT5IZdIiQA0u9qmf
bZvoQG9zl+1Gc9VApRnlTb3pQIXFLOb3IjXIqzzKo+R2IOPFcPLwCzVovs3Z
6e7WgayyJ3ZZdqmBqpu55PvaduTvv//gYQkqFHS5XZu+3oYGZ5tZSYep4D8u
XnA3qA2Zek9lfPaigoYM5/Uv9m1o3iJg2OAkFdhm3yVuSbehRZ57SkgMFULu
3A63iGxFK/HNBfMZVDD1EbjHe7agouPR7H3DVIjjV9j96NSEMu/zQtw91GFa
Tu7PuPVNaE27a0Osrzr4WxxBXdw3aKSztPXv39TBJnPRMNrkDWJHBb9Nj1QH
+WM7MS7tNYrbKF1DTlWHm/++GDw48gpljF6qbm5UB8662vDImDrUGhv6PUKf
BqUpSV0DW+vQotAnqdqQBvUaHsZ7hmtRemGj7LIJDQaM5qYptrXotFShhfvP
NKD4GIQ9xWqQIz1uY9YRGkiGGY0I/aoQ91rG/pirNCjqEg28bitGl3V+9KYO
06B59MK9NLNi9MC9g3PwIw0+itO9jt8rQtXNripXxmjA2HqgXyrwCbLdO8YW
ztKApBBbcYFUgKRvBm02laNDddAPJQGx2ahSeRe1ahsdHu/adtktxQ/dnjaZ
ijxHhx5bya+vdxijSNWakeGLdFgwKGrWlvIifthlL2cTT4e2d3tJB99FEdtV
O8lSbDpoONrxjKhs4oy3tpN1Jh22x/VfjA7JJLrUU2PGa+mwh6F7mKFZRPSo
d4zpSzBg3xf7mtPhtURTyO3G+QgGvD86OZ5SWUvkeXwqMY1hQJTgJqNcvI4Y
bKnQCItlQG7zcLRkUh3xSb40RvQ/BiwWRhqnPeASMXl733GSGZAXmsOp7akn
XETyjlwOA8SXF1NVzN8Qza4T2bsFDHCXOVTSt9JKXD/b98jaRAMujbiWCy/w
CU3+6Zg9Ig24+0I3lmQ4RHgqXSy2364Jfh/5H/lXRIRdwF/zeRGacDKi9LOT
1Rfiw+znNH6JJhQNKySMPhwn1samPVP/rAm3eQ1Daab/EhiJ8AhmaEFHsO99
NnuKoAnyuGYOWlAYUVWsWj1DOCoGfyBHaEHeE332LGOeWPuAzZ3N0gIrl8OV
xw5+J060Y8kzDVqwZHjzqUHFEmHa8eil8TctuNHnevy9rBhsVgx9tUGFCWKu
uxkLrDXQpD2tjhkzYS5g5/YKZ3FgUKJnMlyYUGOmvPzzGQl4G+uX++YsE6w9
ug6YXpIEjkJBcmgqE1yp2Qrdz6SAzfFtL3/KBItExxCLVmlw2LPJRbuVCUW3
1+7cLyEDrsd/EzcZZ8Kg2KObzVvXwd8i6j05ORYM0rbeIe2RBco1fXX/TSwI
aquUkohYD0u2+34IsmRBi4UuVnldDjSmi57rHGHBqPgf5cJ/NsCLpYSopVAW
3PAaqXvULQ/PVbY7JCSxQDlML8xqQgEGYnNdxPJYkKS0o97ymiIwszxjDWtZ
sGzVtrFBQwniTJ+3+/BYYMv81eEiRwn8xcyShiZY4Gk/oUuyIoFTRn6aznoc
eO3Brn+u/k7l5kJyMhMHxoN585YTypBzX0R/ZY4DsensiIMYGbzm+OSjzjg0
ir0XPUkgA81bmmnxGw7qOofSPuMqEP7HeMy3P3DofPg8Y22xCgRmuQ6N38Ih
oFfhtKsFBWSoG52Dn+DQ5Bwwcb6TArcMwj17G3FI0S9/leCDgX+155qMARw6
PoWmiPthoDsx/VxyEAdy3lbviGMYiF5NBp5cdSqes3D0FAZrXuoKjYZw+JvO
3mIejsGNS5yapmEcbir4X/90GQMfq5N3F0Q43JlU+vW/X7C7/q3s0BgOgidN
+pXFGMzsCTpfuWpaUPyc4TMMTE9c/oX5FYf00cVr9AoMBDsSu8dWfffDCHeK
i0FXiPxK3Dcc7nVX6d3vweD1sm1A8SQOA6kRs6p8DNYuMizUpnDQdN7GTezD
YCkvRyF21ZkteR5RQxgserU+tZ3GIavxOnv/KAbigW/XDs3gMBTv4PHqKwbm
8r7CX2ZxYO5ep7dzAgPnhdKS/FXfrz1XpzODgbzEA//IORzenzdj353DYM7a
CvpXjRNTR8jfMXDTyqFaz+Pgu1Sge2UJA0Odt9MPV51dcWJmZQWDwDHUqriA
w/8BEPNZNQ==
       "]]},
     Annotation[#, "Charting`Private`Tag$5700#4"]& ]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{-1, 6}, {-1.2731410489519774`, 10.488409571341176`}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.7935091371265087`*^9, 3.7935091414619613`*^9}},
 CellLabel->"Out[44]=",ExpressionUUID->"3d2759fb-bea6-440f-96c8-2a83c148700d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Show", "[", 
  RowBox[{"%", ",", "%%"}], "]"}]], "Input",
 CellChangeTimes->{{3.7935091423487673`*^9, 3.79350914863501*^9}},
 CellLabel->"In[45]:=",ExpressionUUID->"63094d15-287a-4be6-b126-858c539c5839"],

Cell[BoxData[
 GraphicsBox[{{{{}, {}, 
     TagBox[
      {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
       LineBox[CompressedData["
1:eJwtzmlQ1GUcwPGV+5LlWHj4F5oCORwFkdSIAs+PQ8YYLpGM5dAkQNZiIAla
LUuyCWEYhQHiRhE0BFJgi5TDB4EJLGhgWZZzWSXihnUFudnNpufFdz5vv/sj
44OiVVgsVsCr/nO/xE+gVMqIR2NRjFIpJRqzl8J5SzKiJ9x6IByTkrmVn9X7
x2RENBume+ehlNTr6YfceSgjUYx5rW+ilHi4/LXtmygj3/OLNwqmxklkkb93
4dQS6Xi/JMOpR0JucQOGnXoWiZegtJ5XOEosxYFKXuE88a4pU/Q7DRJkpXXB
fnaGvHPM4EW4sI/MxNoIDoinyM3y292FIX+Sc/tSO1sjJ0igqrOLhqmAdD9P
0bBkPSW8sJh1uCJ/pJCfsubpjhGDBK2Whor7+J44NOtltpBUBPlIOEN/4Grt
tuQLX7cT261Sr3Z3Ma51P5gWmhNNLhUs+gyKpDhg3u9xfHIbFl088byoZBKH
aZ38VaLsw/Zq1SNLyhl8dZrbOJ4yijuW34qQtS7i0kc23xo5TuAAaQ5OM5Pj
6JnRmdH0KfzuStxK3NFlfI7/YC7Icx6/5xKedLfsJa7/m52xUCXDw3JN7+SB
NVw00jVRcOgFdROLzkeVZ2auULfxfX6LwKx1larAlXV2mWt7N7BoyKTrq+ss
8Az5qPnsh1vYosZuXFC1C3Yc83+xb9rBCjPf0DyJCuRJuLGTOiyqGrC43ns3
LXdR1WE9zvVwU7AKVQMeOxsrvD5XpWrC0QjxiUNX1ahawH2tgj3YoE7VBrdr
gYlufRpUHagv0nQ9rqpF1YNnrJr8Hgdt6m54Zu5QbHRMh6oPCcJmdVW+LpUN
vW42qDlbD2Jv5OiOf2AACypXGsfv7obkFPcImcgA8j6ebq8Z1Aff2uUz4k8N
wTjJNslTzob0w7mNZeuGcN3Q5XePLAOqESg8hW92vWFINQYfi9P+31UbUo3h
lJ/cxsjTiMqBkf7z3B96jagc2PvTxpFenjHVBPCBL6f9WRyqKTxhTU7VZXCo
pvC69cmCOSsTKoKBqt9uaApMqAjihtnxXDdTqhl0B8fJLw+YUs0gx66xMyMS
URkQzX6RoxKNqAxwKh3O8M8iKgO5Vrc3P/kMURn4cU/m20eSEZWBfHZM9mwa
ojJQvGx42rsOURkYq+u2a3719b8MmCekrjs2ICoDJQvbWXuaEJWB0n+mO1Y6
EJWBm4MttuVDiMrA01z+mtkoojKwL/hgxzUJojJQ1lsZcXECURm49SQ78/gC
ojIwkeof0bmEqAxYeGvbusoRlYHytm/arVcRlYHJy86ZpeuIyoAVXgnnbCEq
A1E792zSdxCVgYom3qpSiagM/AtDGV7I
        "]]},
      Annotation[#, "Charting`Private`Tag$5700#1"]& ], 
     TagBox[
      {RGBColor[1, 0, 0], AbsoluteThickness[1.6], Opacity[1.], 
       LineBox[CompressedData["
1:eJwVjnk41Hkcx3+NWxjGmJ9foYTW0ZKtnrSY70eTiTajcmzTTVlNx5baNHQI
RWQZD60zHbQ5Sg2tiqmfa8PKOgo5hpqEcU8khZm1f7yf9x/v5/W8X6b+J3YE
UDAM81zI/20q9ihWKMbJA1VjqznYO1JVemEPb2ycJFK6hb+Ke8mhqQcqr7vH
yU+0WopLaS9ZpKWz889n42RGsN+9j6d7yY1O/85tPT1ONtrEztoO9JD+GRx2
ev8YmdvDaKxoEJN3uJ4daxtGydDfvUwG07tIs7ZtCl76MEnYpzqsX9dO4ubq
IbbSQbJh/URSTkszOXjYqnhlWz+ZbG98TbGznjyyPLqm3F9CLl1tcJTFKCZf
TYSrmi14Dm3jO6mIZC/ksn2WvMXd5BrXSib17kNU2LYr8XNSC+kYknrT5+0/
qECjMjjkfBXpg9/Q+OTShh65rInZlRxAuggtPui29iLPYY+KE8GVqCBEy0J0
ow/tVvf9S6xoRrGirEFdTIquDnBLe8K7kCgseiutYhRlvbAKo9lL0Kq6uqfp
hjIUMNg12BXbj/6efG0R5jqJjvCfDu1gDaOMMEej0tufUdEHatxI/jjS7Rnd
GNX6BWV01krSHD4hyebLGnkO39CbU4eyBYIppG5K/5glmEMP+c+LDcunEUlV
xVeWy1Gu0EbwxeQrkuvnKcITMGDt/FkU6DOL1o7X5DzLXwTz9qmPbcvmkat7
ZF6mmAIpYu7hPk0MnPY0sqWayoBx2SbfzBbB/rOHU+VmKjBz3PnHMm8KTGRf
8SC9VaFig758U5AShGxyeOIWpAaue9u8HK4qg+d37FLHq+rAXZJDbS9RAcfV
whWdJRrAjN92mtmsCh0okOnSrAlFGWrO25XUgRHEKfdS0oL32P3UBjsNqD93
sqvRThveG9ll0tw0wdS/+x7dTQdOtohUlPiLYV3mh05lPhWamFa4KEkLBtKw
3h53XRihRJb25GlDkNnc0ok3upByYKDqfrsO1D/w1Go/qgf6Z6zPsGRU2CR6
4XVnRg8S9Jxebkxc4IoEHFYiDeSsFovaZXrgUSu/WbtMH7as2M+JKNCDKe1F
oogCfdjnIbOisWjQc8X3Go1Fh87Xp7hRTTQY9U55FNVEB5N7Xx2bePpQb2YV
08QzALTy7AAHo4MVe8zGE2NAHdbXL4yjQ20CzbwojgFLLX3ThswN4KX1mcYh
cxxa85/cVCs2ANfEqUa1YhyOd1BPcJkMuMUzTecyDeGV93HZpVYGGF+4gIe3
GkKyTWlNnD8OUd23pHH+BLyR/pZMCcDhss6WEkoAAfRcOz9+IA6b3Scj+IEE
XDe/++3gMRw0O1yNDh0j4A9jwfeOwTho+A1zHIMJSKX+kiSNweEA1eGxNIaA
zEm9/Wzhwl7XfpEtJKBb+MpGtOB1d3HET6JiAoxORs/Ylyz8+a4y/KGEgBsj
c4nGZTjMKYcLjcsIyPo4UD1VjYNftXXfVDUBt9qfW2e/xSGtLsw9+y0B767z
vxh24ZAQb80gughY7r2mOl6MQ8zuVkm8mIDbTbl7QyU4XNS2OR8qIeBOXZJg
+wgOM01thdtHCJBEc/bWjOGQ3xp+rmaMgBVsDWtnGQ4uklVuzjICsisvVllO
42CgH/necpqAvksbBFkzOGxZb1uYNUOAOZraQ5/FwedgRyh9loBD84VWsfM4
rE25vDl2noCcMt60QoGDpMWOjmFL4D8cyU4O
        "]]},
      Annotation[#, "Charting`Private`Tag$5700#2"]& ], 
     TagBox[
      {RGBColor[0, 1, 0], AbsoluteThickness[1.6], Opacity[1.], 
       LineBox[CompressedData["
1:eJwVzXs8lIkawPExYoaSXF8vio3c2pR0Ktp6H5TkJBEyFZVctosUKjpd1x4K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        "]]},
      Annotation[#, "Charting`Private`Tag$5700#3"]& ], 
     TagBox[
      {RGBColor[0, 0, 1], AbsoluteThickness[1.6], Opacity[1.], 
       LineBox[CompressedData["
1:eJwV1fk/1PsfBXDZkmQZYz6MmcHMp2yl63ZtKZ9XXN0ISSpLXISWG8mW7aa6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        "]]},
      Annotation[#, "Charting`Private`Tag$5700#4"]& ]}, {}}, {{{}, {}, 
     TagBox[
      {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
       LineBox[CompressedData["
1:eJxFxW0w03EcAPB/k2cZo7hCnnLGlXN6QR6z2lWXeUgyeahlMZcjotX1oNzl
4ZzmkMdUqITUrFSMPF24o5uniZmrpc3D4iYP8zCrXuz7e/G5jxUtIYiOwzDM
/5//Wwn9OErl4mfVGrO3wxkL6Lnl1+rDk+hGPf3QF5/Qvh5ft04no2llFHKp
eAGupPqPHx74DdvwA5SM0nl4JpbIseOL4TjLjJ52mgjelkXaM3Qn4QZ+WN5K
/hBsfdJgKXxoEK7T7ky9casLfnvUJSusgA4HriTJfdJlbar95/06ElI7vVWf
1wp5L1QOwpkSavPUPQFc0Ua8S3AWwfQZwYwgWwzHMT/OBZHm4caf+Bxp7SJc
NtErKnFdgkeSoqtYrGX4DbOVY9q+CtewHVlrFuswKfQcN+bsJqxwLn53qEUB
FwmpsdM6mI9qjEq22LDZAcvjPY+0BOPgDjej7WNX1eDjEfwzrpk7YereavxY
kzrslRuQ7DWoATeWaXoGqmnBP7D64gEnbbSZUznhhA6cOMRVV2Pqwjwvogk3
Xw+W4tKbp17tgosuSLrqx/RhoxSHFJIMDz809Pjim2cAb5OGDvTuN4RPWUdR
7tehI/1kRAKJAE8MJ1Ef8NAWL9fdeQwj2NvuuoSCGcN92LSYnYPeZx9SMme7
Gx6t/fBEk4OOH8cnUL32wP3B8bK0UXSBY3NPDs0EHpm9VoCjo41rnC4yY9CF
ts83Ll1BPzJnHXRPRRfjL+fPZqHL/xhGkdnoSXa/I5eDNkvMkDs3oR9Lt/LM
W9AVvyTdy93op2OtDlXf0N8LmWumArRlsEt3rhD9jFcTcVOEruzLZwVK0aIM
SkTPAtqarO3gKUNXdd7psl9FT6e5sSrkaFvv5XDjTXS0ooGYrUBXtzBWlUr0
XxNiZHk=
        "]]},
      Annotation[#, "Charting`Private`Tag$5645#1"]& ], 
     TagBox[
      {RGBColor[1, 0, 0], AbsoluteThickness[1.6], Opacity[1.], 
       LineBox[CompressedData["
1:eJwV0Gs4lGkcx/EHkaIwjEelkqw11M6l2kri+a/BbgdESlNUqxTttqzTznZt
G+pyvhjRVrQ60GbTaUzZnOYmitoOE0UZ05aVYcjT2Cmnhr3vF7/r8+734rso
PDooQp+iqAA84iKln3RqikU5CRt9kqn3yKj/cGjUEIs6Am/Q37EsUmuvGrZ1
saizUnKxTcmiCtPZ2/6oYtGJx9FNpdUs8lr7+NPGOBbFHr9n+nU8i8KL/H0L
e4cQ3bG+JUs1hC4IA16uePQOHVnB6+U+focWt2+aiiocQBvakwqXFA2gvkie
1LG9F8VVrDsgwR6wS2uuD+9GuokH2kV7utGkZqdTlEkXcpnJP6zGXmvfnvch
vxXZpC9NZApakf068+HQ1qdIt2TH/hJs+Yw7iT//0ohczbvGarE3vlqesb0g
Arm3BfcXYgM/xI7CUY3M9KbgHErTyAIG/BqiE+8wbqMmAWexO4y33lJOPWVy
Gm3tjahWJl0lrH6VrGDq+b7jlikKpljGO8Jx7WaOcyYdXbERfYo+RWYv41O1
xUKHPSC6rQ4SDDDyz2uOJWAr/jXLHrzMMgo+97hZOcsUdbZ0n149zMw7XOJZ
jn0Wu7dELNYyWdK43PPY66I6qU39R2Zk1UZjHrZM4iIeWTDGWP1TZjt94Rgj
2BZSu3/LBJM6PEuUiNW5nrr5RY2OEa1wT1qLPakURvbMpKB5xPu5GksJfReM
L9YD1fzwuZSDHowe9FhTE6wPP2i+lNVjG9wsJ71/NADlmX3c9VifsPbNq9On
wUudZpoHVji31Kyj0hAyS6NCFFjPnE1xnk+NwFURs9MLW1E03SPQwBiuHHV5
EIx9Q1059Yg/A5pmL5TLsW9s+Wc438yEimdpGVxsTGutoYHIBJT16jJDrNyT
R9fmm8IG68pDMuyg/tHqV3/Ogu160p7X2JO7VY1XOmaDRwPv1jWsZYJzgkBj
BloZtdIHm2ux9p5Xnjm82Px3jgA7KWj9rGWhBZRK+J3E9fa7/FPKLSBoFnpP
3Omn4XEEHMjKK68mdrbFClPlHIhcFqggLrg05i6PsgRxw7brRMbxJ5U/ZQUp
J7n+Adj7VE+vJNsKpO1yrwrsPKetp9UOXDBwU6iJzy//dXa6lAuwK6OPePCl
WbTQ0xoO+a28QXwYfFCT9NwaglR2LsnYApfq5uxwGhrzVk0Qn/XHF+hH0GBu
/aKZaFXG/1a0nwanS6IC4gmHi+N7vqfhPFu1dC/2t/nipe6JNHDmeOwmnjLb
l9+fQUNvi89d4pn/LHb5SmiIj9+dS+ySPHSpldIwnqofSrSNSRt1rcS/F0ud
lmF/H/yUN7+GBq1RfwOx+K2qSdtEw21hrJZ4rqPOueQFDblr0oTE1ydEIzYK
Gp6YODvOwdoFL2/KUdLwqO/hMPG8vCzsUDcNA3c52cQL9/PFgYM0zDE9KyN2
p/mHNQ/RcHWNVxbR3neGs4cGd4h/G0IsufNro9NHGppMlmiIPUlu4uJRGlIi
n9QRHRhtqNUEDXXy2EziXt01XqaOhhhv6xBiaU3Ux6kp3KmxajFF2cD/IQRa
IQ==
        "]]},
      Annotation[#, "Charting`Private`Tag$5645#2"]& ], 
     TagBox[
      {RGBColor[0, 1, 0], AbsoluteThickness[1.6], Opacity[1.], 
       LineBox[CompressedData["
1:eJwVjHk01Hsfx6eJZKnJWH4TQi63JEmoEN/PTRsl3UKpRNYWpYgs9xblQR4n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        "]]},
      Annotation[#, "Charting`Private`Tag$5645#3"]& ], 
     TagBox[
      {RGBColor[0, 0, 1], AbsoluteThickness[1.6], Opacity[1.], 
       LineBox[CompressedData["
1:eJwV1Xk41PsXB/DJSGW5wzC+Y4yxzDeh1c0Wmc/5JSpbimw3S2LK/SVESF3h
+tGmhLIl+04uiWwtuEmZS5bGGoZGSWSJyHLn98d5zvN63n+d5zzPOcpu3sc9
hAgEQoyg/t9d9zyLepfexWoxSW1+waxGy7vKOds2uiJltm6RFFEE8v1ir8yf
9UX0ktKNr0tFoaPNjHyiLRgZfH9Gt3OVgLV7Ql19tHBUeWVsy7bDJJA5OMQQ
+ycSLXKmGddPSYL6bK2nQdhNVNOep1myIgmKVuZ92rQYpKOWEqgWKgUaeTXr
HL9YZKe2OHdsVgq01tS2sjnxSLOhqJZlRwZ0IsF0TTUBnY+bH6kqI4Np8Uaf
+6FJCPZEzVcTpcGG6H9vV18Kig41vFlnKQ0ujryaV3sfoqx2ovBgnDToRwyF
X/bLQKMZGjEvSTLwovT+vUPpmairm/yq8ZAMGPdb5EtzspDUUg/L/4oMWP1a
xylSzUU3Vns3HB+UgW4nv+FA6zxUzT5zS0aUAo7XNeaMQvNR5vetAU+0KOAx
nEgd6C1EQWl3xU9EUGBCzGp7vkgxkiZrBucUUMBHdxPLf28JUntU3HGJQ4Hg
2xdPi0eXIqd0X7qylCwcZqjbMZTKUVjxoM/kDVkQq4hwjagsR8lpEbHLubLw
z5Fhzwnzx8iXc7BRs0EWrC8mXKm8VIGiI7VJFguy4Ny6MdOysxKJiBn/96Qt
Bkpup4oqPKtQ+NICY+QcBqOLdRU0wlOk71yQ3x+OwVmmfzN/RzUyIP9QNS/B
wC+YNxkSWYtsjMmRT1cw0JFkLYzR61D0urxtNIkKP3KS1k0f1yHhIdW+DSpU
CHlnRcaG69F3rZIdvcZUOBg/lMKlv0DGdokX065T4egXi5feAQ1oqudq2ixR
DsZOz03H1zUgEUe3VD0pOQgeSGTUCDWirf/5SDvKkINczuhl4TuN6In+nY+z
unKwUnpJJymvCdV8d5zV9ZSDfP+cooaeV6jGcPuXrCY5YH017RtnNAv2X+IY
1CYHnR7fNkt4NKNw80feO/vkYM3WgG0304zC0Hv2/mk5OLHvndLklhbUuFaP
CFQaCK2t3KMYvEVu1BaJbHcaJAZkNumHvUXamqqnOV402Dl9aM6l+S2yXicF
DwfQwH441qrQuhWdh+Csv6/RoLRBTQyd46AvplN6CUU0OBllE3o2tQ357HKh
FXylwW+bbZ8Mrr9Dm8Ja72R4yEMP9nv1x60dCHdzJIGXPNhsC6n/ataBOF0R
F9r85cHSJPfv1YQO9FK7r/fln/IAEQvdCns6UduZPxJ+psuDKiFhwcm1CwnX
FI/N9MjD7CJX98OL90iyZDhXHejgvWnSgM9/j/Smx02NTegwKUuAKXEuWo09
zrYzp8NHbbXDa/ZcVDkyE+JiT4cevyB7xgwXvf78R5CQDx3qp6mXnJV7kcdX
T25RKh2ujTvUfAjrR+LdWVd15ugwxPHsdMnpR+eaj7xdWaSDTsWlyeHX/aiA
Q3auX6HDaGgSY5Q0gLRWC2N3iigAi9YbPp46gPZh156/pSrAd3N7s2/Vg6gy
xv+5qKECuJXbDmyYHULuuCOPH6YAD5+pXyVr8lAOceaO4boCGEe1Z186wEPl
DpXGfUIMmDwa+GbYmofGvBba/UQYoD/SRCkN4KF39MKrqRIM4BJdi83qeOia
UvLwW3kGSB653xtxaBT1+j6NTdJlQHinkNai0xgKcmd30L0Y4PGp/1P/DT7S
9zc9V9vOgFzH0ab6VD46zX7Mmu9kAL91Ij3tL0G+5pqhwWUAu2zJ/vR7Pir9
mbwtZlDgYKxlQnkcJen157AmBBa3Llh6Oo4o7F/rdxAV4eyeN57Y+CfU96BT
g71XEX4Pejpx3OgLCnF/M/UzWhHKR0m3Jgun0XPn/Id8shKk9L3mJenNIrDW
Uz35mxJ0XXDPiomZRyFUNdvpZCUoDap/TH2xgMpuBvp8bVeC/LLtMYuMJbRf
XC64S0QZjOzt6s6c+InGCRZh17SVYVUzsWJX7SpyqKrJHHBXhoRBh7NjogTY
fiDleGSMMhAcTBjLzA0wQamtUqhShh9ehvq1NkJg6bd8+dsHZXi5T3rtoC8R
7MP9LwYKqYCx03trvWvCEJA5y59iqoADLZvErdwItZ789lETFWDdtvJjvROB
L9SGQje2CpSnbDI8RtwMBVORo15RKjBCKE7k7N4CxLg35rxcgem7H5APi8I6
mbXTu1EFfDrqNhKDxEDc3KsqbUQF2lnqWF2cOMR2aopuW1WBSaE/az4USMBn
3QXWfYwJCa7jjcXcX+D6V65X5V4mSF/UuGg0Q4IHhqd2XbZgwh2p/a8O3JWE
AKHC1LmzTFgz6tj6WlHwZ/af69cOZ4KpiotleJEU+K/qVGcnM8HZYkadbEQG
JbUDV9ormNDXecEhsp0MhVwn44VWJjDylgzaPaXh401K1gCfCUg1cNySIAOa
ebdUJQg4tBDG+GW3ZIBkkC/vhOEgr2abNIFT4JR9Y3HgHhy6C6vSNj2mQK5t
imjTIRy8ekneDixZINYS4q8649Bq4zUT2i0LGSZxWZKBOMRvr2m+5YYBX2b+
yJdoHLo++8cLeWDg+EhB99htHGTyd58KOoPB5g92zCqB7+E5y6cFdz64R3gp
/A4O9xVidhoEYJBM9U2i3cUhkcSO+3wdg5BfpP46Eo/DgzkpF5MyDGRP2UJe
Mg4DZa3b6x5jMFUyRJZIwYHuE/VDsxKDK99Kxy4InDq5clehFoMLlB2RrAc4
PPw43jTfhMEBsYYX3ak4pHPrNbJ6MNjrNUgRzsBh+F7QIrUfgxqx9EFPgZVs
9jbdHsRA639N2W0CZ7TnOwXzMPhUu08zJROHzJa4mGOTGISThY1+zcaBF2Xp
1DyFgaK7sEiiwComWzQMZzB4P+P3elXgrIaQRrUFDF6dzzNrycFhLHRfzMMf
GGhUnBffnYsDjuZPyvzEgMArao0X2H31kfqNVcF8ma63lgXOrvVcWF/HwDvj
tplrHg7/Akh0FXw=
        "]]},
      Annotation[#, "Charting`Private`Tag$5645#4"]& ]}, {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{-1, 6}, {-1.2731410489519774`, 10.488409571341176`}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.7935091489823256`*^9},
 CellLabel->"Out[45]=",ExpressionUUID->"7f1a255d-5455-44c0-864b-2097b9acad0c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{"k", "+", 
    RowBox[{"ProductLog", "[", 
     RowBox[{
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "k"}], "+", "\[Eta]"}]], " ", "k"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"\[Eta]", ",", 
     RowBox[{"-", "Infinity"}], ",", "2"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.79350920002712*^9, 3.793509230189028*^9}},
 CellLabel->"In[48]:=",ExpressionUUID->"9224b7a6-0417-494d-b68b-bd1b0b5828ee"],

Cell[BoxData[
 RowBox[{"k", "+", 
  RowBox[{
   SuperscriptBox["\[ExponentialE]", 
    InterpretationBox[
     RowBox[{"\[Eta]", "-", "k", "+", 
      InterpretationBox[
       SuperscriptBox[
        RowBox[{"O", "[", 
         FractionBox["1", "\[Eta]"], "]"}], "3"],
       SeriesData[$CellContext`\[Eta], 
        DirectedInfinity[-1], {}, -1, 3, 1],
       Editable->False]}],
     SeriesData[$CellContext`\[Eta], 
      DirectedInfinity[-1], {1, -$CellContext`k}, -1, 3, 1],
     Editable->False]], " ", "k"}], "-", 
  RowBox[{
   SuperscriptBox["\[ExponentialE]", 
    InterpretationBox[
     RowBox[{
      RowBox[{"2", " ", "\[Eta]"}], "-", 
      RowBox[{"2", " ", "k"}], "+", 
      InterpretationBox[
       SuperscriptBox[
        RowBox[{"O", "[", 
         FractionBox["1", "\[Eta]"], "]"}], "3"],
       SeriesData[$CellContext`\[Eta], 
        DirectedInfinity[-1], {}, -1, 3, 1],
       Editable->False]}],
     SeriesData[$CellContext`\[Eta], 
      DirectedInfinity[-1], {2, (-2) $CellContext`k}, -1, 3, 1],
     Editable->False]], " ", 
   SuperscriptBox["k", "2"]}], "+", 
  RowBox[{
   FractionBox["3", "2"], " ", 
   SuperscriptBox["\[ExponentialE]", 
    InterpretationBox[
     RowBox[{
      RowBox[{"3", " ", "\[Eta]"}], "-", 
      RowBox[{"3", " ", "k"}], "+", 
      InterpretationBox[
       SuperscriptBox[
        RowBox[{"O", "[", 
         FractionBox["1", "\[Eta]"], "]"}], "3"],
       SeriesData[$CellContext`\[Eta], 
        DirectedInfinity[-1], {}, -1, 3, 1],
       Editable->False]}],
     SeriesData[$CellContext`\[Eta], 
      DirectedInfinity[-1], {3, (-3) $CellContext`k}, -1, 3, 1],
     Editable->False]], " ", 
   SuperscriptBox["k", "3"]}], "-", 
  RowBox[{
   FractionBox["8", "3"], " ", 
   SuperscriptBox["\[ExponentialE]", 
    InterpretationBox[
     RowBox[{
      RowBox[{"4", " ", "\[Eta]"}], "-", 
      RowBox[{"4", " ", "k"}], "+", 
      InterpretationBox[
       SuperscriptBox[
        RowBox[{"O", "[", 
         FractionBox["1", "\[Eta]"], "]"}], "3"],
       SeriesData[$CellContext`\[Eta], 
        DirectedInfinity[-1], {}, -1, 3, 1],
       Editable->False]}],
     SeriesData[$CellContext`\[Eta], 
      DirectedInfinity[-1], {4, (-4) $CellContext`k}, -1, 3, 1],
     Editable->False]], " ", 
   SuperscriptBox["k", "4"]}]}]], "Output",
 CellChangeTimes->{{3.793509207985388*^9, 3.793509230570879*^9}},
 CellLabel->"Out[48]=",ExpressionUUID->"3ae77829-005e-41f9-b62c-16bba97890f5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Block", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"k", "=", 
     RowBox[{"2", "/", "3"}]}], "}"}], ",", 
   RowBox[{"LogPlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"k", "+", 
        RowBox[{"ProductLog", "[", 
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "k"}], "+", "\[Eta]"}]], " ", "k"}], "]"}]}], ",", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"\[Eta]", "\[LessEqual]", "k"}], ",", "k", ",", 
         RowBox[{"\[Eta]", "+", 
          RowBox[{"Exp", "[", 
           RowBox[{"k", "-", "\[Eta]"}], "]"}], "-", "1"}]}], " ", "]"}], ",", 
       RowBox[{"k", "+", 
        RowBox[{"1", "/", "2"}], "+", 
        RowBox[{"ProductLog", "[", 
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"-", "k"}], "+", "\[Eta]", "-", 
            RowBox[{"1", "/", "2"}]}]], " ", 
          RowBox[{"(", 
           RowBox[{"k", "+", 
            RowBox[{"1", "/", "2"}]}], ")"}]}], "]"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Eta]", ",", 
       RowBox[{"-", "12"}], ",", "33"}], "}"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Red", ",", "Black", ",", "Blue"}], "}"}]}]}], "]"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.793509382979137*^9, 3.7935094569152975`*^9}, {
   3.793509713083112*^9, 3.793509727888795*^9}, {3.793509767209875*^9, 
   3.7935097941220055`*^9}, {3.793509917337926*^9, 3.7935099429197917`*^9}, {
   3.793510030688527*^9, 3.793510151998204*^9}, {3.7935102042560167`*^9, 
   3.793510264759437*^9}, {3.7935103164783926`*^9, 3.7935104115485306`*^9}, 
   3.7935109233320923`*^9},
 CellLabel->
  "In[114]:=",ExpressionUUID->"487824bd-b09e-4259-8e8e-3d4df4651bf0"],

Cell[BoxData[
 GraphicsBox[{{{{}, {}, 
     TagBox[
      {RGBColor[1, 0, 0], AbsoluteThickness[1.6], Opacity[1.], 
       LineBox[CompressedData["
1:eJwd1nk41U8XAHD7cu3Zru26ri0RRZaEO0nK0kIlpaQSSmXNli2UNtKCChES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        "]]},
      Annotation[#, "Charting`Private`Tag$560342#1"]& ], 
     TagBox[
      {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
       LineBox[CompressedData["
1:eJxTTMoPSmViYGCQAGIQfdND/+H//+oHfGbsf6P8+eZ+H7aZKx/IIvgHDjMV
HbRWg/O9FitsrAhUgfM11faWrG1XgvPLzWUU7h5TgPMvRHV/ZjkgC+dH995e
72UsBefrdB44UR0lBuffXqi1cdFkITg/jUnFtVOaD85fFCzzcHE5G5yfkCIn
l7n6334Y/+MUiR2J6z/A+XNXxrnVGOyA86ed8q6Za3HAHsb/W/K4d4/LNTj/
ms2h0s8Rd+H8iKYLelPNHsH5wdFnuGUkH8P5fiYnXiz6jeCfUXALf5bzBM73
5D1yVPMegn/jzQrXE/cRfAB6deBm
        "]], LineBox[CompressedData["
1:eJwVlGk81Isehw2h8aeDLLmt9jqyMxjq9yOynTmlUlMNabGUThJdZC1ZbuJa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        "]]},
      Annotation[#, "Charting`Private`Tag$560342#2"]& ], 
     TagBox[
      {RGBColor[0, 0, 1], AbsoluteThickness[1.6], Opacity[1.], 
       LineBox[CompressedData["
1:eJwV1nk41F8XAHBkH7LvjDGWyVKRLD/bvQllq5SiTSpbqUQUsrVqMylSihKS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        "]]},
      Annotation[#, 
       "Charting`Private`Tag$560342#3"]& ], {}}, {{}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}}, {{}, {}, {}, {}, {}, {}, {}, {}, {}, {}}}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, -0.4054651081081644},
  CoordinatesToolOptions:>{"DisplayFunction" -> ({
      Part[#, 1], 
      Exp[
       Part[#, 2]]}& ), "CopiedValueFunction" -> ({
      Part[#, 1], 
      Exp[
       Part[#, 2]]}& )},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Quiet[
      Charting`ScaledTicks[{Log, Exp}][#, #2, {6, 6}]]& , 
     Charting`ScaledFrameTicks[{Log, Exp}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None},
  PlotRange->{{-12, 33}, {-0.4054651081081644, 3.465735874100747}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->FrontEndValueCache[{Automatic, Quiet[
      Charting`ScaledTicks[{Log, Exp}][#, #2, {6, 6}]]& }, {Automatic, {{0., 
       FormBox["1", TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {1.6094379124341003`, 
       FormBox["5", TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {2.302585092994046, 
       FormBox["10", TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {-0.6931471805599453, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-0.5108256237659907, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-0.35667494393873245`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-0.2231435513142097, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-0.10536051565782628`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {0.6931471805599453, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {1.0986122886681098`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {1.3862943611198906`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {1.791759469228055, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {1.9459101490553132`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {2.0794415416798357`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {2.1972245773362196`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {2.995732273553991, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {3.4011973816621555`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {3.6888794541139363`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {3.912023005428146, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {4.0943445622221, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {4.248495242049359, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {4.382026634673881, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {4.499809670330265, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {4.605170185988092, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {4.700480365792417, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {4.787491742782046, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {4.867534450455582, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {4.941642422609304, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {5.0106352940962555`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {5.075173815233827, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}}}]]], "Output",
 CellChangeTimes->{{3.793509405281557*^9, 3.793509457117481*^9}, {
   3.7935097155283422`*^9, 3.793509728773608*^9}, {3.793509778218932*^9, 
   3.7935097944428015`*^9}, {3.7935099269897566`*^9, 3.793509943191038*^9}, {
   3.793510031986725*^9, 3.7935101523104877`*^9}, {3.7935102144924088`*^9, 
   3.7935102651227674`*^9}, {3.79351031682771*^9, 3.793510411828785*^9}, 
   3.7935109236824117`*^9},
 CellLabel->"Out[114]=",ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"],ExpressionUUID->"b6361193-df52-4f7f-82ec-990acb54c718"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"D", "[", 
  RowBox[{
   RowBox[{"k", "+", 
    RowBox[{"ProductLog", "[", 
     RowBox[{
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "k"}], "+", "\[Eta]"}]], " ", "k"}], "]"}]}], ",", 
   "\[Eta]"}], "]"}]], "Input",
 CellChangeTimes->{{3.7935094818891487`*^9, 3.7935094965226297`*^9}, {
  3.793509808512641*^9, 3.7935098132094316`*^9}},
 CellLabel->"In[70]:=",ExpressionUUID->"90fb37c4-5fd2-41fc-9798-588df55b27f4"],

Cell[BoxData[
 FractionBox[
  RowBox[{"ProductLog", "[", 
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{
      RowBox[{"-", "k"}], "+", "\[Eta]"}]], " ", "k"}], "]"}], 
  RowBox[{"1", "+", 
   RowBox[{"ProductLog", "[", 
    RowBox[{
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{"-", "k"}], "+", "\[Eta]"}]], " ", "k"}], "]"}]}]]], "Output",
 CellChangeTimes->{
  3.7935095014112215`*^9, 3.7935098146057005`*^9, {3.7935098503540726`*^9, 
   3.7935098644049397`*^9}},
 CellLabel->"Out[70]=",ExpressionUUID->"34d6fd3e-dfd9-4156-804d-90ec2790b2bc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Log", "[", 
  RowBox[{"2.", "^", 
   RowBox[{"-", "26"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.793516903922715*^9, 3.793516939040867*^9}},
 CellLabel->
  "In[148]:=",ExpressionUUID->"9e5bc734-3435-4bc4-9c3c-afcee7f39a14"],

Cell[BoxData[
 RowBox[{"-", "18.021826694558577`"}]], "Output",
 CellChangeTimes->{{3.793516906778829*^9, 3.7935169393336363`*^9}},
 CellLabel->
  "Out[148]=",ExpressionUUID->"5e5c4c86-6608-4e73-a86a-733230932c22"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Block", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"k", "=", 
      RowBox[{"-", "0.999"}]}], ",", 
     RowBox[{"\[Theta]", "=", "0.1"}], ",", 
     RowBox[{"\[Eta]", "=", "0"}]}], "}"}], ",", 
   RowBox[{"LogLogPlot", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"x", "^", "k"}], " ", "/", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{"Exp", "[", 
           RowBox[{"x", "-", "\[Eta]"}], "]"}]}], ")"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"x", "^", "k"}], " ", 
        RowBox[{
         RowBox[{"Sqrt", "[", 
          RowBox[{"1", "+", 
           RowBox[{"\[Theta]", " ", 
            RowBox[{"x", "/", "2"}]}]}], "]"}], "/", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           RowBox[{"Exp", "[", 
            RowBox[{"x", "-", "\[Eta]"}], "]"}]}], ")"}]}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"x", "^", "k"}], " ", 
        RowBox[{"Sqrt", "[", 
         RowBox[{"1", "+", 
          RowBox[{"\[Theta]", " ", 
           RowBox[{"x", "/", "2"}]}]}], "]"}]}]}], "\[IndentingNewLine]", 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", "12"}], "}"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Red", ",", "Blue", ",", "Black"}], "}"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7938716868480844`*^9, 3.7938718063593955`*^9}, {
  3.793871873613948*^9, 3.7938719102849665`*^9}},
 CellLabel->"In[34]:=",ExpressionUUID->"1bd2c7e9-d69e-449e-b4a5-309a64a7a325"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[1, 0, 0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwB4QQe+yFib1JlAgAAAE0AAAACAAAAorvQVkjJEcDKG++l2/ENQIRhaw4b
xxHARP4Gn3vtDUBmBwbG7cQRwLRghJQb6Q1AK1M7NZPAEcCtsqd0W+ANQLTq
pRPetxHANqlYCdvODUDGGXvQc6YRwDYooYLZqw1A63clSp+DEcC5MHum02UN
QDQ0ej32PRHACin3PLzZDEBSeRIa7KYQwCge3dbBqQtAFlGTTeQZEMC0fsAX
m40KQO7yUm9BHw/AFMYPd692CUDJ3FwvSvMNwM4osX6uRwhA8Os3nVfbDMDP
ETNmaywHQDCU8Pb0qwvAZu3rLtb4BUCr3dO9GoIKwOzAhzEnygRAcUyIMkVs
CcBZSu/NE68DQFBUGpP/PgjADy/EEjF7AkB7gX2hviUHwKaoR8vAWgFA4U8L
HQYSBsCoyKVg5D4AQGC3doTd5gTAaye94PQS/j8rRLOZuc8DwHNjRstwzvs/
D2rNmiWhAsBC6G46PlX5Py4xEgkaeAHADAcTOvji9j+YHSglE2MAwMw5gU0L
lvQ/OEY3Wjht/r8TwD+FFhHyP9ebwMVTPPy/iV09m5Ng7z+oIwUJj9z5vwg8
ckS5J+o/7+2eJtuH97/eD1AlUPLkP80C258wW/W/bKCp4UkA4D/dSdLwpf/y
v++jwWAwDtU/hdtrnSTM8L9qeSC4MSzFP0NftUhoR+2/b86bzPuQRz/gawkG
x5jov/Az6hMWhMe/rA2iejg65L/zsn6XCzDXv7gnYj3T+96/9jpfLEsP4r/v
PdXueK/VvxQ4eR50vei/Cf2iHYgGyr9tCdArbVTvvw4/1G103Ky/Pg9dnI55
87+MEU0TBrC0P46RYhSiTPe/og0YXJyOyz+5mv7fvln7v3cAWHgbHtc/65zf
NnMTAMC/zxpUw9TfP3RF/3TmigLAIGt46HWj5D898ymjuIIFwDHZnm93DOk/
AzADpVebCMBXwhpCV1/tPzAceHYW/wvAjSOQsvsH8T9jdx0XnhAQwFabcGhC
OPM/6Bj0lg09EsDt4JVGaZf1P6AzcOvP5RTAD+RlSn/r9z88RmhrddsXwJmc
k/KLF/o//HxJ66z4GsDxIgbDeHL8P+dpaDhFyR7Asl7WN1yl/j9j6jrLd2gh
wP+rKGmXZgBAPL0+EFqiI8CMj4jK8JEBQP96QGX7XibAzU0XfkWpAkB4Stza
a0UpwCRNxsIkrgJAnkVzbTRTKcB6THUHBLMCQI4lSaoEYSnAJkvTkMK8AkCe
Alk1vHwpwIBIj6M/0AJA1tY/FIi0KcA0QwfJOfcCQBoKdxiXJSrAmzj3Ey5F
A0CxeYPwsw0rwPI3plgNSgNAbMivC3scK8BIN1Wd7E4DQEbX+2tKKyvA9DWz
JqtYA0D2ZRoQAkkrwE4zbzkobANAi+UxdNWEK8ACLudeIpMDQPJJGCQR/ivA
WC2WowGYA0D9wFL0Xg0swK8sRejgnANApda1W7UcLMBcK6Nxn6YDQKdB5wR8
OyzAtihfhBy6A0B2a0VUcXkswAwoDsn7vgNAGMD8cASJLMBjJ70N28MDQIqM
E0+gmCzAECYbl5nNA0Dyx7hk8rcswGYlytt40gNAFAf8pqjHLMC8JHkgWNcD
QCliCMBn1yzAEiQoZTfcA0BvfEC1L+cswGkj16kW4QNAeUcKjAD3LMC1aDn1

       "]]},
     Annotation[#, "Charting`Private`Tag$865626#1"]& ], 
    TagBox[
     {RGBColor[0, 0, 1], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwB4QQe+yFib1JlAgAAAE0AAAACAAAAorvQVkjJEcDHKQY0dfINQIRhaw4b
xxHAI+q/gBXuDUBmBwbG7cQRwLazDMq16Q1AK1M7NZPAEcDi0ldS9uANQLTq
pRPetxHAnxh/OXfPDUDGGXvQc6YRwO3+ZGB4rA1A63clSp+DEcB0ee8CeGYN
QDQ0ej32PRHAZURlKmzaDEBSeRIa7KYQwJkAcLeNqgtAFlGTTeQZEMCrNaQP
hY4KQO7yUm9BHw/AyuxLPbt3CUDJ3FwvSvMNwGznenvkSAhA8Os3nVfbDMAh
3//Czi0HQDCU8Pb0qwvAYUEjPnL6BUCr3dO9GoIKwIvfE7MDzARAcUyIMkVs
CcDN+cp4NbEDQFBUGpP/PgjApEifHKl9AkB7gX2hviUHwJ1Ztb6VXQFA4U8L
HQYSBsAkfUujIUIAQGC3doTd5gTAfVynxnMa/j8rRLOZuc8DwLvKvk8H1/s/
D2rNmiWhAsD06hPvMV/5Py4xEgkaeAHAR0e3e3ju9j+YHSglE2MAwJS8HaU0
o/Q/OEY3Wjht/r8wlShPUiDyP9ebwMVTPPy/g48I836D7z+oIwUJj9z5v1n/
+3QzUOo/7+2eJtuH978CV6IjGiHlP80C258wW/W/gFJKMdg14D/dSdLwpf/y
v163qnYtitU/hdtrnSTM8L9K2NvrbUjGP0NftUhoR+2/hcEm6ALHhT/gawkG
x5jov6QZ+uCbDMa/rA2iejg65L+nrJduMlnWv7gnYj3T+96/vfGCP/6S4b/v
PdXueK/Vv/mFpIkNLui/Cf2iHYgGyr83WsJNoLDuvw4/1G103Ky/eGJYsvwa
87+MEU0TBrC0P7ryd+OE4Pa/og0YXJyOyz+Yl0Rwh976v3cAWHgbHtc/06zm
WvuY/7+/zxpUw9TfP5/QvJL9OQLAIGt46HWj5D8qhaNTgyUFwDHZnm93DOk/
xf+vnQ0xCMBXwhpCV1/tP6oMDMhLhgvAjSOQsvsH8T9zDctanZYPwFabcGhC
OPM/aya281PuEcDt4JVGaZf1P9c8mvWOixTAD+RlSn/r9z/RGlFqZ3QXwJmc
k/KLF/o/gxCbnTmEGsDxIgbDeHL8P7ggvi6QRB7Asl7WN1yl/j8yWoIupR0h
wP+rKGmXZgBAI3Et0FZOI8CMj4jK8JEBQOEWizfw/yXAzU0XfkWpAkBgCZbd
B9sowCRNxsIkrgJAuatSYZvoKMB6THUHBLMCQE8V+3k29ijAJkvTkMK8AkAm
JaZ8gxEpwIBIj6M/0AJA2sAoSnlIKcA0QwfJOfcCQOBbnSXYtynAmzj3Ey5F
A0B421R4hJwqwPI3plgNSgNAydd20hOrKsBIN1Wd7E4DQNCr5luruSrA9DWz
JqtYA0AD+ccQ89YqwE4zbzkobANAxPDoj+URK8ACLudeIpMDQDi/tVhbiSvA
WC2WowGYA0BkngkJcJgrwK8sRejgnANAaVN5Oo2nK8BcK6Nxn6YDQMdZjzXh
xSvAtihfhBy6A0CB4oAf8AIswAwoDsn7vgNAWviHa0kSLMBjJ70N28MDQH9/
xWKrISzAECYbl5nNA0D/Oy9oiUAswGYlytt40gNAa1kJgQVQLMC8JHkgWNcD
QBC8dVqKXyzAEiQoZTfcA0Brm9P5F28swGkj16kW4QNAo4CFZK5+LMB8P0hO

       "]]},
     Annotation[#, "Charting`Private`Tag$865626#2"]& ], 
    TagBox[
     {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwB4QQe+yFib1JlAgAAAE0AAAACAAAAorvQVkjJEcDa/u55B8URQIRhaw4b
xxHAiKkE6trCEUBmBwbG7cQRwNUYMVquwBFAK1M7NZPAEcDnds46VbwRQLTq
pRPetxHAcI0c/aKzEUDGGXvQc6YRwPYeEYY+ohFA63clSp+DEcC3E7WpdX8R
QDQ0ej32PRHAhHTJOuQ5EUBSeRIa7KYQwFknfLsOoxBAFlGTTeQZEMCF+DcV
OhYQQO7yUm9BHw/Ao+N+l1UYD0DJ3FwvSvMNwAa/pVjV7A1A8Os3nVfbDMBy
QCjRV9UMQDCU8Pb0qwvAdPr0h3umC0Cr3dO9GoIKwHqtOwEufQpAcUyIMkVs
CcDuVWO/5GcJQFBUGpP/PgjATpgdn0I7CEB7gX2hviUHwC43UZemIgdA4U8L
HQYSBsA697n3nA8GQGC3doTd5gTAbtocJUPlBEArRLOZuc8DwO+fXX/yzgNA
D2rNmiWhAsCpWlCOWqECQC4xEgkaeAHAfBs8TmF5AUCYHSglE2MAwA+OiuB1
ZQBAOEY3Wjht/r9NkssZqnT+P9ebwMVTPPy/g9j+/Y5G/D+oIwUJj9z5v8Yk
WkQt6vk/7+2eJtuH979W1FkKOpn3P80C258wW/W/89XoLYBw9T/dSdLwpf/y
vykPQB7IGfM/hdtrnSTM8L8K4rZNX+vwP0NftUhoR+2/VIxeQiGR7T/gawkG
x5jovzlNKplZ8Og/rA2iejg65L8otTdvd6DkP7gnYj3T+96/MtICi37s3z/v
PdXueK/Vv/gnM+u4yNY/Cf2iHYgGyr9EQCz6EY/MPw4/1G103Ky/FN9RHqdT
tD+MEU0TBrC0P98Y2njO0au/og0YXJyOyz94GU/j0q3Hv3cAWHgbHtc/Azvh
I4Tg1L+/zxpUw9TfP0QksixWRd2/IGt46HWj5D+fWH8ZWCnjvzHZnm93DOk/
Z77puuVc579XwhpCV1/tP5vb5JSndOu/jSOQsvsH8T87LKnHw9zvv1abcGhC
OPM/PPxZRXD48b/t4JVGaZf1PzrX0WreKPS/D+RlSn/r9z/NhoWoJ0n2v5mc
k/KLF/o/NKYUxRA/+L/xIgbDeHL8P7nVS0xcWPq/sl7WN1yl/j/OvIro7kb8
v/+rKGmXZgBAYrf/I68k/r+Mj4jK8JEBQOUnqppEEQDAzU0XfkWpAkAHMbuN
7voAwCRNxsIkrgJAk9OzV/j+AMB6THUHBLMCQOj/X8wBAwHAJkvTkMK8AkB+
1pC1EwsBwIBIj6M/0AJAYAuIhTMbAcA0QwfJOfcCQFHYjQ1jOwHAmzj3Ey5F
A0AjdFpOgXsBwPI3plgNSgNAOTCTT4B/AcBIN1Wd7E4DQKpKhPl+gwHA9DWz
JqtYA0AuUFNHe4sBwE4zbzkobANA1EcByW+bAcACLudeIpMDQPIdq1dIuwHA
WC2WowGYA0AvxHLdQb8BwK8sRejgnANAYUcHCzvDAcBcK6Nxn6YDQFDAXV0s
ywHAtihfhBy6A0DtUjPdCtsBwAwoDsn7vgNAiF3UnwHfAcBjJ70N28MDQA5O
0Qn44gHAECYbl5nNA0DpXafT4+oBwGYlytt40gNAzNxkM9nuAcC8JHkgWNcD
QMkARzrO8gHAEiQoZTfcA0DZGkDowvYBwGkj16kW4QNATIlCPbf6AcAJIUOa

       "]]},
     Annotation[#, "Charting`Private`Tag$865626#3"]& ]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{-4.446565014352844, -14.48242604852179},
  CoordinatesToolOptions:>{"DisplayFunction" -> ({
      Exp[
       Part[#, 1]], 
      Exp[
       Part[#, 2]]}& ), "CopiedValueFunction" -> ({
      Exp[
       Part[#, 1]], 
      Exp[
       Part[#, 2]]}& )},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Quiet[
      Charting`ScaledTicks[{Log, Exp}][#, #2, {6, 6}]]& , 
     Charting`ScaledFrameTicks[{Log, Exp}]}, {Quiet[
      Charting`ScaledTicks[{Log, Exp}][#, #2, {6, 6}]]& , 
     Charting`ScaledFrameTicks[{Log, Exp}]}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None},
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->FrontEndValueCache[{Quiet[
      Charting`ScaledTicks[{Log, Exp}][#, #2, {6, 6}]]& , Quiet[
      Charting`ScaledTicks[{Log, Exp}][#, #2, {6, 
       6}]]& }, {{{-2.995732273553991, 
       FormBox[
        TagBox[
         InterpretationBox["\"0.05\"", 0.05, AutoDelete -> True], 
         NumberForm[#, {
           DirectedInfinity[1], 2}]& ], TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {-2.3025850929940455`, 
       FormBox[
        TagBox[
         InterpretationBox["\"0.10\"", 0.1, AutoDelete -> True], 
         NumberForm[#, {
           DirectedInfinity[1], 2}]& ], TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {-0.6931471805599453, 
       FormBox[
        TagBox[
         InterpretationBox["\"0.50\"", 0.5, AutoDelete -> True], 
         NumberForm[#, {
           DirectedInfinity[1], 2}]& ], TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {0., 
       FormBox["1", TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {1.6094379124341003`, 
       FormBox["5", TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {2.302585092994046, 
       FormBox["10", TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {-5.298317366548036, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-5.115995809754082, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-4.961845129926823, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-4.8283137373023015`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-4.710530701645918, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-4.605170185988091, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-3.912023005428146, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-3.506557897319982, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-3.2188758248682006`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-2.8134107167600364`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-2.659260036932778, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-2.5257286443082556`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-2.4079456086518722`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-1.6094379124341003`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-1.2039728043259361`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-0.916290731874155, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-0.5108256237659907, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-0.35667494393873245`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-0.2231435513142097, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-0.10536051565782628`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {0.6931471805599453, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {1.0986122886681098`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {1.3862943611198906`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {1.791759469228055, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {1.9459101490553132`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {2.0794415416798357`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {2.1972245773362196`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {2.995732273553991, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {3.4011973816621555`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {3.6888794541139363`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {3.912023005428146, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {4.0943445622221, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {4.248495242049359, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {4.382026634673881, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {4.499809670330265, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {4.605170185988092, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {4.700480365792417, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {4.787491742782046, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {4.867534450455582, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {4.941642422609304, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {5.0106352940962555`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {5.075173815233827, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}}, {{-11.512925464970229`, 
       FormBox[
        TemplateBox[{"10", 
          RowBox[{"-", "5"}]}, "Superscript", SyntaxForm -> SuperscriptBox], 
        TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {-6.907755278982137, 
       FormBox["0.001`", TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {-2.3025850929940455`, 
       FormBox[
        TagBox[
         InterpretationBox["\"0.100\"", 0.1, AutoDelete -> True], 
         NumberForm[#, {
           DirectedInfinity[1], 3}]& ], TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {2.302585092994046, 
       FormBox["10", TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {-16.11809565095832, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-13.815510557964274`, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-9.210340371976182, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-4.605170185988091, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {0., 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {4.605170185988092, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {6.907755278982137, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {7.313220387090301, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {7.600902459542082, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {7.824046010856292, 
       FormBox[
        TemplateBox[{0., 0.}, "Spacer2"], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}}}]]], "Output",
 CellChangeTimes->{{3.793871728060296*^9, 3.7938718067242317`*^9}, {
  3.793871892204941*^9, 3.7938719106668177`*^9}},
 CellLabel->"Out[34]=",ExpressionUUID->"e2cac587-6884-466a-9729-dd23de44ed52"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"kVALS", "[", 
  RowBox[{"[", 
   RowBox[{"1", ";;", "20"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.793872493344982*^9, 3.793872502127005*^9}},
 CellLabel->"In[38]:=",ExpressionUUID->"79ea98bf-a36e-4a3b-88dc-96b4bc779a93"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"4", ",", "2", ",", "1", ",", 
   FractionBox["1", "2"], ",", "0", ",", 
   RowBox[{"-", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{"-", 
    FractionBox["3", "5"]}], ",", 
   RowBox[{"-", 
    FractionBox["7", "10"]}], ",", 
   RowBox[{"-", 
    FractionBox["4", "5"]}], ",", 
   RowBox[{"-", 
    FractionBox["9", "10"]}], ",", 
   RowBox[{"-", 
    FractionBox["91", "100"]}], ",", 
   RowBox[{"-", 
    FractionBox["23", "25"]}], ",", 
   RowBox[{"-", 
    FractionBox["93", "100"]}], ",", 
   RowBox[{"-", 
    FractionBox["47", "50"]}], ",", 
   RowBox[{"-", 
    FractionBox["19", "20"]}], ",", 
   RowBox[{"-", 
    FractionBox["24", "25"]}], ",", 
   RowBox[{"-", 
    FractionBox["97", "100"]}], ",", 
   RowBox[{"-", 
    FractionBox["49", "50"]}], ",", 
   RowBox[{"-", 
    FractionBox["99", "100"]}], ",", 
   RowBox[{"-", 
    FractionBox["999", "1000"]}]}], "}"}]], "Output",
 CellChangeTimes->{{3.79387249527274*^9, 3.7938725024478006`*^9}},
 CellLabel->"Out[38]=",ExpressionUUID->"aad86b6b-d4be-461b-828f-6fb244944ac5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"x", "^", "k"}], "/", 
    RowBox[{"(", 
     RowBox[{"1", "+", 
      RowBox[{"Exp", "[", 
       RowBox[{"x", "-", "\[Eta]"}], "]"}]}], ")"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "Infinity"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{3.7938726662694664`*^9},
 CellLabel->"In[43]:=",ExpressionUUID->"30bca7b7-eb7c-4637-a784-d3719a75b5ab"],

Cell[BoxData[
 RowBox[{"ConditionalExpression", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     RowBox[{"Gamma", "[", 
      RowBox[{"1", "+", "k"}], "]"}]}], " ", 
    RowBox[{"PolyLog", "[", 
     RowBox[{
      RowBox[{"1", "+", "k"}], ",", 
      RowBox[{"-", 
       SuperscriptBox["\[ExponentialE]", "\[Eta]"]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"Re", "[", "k", "]"}], ">", 
    RowBox[{"-", "1"}]}]}], "]"}]], "Output",
 CellChangeTimes->{3.7938726683658733`*^9},
 CellLabel->"Out[43]=",ExpressionUUID->"63c55702-3288-47ac-85d6-4a198d47efb5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AsymptoticIntegrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"x", "^", "k"}], "/", 
    RowBox[{"(", 
     RowBox[{"1", "+", 
      RowBox[{"Exp", "[", 
       RowBox[{"x", "-", "\[Eta]"}], "]"}]}], ")"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "Infinity"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", 
     RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7938719421170664`*^9, 3.7938719779879003`*^9}, {
  3.7938720626291695`*^9, 3.7938720783479896`*^9}},
 CellLabel->"In[36]:=",ExpressionUUID->"e76cf6e3-8fd7-4cda-ab69-8e30668e2070"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox[
    RowBox[{
     SuperscriptBox["\[ExponentialE]", "\[Eta]"], " ", "EulerGamma"}], 
    RowBox[{"1", "+", 
     SuperscriptBox["\[ExponentialE]", "\[Eta]"]}]]}], "+", 
  FractionBox[
   SuperscriptBox["\[ExponentialE]", "\[Eta]"], 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "+", 
      SuperscriptBox["\[ExponentialE]", "\[Eta]"]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{"1", "+", "k"}], ")"}]}]], "-", 
  RowBox[{
   SuperscriptBox["PolyLog", 
    TagBox[
     RowBox[{"(", 
      RowBox[{"1", ",", "0"}], ")"}],
     Derivative],
    MultilineFunction->None], "[", 
   RowBox[{"0", ",", 
    RowBox[{"-", 
     SuperscriptBox["\[ExponentialE]", "\[Eta]"]}]}], "]"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "+", "k"}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{
       SuperscriptBox["\[ExponentialE]", "\[Eta]"], " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["EulerGamma", "2"], "+", 
         FractionBox[
          SuperscriptBox["\[Pi]", "2"], "6"]}], ")"}]}], 
      RowBox[{"2", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         SuperscriptBox["\[ExponentialE]", "\[Eta]"]}], ")"}]}]], "+", 
     RowBox[{"EulerGamma", " ", 
      RowBox[{
       SuperscriptBox["PolyLog", 
        TagBox[
         RowBox[{"(", 
          RowBox[{"1", ",", "0"}], ")"}],
         Derivative],
        MultilineFunction->None], "[", 
       RowBox[{"0", ",", 
        RowBox[{"-", 
         SuperscriptBox["\[ExponentialE]", "\[Eta]"]}]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{
       SuperscriptBox["PolyLog", 
        TagBox[
         RowBox[{"(", 
          RowBox[{"2", ",", "0"}], ")"}],
         Derivative],
        MultilineFunction->None], "[", 
       RowBox[{"0", ",", 
        RowBox[{"-", 
         SuperscriptBox["\[ExponentialE]", "\[Eta]"]}]}], "]"}]}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{3.793871980028778*^9, 3.793872081260641*^9},
 CellLabel->"Out[36]=",ExpressionUUID->"4d8a4ef8-5c15-4084-afd0-e903cf501b7e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{
            SuperscriptBox["\[ExponentialE]", "\[Eta]"], " ", "EulerGamma"}], 
           
           RowBox[{"1", "+", 
            SuperscriptBox["\[ExponentialE]", "\[Eta]"]}]]}], "+", 
         FractionBox[
          SuperscriptBox["\[ExponentialE]", "\[Eta]"], 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["\[ExponentialE]", "\[Eta]"]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{"1", "+", "k"}], ")"}]}]]}], ")"}], ",", 
       RowBox[{
        RowBox[{"fFermi", "[", 
         RowBox[{"k", ",", "1", ",", "0"}], "]"}], "+", 
        RowBox[{
         RowBox[{"Gamma", "[", 
          RowBox[{"1", "+", "k"}], "]"}], " ", 
         RowBox[{"PolyLog", "[", 
          RowBox[{
           RowBox[{"1", "+", "k"}], ",", 
           RowBox[{"-", 
            SuperscriptBox["\[ExponentialE]", "\[Eta]"]}]}], "]"}]}]}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", 
       RowBox[{"kVALS", "[", 
        RowBox[{"[", 
         RowBox[{"1", ";;", "20"}], "]"}], "]"}]}], "}"}]}], "]"}], "/.", 
   RowBox[{"\[Eta]", "\[Rule]", "0"}]}], "//", "TableForm"}]], "Input",
 CellChangeTimes->{{3.7938725124069767`*^9, 3.793872587223169*^9}, {
  3.7938726206331897`*^9, 3.7938726267817836`*^9}, {3.79387268861738*^9, 
  3.7938727855104265`*^9}},
 CellLabel->"In[49]:=",ExpressionUUID->"32335262-5ba0-4ae6-be6d-717c8c2e0946"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{
      FractionBox["1", "10"], "-", 
      FractionBox["EulerGamma", "2"]}], 
     "37.638575881440827894746073455742137891481199506489172233649035852500636\
428503863250388092959795455699791015593250868521644376357692760512992460028398\
6997437`127.79052090284837"},
    {
     RowBox[{
      FractionBox["1", "6"], "-", 
      FractionBox["EulerGamma", "2"]}], 
     "2.5252458708860102962146673099180453272881621559525451657817794575514651\
489157111702091500979804457044617312183911639909732431528018520344954757282815\
276927`127.76598318188763"},
    {
     RowBox[{
      FractionBox["1", "4"], "-", 
      FractionBox["EulerGamma", "2"]}], 
     "0.9838190370206610384147938435960863849484990669888318215877144426134693\
952547630069347168139670712001678405972036440743874210334314946412694998386180\
094186`127.73612868917043"},
    {
     RowBox[{
      FractionBox["1", "3"], "-", 
      FractionBox["EulerGamma", "2"]}], 
     "0.7182813855134631190073252699849335558928986924511568905859877377985139\
586394937167561961411650651791438275992847136627122182781809188740325547034882\
62276`127.71129245958983"},
    {
     RowBox[{
      FractionBox["1", "2"], "-", 
      FractionBox["EulerGamma", "2"]}], 
     "0.6201145069582775246317633735096790738397799513100931205983835053438012\
795394925053303370792808737038470195657948936677882697394696466323969284982305\
990825`127.67412061680625"},
    {
     RowBox[{"1", "-", 
      FractionBox["EulerGamma", "2"]}], 
     "0.7482564272067713035106188901150742652776217735682134372725194577803906\
789212653619943238198343061247139792390453434811475386675769664467232595652351\
429214`127.61388091962371"},
    {
     RowBox[{
      FractionBox["5", "4"], "-", 
      FractionBox["EulerGamma", "2"]}], 
     "0.8492054249850151632389939106186812766742238169515585558602088404294207\
459255288644140904644338184155768864920870315026997668120109163243702604100808\
236527`127.59711035926915"},
    {
     RowBox[{
      FractionBox["5", "3"], "-", 
      FractionBox["EulerGamma", "2"]}], 
     "1.0288751614962653179442163294400225241847725774721961153138304109036713\
714630821115705339014793034343200990130330608943953930646483016295953306317396\
661106`127.57798266717842"},
    {
     RowBox[{
      FractionBox["5", "2"], "-", 
      FractionBox["EulerGamma", "2"]}], 
     "1.4027435173103650675728297099551650498671610671979343922553789246424812\
429806593705628423744285441699710779202324132598954400992456986915004989727933\
743222`127.5559417713161"},
    {
     RowBox[{"5", "-", 
      FractionBox["EulerGamma", "2"]}], 
     "2.5484550765135390174712942637430164348458080215101099900668591901414883\
323947540351389492477088455468646707024322713695690523817123781716157062507097\
417734`127.53022795865294"},
    {
     RowBox[{
      FractionBox["50", "9"], "-", 
      FractionBox["EulerGamma", "2"]}], 
     "2.8043210808874403944566259609755628121716491501532242862357351397453707\
510821445445294620077592564850911438592237811485425981364193056866021935667002\
004014`127.52741683761359"},
    {
     RowBox[{
      FractionBox["25", "4"], "-", 
      FractionBox["EulerGamma", "2"]}], 
     "3.1243871650723165140962189632160397151028250219704657468591074080475592\
524210400259348687543837872747112456394177448075489255622492524135220885117660\
845713`127.52455738553942"},
    {
     RowBox[{
      FractionBox["50", "7"], "-", 
      FractionBox["EulerGamma", "2"]}], 
     "3.5361604169190859117722154395589229141079356355312361058410281779029567\
113406670351323364929089608662091108264844159663602402333911251838063827049403\
189725`127.52164826754849"},
    {
     RowBox[{
      FractionBox["25", "3"], "-", 
      FractionBox["EulerGamma", "2"]}], 
     "4.0854859163236028583767073739851819140003081586539541421370772024723083\
570253239120221066838426690859122464173161593711465629797316401864065120516301\
354528`127.51868809625354"},
    {
     RowBox[{"10", "-", 
      FractionBox["EulerGamma", "2"]}], 
     "4.8548847180509128073996151149168844452545319413086111964114436997156988\
937375463725174772704189409359387115085595055936993340230447474702351825999173\
574673`127.51567542905633"},
    {
     RowBox[{
      FractionBox["25", "2"], "-", 
      FractionBox["EulerGamma", "2"]}], 
     "6.0093988082299076522104200681804575285471925272649639180507887512061251\
726579304084671873189960305805153563923578621512690105984407101625225715653128\
955475`127.51260876526781"},
    {
     RowBox[{
      FractionBox["50", "3"], "-", 
      FractionBox["EulerGamma", "2"]}], 
     "7.9341259730283342666342401238406719158535159772472585965332071989171345\
068004001254753282680182856783522195490221550867089464638403126762835435145478\
104659`127.50948654304129"},
    {
     RowBox[{"25", "-", 
      FractionBox["EulerGamma", "2"]}], 
     "11.784359272051576080115425106648177726181451122863180417140332931544101\
080361653907382961988473156255105080812339614462045881026117692627663644092681\
5921175`127.50630713610329"},
    {
     RowBox[{"50", "-", 
      FractionBox["EulerGamma", "2"]}], 
     "23.336563349342153880302976114839735224363960237946647877923809211391882\
968049830080870304876859319204815043187686587120771435760586726206944608348441\
5377127`127.50306885026674"},
    {
     RowBox[{"500", "-", 
      FractionBox["EulerGamma", "2"]}], 
     "231.28864742933732812241593896406827398401061060333939921037180189861704\
933199077305384240108602784119109147393993589254318509394160859237`127.\
50010259364605"}
   },
   GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.7938725402860594`*^9, {3.793872570363282*^9, 3.793872591271388*^9}, 
   3.793872631327472*^9, {3.793872696899621*^9, 3.793872778573563*^9}, 
   3.7938728295658855`*^9},
 CellLabel->
  "Out[49]//TableForm=",ExpressionUUID->"585be9d0-04d5-4355-8bde-\
6b77827737e5"]
}, Open  ]]
},
WindowSize->{1600, 1008},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
ShowSelection->True,
Magnification:>FEPrivate`If[
  FEPrivate`Equal[FEPrivate`$VersionNumber, 6.], 1.5, 1.5 Inherited],
FrontEndVersion->"12.0 for Microsoft Windows (64-bit) (April 8, 2019)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Info3593864067-1021897"->{
  Cell[93932, 2341, 183, 4, 68, "Print",ExpressionUUID->"4afd9680-0e77-480e-80c0-38c9571109e3",
   CellTags->"Info3593864067-1021897"],
  Cell[94118, 2347, 1443, 39, 63, "Print",ExpressionUUID->"2d333413-3f7c-44c5-b18c-916598c00369",
   CellTags->"Info3593864067-1021897"]},
 "Info3593864070-1805780"->{
  Cell[110475, 2797, 183, 4, 68, "Print",ExpressionUUID->"e695d451-00f9-447c-9bb3-7e9031f7d72c",
   CellTags->"Info3593864070-1805780"],
  Cell[110661, 2803, 1448, 39, 63, "Print",ExpressionUUID->"be4097ac-03cb-4115-adac-90643a1d1b73",
   CellTags->"Info3593864070-1805780"]},
 "Info3593864072-1805780"->{
  Cell[116763, 2993, 183, 4, 68, "Print",ExpressionUUID->"3d719588-07ec-49c9-a6d6-087f8dfd0a71",
   CellTags->"Info3593864072-1805780"],
  Cell[116949, 2999, 1446, 39, 63, "Print",ExpressionUUID->"38730339-e9c8-434c-8cd6-32e1f67a228d",
   CellTags->"Info3593864072-1805780"],
  Cell[118623, 3050, 562, 14, 68, "Print",ExpressionUUID->"9b73a979-0471-434e-98be-5394f0abc645",
   CellTags->"Info3593864072-1805780"]},
 "Info3593866568-9659176"->{
  Cell[140071, 3606, 793, 17, 103, "Print",ExpressionUUID->"b34ea39b-b09b-4623-ade6-5d12dbddc73c",
   CellTags->"Info3593866568-9659176"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Info3593864067-1021897", 354291, 8157},
 {"Info3593864070-1805780", 354595, 8162},
 {"Info3593864072-1805780", 354901, 8167},
 {"Info3593866568-9659176", 355345, 8174}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 564, 14, 43, "Input",ExpressionUUID->"1095fb49-7af2-42eb-bd87-9f99ae5f06f5"],
Cell[1146, 38, 659, 17, 49, "Output",ExpressionUUID->"db31f587-3455-4da3-8fd9-402489531e8b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1842, 60, 196, 3, 43, "Input",ExpressionUUID->"f2dce862-28f9-4f07-a93c-5075ada52846"],
Cell[2041, 65, 149, 2, 49, "Output",ExpressionUUID->"f1718048-72f0-4005-9f41-9c4c49fc53c2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2227, 72, 710, 21, 43, "Input",ExpressionUUID->"973af9d8-4f5c-448f-8dee-67951d3c61f9"],
Cell[2940, 95, 465, 12, 49, "Output",ExpressionUUID->"1e8a71eb-ca42-4332-b333-1f7c6728bb00"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3442, 112, 210, 3, 43, "Input",ExpressionUUID->"57585c61-bbfa-4db1-841a-0128e8dedf41"],
Cell[3655, 117, 528, 14, 49, "Output",ExpressionUUID->"a9665031-e0e6-4f0a-8455-84475a4659fd"]
}, Open  ]],
Cell[4198, 134, 154, 3, 43, "Input",ExpressionUUID->"d43f4dba-d1a1-4b32-aafd-02bc366bf227"],
Cell[4355, 139, 710, 19, 43, "Input",ExpressionUUID->"ccb2bc46-a511-451e-a78b-ab6436f355ec"],
Cell[5068, 160, 1003, 26, 43, "Input",ExpressionUUID->"a02097e4-b206-4b50-9d2f-14ed8d2525cb"],
Cell[6074, 188, 1051, 30, 50, "Input",ExpressionUUID->"35f3ba98-cb0f-4310-a3e3-aeb69089c86c"],
Cell[7128, 220, 1638, 37, 102, "Input",ExpressionUUID->"29367083-80a7-4630-a222-ad39a661b768"],
Cell[8769, 259, 3705, 81, 560, "Input",ExpressionUUID->"1f56ca8f-8d3d-45bd-beba-dc0ce743be72"],
Cell[12477, 342, 1450, 27, 43, "Input",ExpressionUUID->"e4f95e44-68da-449a-83ac-a4a91363e256"],
Cell[CellGroupData[{
Cell[13952, 373, 382, 8, 43, "Input",ExpressionUUID->"070271ab-e8b1-446a-a83f-d7299920295c"],
Cell[14337, 383, 3492, 73, 715, "Output",ExpressionUUID->"2c14964c-e7ea-4a79-8cb7-8e7207fbf1d8"]
}, Open  ]],
Cell[17844, 459, 358, 9, 43, "Input",ExpressionUUID->"1d9cd5e7-d72f-4ebe-ac9d-5d2e53a6f8ee"],
Cell[18205, 470, 1832, 43, 408, "Input",ExpressionUUID->"8c67ee88-fac7-4184-83f1-af0ffea1c6ba"],
Cell[CellGroupData[{
Cell[20062, 517, 376, 9, 43, "Input",ExpressionUUID->"fc34d780-0b91-49e1-9527-a2bfb69d47c1"],
Cell[20441, 528, 611, 15, 264, "Output",ExpressionUUID->"8309d85d-1bf2-407c-9358-82f65b491d69"]
}, Open  ]],
Cell[CellGroupData[{
Cell[21089, 548, 360, 5, 43, "Input",ExpressionUUID->"51d6f8cb-0511-4738-b4e0-998bb584da24"],
Cell[21452, 555, 7647, 171, 354, "Output",ExpressionUUID->"e1b625b4-374e-4c6b-9886-80cbaeb62aa4"]
}, Open  ]],
Cell[29114, 729, 846, 24, 70, "Input",ExpressionUUID->"88d91881-34d2-4f9f-9122-aa48474c2256"],
Cell[CellGroupData[{
Cell[29985, 757, 318, 6, 43, "Input",ExpressionUUID->"c6744a0d-f247-4d88-8322-6ab2aca51474"],
Cell[30306, 765, 1819, 45, 349, "Output",ExpressionUUID->"1c03c875-9e47-4e48-8c4b-7a7b02abca31"]
}, Open  ]],
Cell[CellGroupData[{
Cell[32162, 815, 750, 21, 43, "Input",ExpressionUUID->"85cbbd76-189c-44c0-aa31-4395cc18d6f1"],
Cell[32915, 838, 769, 14, 108, "Output",ExpressionUUID->"34b80227-11b2-4b7c-8bf9-1b471f32d332"]
}, Open  ]],
Cell[CellGroupData[{
Cell[33721, 857, 339, 8, 43, "Input",ExpressionUUID->"ce8662bb-dd41-4e5d-85e9-d0a2b586dac7"],
Cell[34063, 867, 5220, 105, 361, "Output",ExpressionUUID->"9145c712-368a-49b4-abad-7a891fe2b9f5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[39320, 977, 231, 4, 43, "Input",ExpressionUUID->"2a3642f2-3929-4ea9-a903-d711a887774c"],
Cell[39554, 983, 5292, 105, 361, "Output",ExpressionUUID->"752eae86-6846-450b-9e3f-12577e7a10f8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[44883, 1093, 241, 4, 43, "Input",ExpressionUUID->"64702392-a28b-4dcb-b682-385a5aba4340"],
Cell[45127, 1099, 319, 5, 49, "Output",ExpressionUUID->"e4c02ca8-c24d-42cd-8f29-05a4091553b2"]
}, Open  ]],
Cell[45461, 1107, 2098, 54, 247, "Input",ExpressionUUID->"033add7e-f6be-4059-b520-62ee5e84f9fe"],
Cell[47562, 1163, 2038, 54, 247, "Input",ExpressionUUID->"7a59c861-b7d6-4779-b5cf-1bdfcc5bddce"],
Cell[CellGroupData[{
Cell[49625, 1221, 703, 13, 43, "Input",ExpressionUUID->"d9ef528d-8a4e-4dfd-aa61-fe33668623d1"],
Cell[50331, 1236, 586, 9, 49, "Output",ExpressionUUID->"9a49b850-5aaf-44b6-8000-927eabee5229"]
}, Open  ]],
Cell[CellGroupData[{
Cell[50954, 1250, 589, 12, 43, "Input",ExpressionUUID->"4ce8b5a5-cebc-4e27-8651-0188f9cfa421"],
Cell[51546, 1264, 445, 7, 49, "Output",ExpressionUUID->"2f4193f3-6b65-4c39-ad1b-2b2c5252386f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[52028, 1276, 243, 4, 43, "Input",ExpressionUUID->"42d195c1-41af-4928-89eb-483a33d5d0a7"],
Cell[52274, 1282, 439, 7, 49, "Output",ExpressionUUID->"63a8778d-ddf5-4819-a900-210bf9033fe2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[52750, 1294, 199, 3, 43, "Input",ExpressionUUID->"691a251c-fb73-445f-a5d7-424ecace234c"],
Cell[52952, 1299, 272, 5, 49, "Output",ExpressionUUID->"a6812994-8c87-4ddc-a9bf-94bb2b5f7bc3"]
}, Open  ]],
Cell[53239, 1307, 391, 9, 43, "Input",ExpressionUUID->"acd1c97f-0353-4f33-ba09-1e86a07ee24d"],
Cell[53633, 1318, 1410, 38, 102, "Input",ExpressionUUID->"53943d9e-19df-4fb2-a53f-a3559a3b51d5"],
Cell[CellGroupData[{
Cell[55068, 1360, 1271, 31, 131, "Input",ExpressionUUID->"b8d72ab5-eb21-4ea3-87f1-a127788e43fc"],
Cell[56342, 1393, 1533, 46, 120, "Output",ExpressionUUID->"e2904f80-edba-483b-8f30-602a4cc81f63"]
}, Open  ]],
Cell[CellGroupData[{
Cell[57912, 1444, 1109, 25, 131, "Input",ExpressionUUID->"6494c50d-fb53-4646-9460-93a2b7c89fba"],
Cell[CellGroupData[{
Cell[59046, 1473, 422, 10, 34, "Print",ExpressionUUID->"79b1fb9b-4b26-4eeb-a971-59c011cda7e5"],
Cell[59471, 1485, 824, 17, 34, "Print",ExpressionUUID->"037b5b85-9743-4fb5-81c8-7cf688b137b6"],
Cell[60298, 1504, 421, 10, 34, "Print",ExpressionUUID->"7433244a-c20e-4c1b-97b2-02630ab4958b"],
Cell[60722, 1516, 862, 19, 34, "Print",ExpressionUUID->"4277c377-96e6-4369-917e-f1e52dc5577d"],
Cell[61587, 1537, 422, 10, 34, "Print",ExpressionUUID->"c7e77bc0-cb78-4f56-ac3a-ef60b44324d9"],
Cell[62012, 1549, 860, 19, 34, "Print",ExpressionUUID->"66150745-5a94-459b-b8dd-378b9b08b972"],
Cell[62875, 1570, 421, 10, 34, "Print",ExpressionUUID->"52f4b24f-cda7-4894-a4f5-32ca47c6a6c4"],
Cell[63299, 1582, 891, 19, 52, "Print",ExpressionUUID->"cb1c98fd-cc73-4b40-924e-a24ec65f344e"],
Cell[64193, 1603, 424, 10, 34, "Print",ExpressionUUID->"9fb83d2b-95b3-47cf-9ab0-143d4f92f199"],
Cell[64620, 1615, 862, 19, 34, "Print",ExpressionUUID->"aae62ff1-91f7-4ca5-8bee-fedd0fac93da"],
Cell[65485, 1636, 424, 10, 34, "Print",ExpressionUUID->"4b2f72a5-2c5d-447b-a6f6-aa52930587dd"],
Cell[65912, 1648, 912, 20, 52, "Print",ExpressionUUID->"2637033c-8ac4-4997-8d28-33097ee9a58c"],
Cell[66827, 1670, 422, 10, 34, "Print",ExpressionUUID->"a9f0b4fe-cb2d-406c-80aa-7bdfba821daa"],
Cell[67252, 1682, 914, 20, 52, "Print",ExpressionUUID->"4308d7e3-7620-4256-8a20-bcfc1c0360e0"],
Cell[68169, 1704, 422, 10, 34, "Print",ExpressionUUID->"b1831697-95ee-4e94-8886-e55f6d5b20a8"],
Cell[68594, 1716, 916, 20, 52, "Print",ExpressionUUID->"890fcf71-ad32-45d0-a64f-58439ff47dde"],
Cell[69513, 1738, 423, 10, 34, "Print",ExpressionUUID->"6d5a2ded-aa71-4ffe-aff4-42942e3ad39f"],
Cell[69939, 1750, 909, 20, 52, "Print",ExpressionUUID->"bac5c409-1b25-4334-98ab-e32428af67d6"],
Cell[70851, 1772, 424, 10, 34, "Print",ExpressionUUID->"66d8cffe-6250-4880-abad-9b3e86228eb4"],
Cell[71278, 1784, 920, 20, 52, "Print",ExpressionUUID->"410b1c65-4008-4566-ade8-4c0103f37eea"],
Cell[72201, 1806, 422, 10, 34, "Print",ExpressionUUID->"3024389c-2371-4aaa-a18a-38ccf0c58279"],
Cell[72626, 1818, 922, 20, 52, "Print",ExpressionUUID->"acafb5c5-fec7-47b8-9047-e57a55e4137e"],
Cell[73551, 1840, 422, 10, 34, "Print",ExpressionUUID->"fd86a530-f0c7-4c6c-a63e-1c91c0358030"],
Cell[73976, 1852, 922, 20, 52, "Print",ExpressionUUID->"abb8d80e-99a7-4a79-aae8-d1b24311335b"],
Cell[74901, 1874, 420, 10, 34, "Print",ExpressionUUID->"e18d820e-f37e-49be-b265-19c6655aa39d"],
Cell[75324, 1886, 924, 20, 52, "Print",ExpressionUUID->"cb8a5735-8959-4c14-b465-7a4feda3a2da"],
Cell[76251, 1908, 424, 10, 34, "Print",ExpressionUUID->"8c0fcc22-8c8d-47ae-b049-348e9ce0362a"],
Cell[76678, 1920, 922, 20, 52, "Print",ExpressionUUID->"7a79501e-7d5c-4f7f-a2b6-c8b68cbd089c"],
Cell[77603, 1942, 424, 10, 34, "Print",ExpressionUUID->"7027ac69-adee-4173-a638-16321420486d"],
Cell[78030, 1954, 920, 20, 52, "Print",ExpressionUUID->"4cf716b5-02b3-479d-aa3e-20ab3258858b"],
Cell[78953, 1976, 424, 10, 34, "Print",ExpressionUUID->"f3392c07-b200-4156-b2b1-666519c9a813"],
Cell[79380, 1988, 920, 20, 52, "Print",ExpressionUUID->"9f92c537-272f-4669-8621-57148c498a01"],
Cell[80303, 2010, 422, 10, 34, "Print",ExpressionUUID->"a88be061-19cb-46ac-965a-71618186b264"],
Cell[80728, 2022, 920, 20, 52, "Print",ExpressionUUID->"6b5e976b-96b8-43a7-be55-52daa31660be"],
Cell[81651, 2044, 423, 10, 34, "Print",ExpressionUUID->"8cb9a8a6-497e-44ff-bbd5-0ba6504a527e"],
Cell[82077, 2056, 922, 20, 52, "Print",ExpressionUUID->"34067601-d7f0-4c7a-b132-89ee0583cbda"],
Cell[83002, 2078, 422, 10, 34, "Print",ExpressionUUID->"8d37f930-ca67-4d1c-87bb-9b0251b7015e"],
Cell[83427, 2090, 924, 20, 52, "Print",ExpressionUUID->"ee04cfbe-ed13-4369-b836-e193fae1d84c"],
Cell[84354, 2112, 422, 10, 34, "Print",ExpressionUUID->"616cdf59-876f-4f07-8506-f8ff747e155a"]
}, Open  ]],
Cell[84791, 2125, 258, 3, 49, "Output",ExpressionUUID->"bd8dcf0a-cdda-4521-b649-3a2e9cd5d068"]
}, Open  ]],
Cell[CellGroupData[{
Cell[85086, 2133, 1344, 30, 50, "Input",ExpressionUUID->"8a63c01d-8726-42e0-beae-7010ee6857d1"],
Cell[86433, 2165, 567, 12, 35, "Message",ExpressionUUID->"656fe578-2351-4569-a23a-11f3fce0a4d9"],
Cell[87003, 2179, 3075, 58, 669, "Output",ExpressionUUID->"f41e0051-bacc-4794-b082-eba4d156995c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[90115, 2242, 432, 7, 73, "Input",ExpressionUUID->"ebc50c34-8244-4871-a973-a468bb18a996"],
Cell[90550, 2251, 169, 2, 49, "Output",ExpressionUUID->"d83c6dc9-a292-4d68-9315-363e38f3beb8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[90756, 2258, 206, 4, 43, "Input",ExpressionUUID->"72541105-6df6-4cfe-ade6-4493ac94e0b5"],
Cell[90965, 2264, 420, 10, 35, "Message",ExpressionUUID->"5657ce79-3f0b-49e1-abf9-529e1816825d"],
Cell[91388, 2276, 557, 8, 49, "Output",ExpressionUUID->"671c8ac0-3e6f-41a8-8e40-c0184946fff9"]
}, Open  ]],
Cell[CellGroupData[{
Cell[91982, 2289, 273, 5, 43, "Input",ExpressionUUID->"985a4a7a-86c1-4f19-ba65-0e4635972671"],
Cell[92258, 2296, 221, 3, 49, "Output",ExpressionUUID->"5086969b-ee24-4d3a-b837-826fabf767c7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[92516, 2304, 222, 3, 43, "Input",ExpressionUUID->"f2907183-3242-4438-8aac-fc04ba62045f"],
Cell[92741, 2309, 369, 9, 35, "Message",ExpressionUUID->"adb399f4-3abd-4cfb-b184-863361477f47"],
Cell[93113, 2320, 531, 7, 49, "Output",ExpressionUUID->"63e60132-e8f3-4e57-991d-1ae2bc0b0b06"]
}, Open  ]],
Cell[CellGroupData[{
Cell[93681, 2332, 226, 5, 43, "Input",ExpressionUUID->"3a777453-49d5-4b01-811c-8e9f695530a7"],
Cell[CellGroupData[{
Cell[93932, 2341, 183, 4, 68, "Print",ExpressionUUID->"4afd9680-0e77-480e-80c0-38c9571109e3",
 CellTags->"Info3593864067-1021897"],
Cell[94118, 2347, 1443, 39, 63, "Print",ExpressionUUID->"2d333413-3f7c-44c5-b18c-916598c00369",
 CellTags->"Info3593864067-1021897"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[95610, 2392, 454, 11, 43, "Input",ExpressionUUID->"4945da89-0e2d-4d20-ba06-b09365d0a206"],
Cell[96067, 2405, 854, 16, 88, "Output",ExpressionUUID->"b15d58d0-1c4b-4eb1-b3eb-5f9d73fa4586"]
}, Open  ]],
Cell[CellGroupData[{
Cell[96958, 2426, 390, 12, 43, "Input",ExpressionUUID->"f07e6867-81fe-4142-9423-2797e41ce6ae"],
Cell[97351, 2440, 661, 12, 88, "Output",ExpressionUUID->"9d10fa09-ee43-4a69-bc78-952eae0e6ba2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[98049, 2457, 333, 9, 43, "Input",ExpressionUUID->"055ce74b-d546-4627-b3c1-820a3a0f62a0"],
Cell[98385, 2468, 273, 4, 49, "Output",ExpressionUUID->"6161f2a8-6dfc-4a2d-a32f-a59791dca0d6"]
}, Open  ]],
Cell[CellGroupData[{
Cell[98695, 2477, 598, 19, 50, "Input",ExpressionUUID->"049acda9-5af6-4a2d-b37f-1da7fe98784a"],
Cell[99296, 2498, 4923, 129, 241, "Output",ExpressionUUID->"b66a04ce-da2a-4b8e-91d1-b259fd93870a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[104256, 2632, 533, 13, 43, "Input",ExpressionUUID->"6e33f99b-5504-4fb9-9ef5-38e905f64dec"],
Cell[104792, 2647, 486, 10, 49, "Output",ExpressionUUID->"373a5397-fa00-49fe-a640-4f776c464afc"]
}, Open  ]],
Cell[CellGroupData[{
Cell[105315, 2662, 181, 4, 43, "Input",ExpressionUUID->"27927b49-8306-4ada-b3ad-ae0f8f2f8b77"],
Cell[105499, 2668, 154, 3, 49, "Output",ExpressionUUID->"9d136198-dc05-4a77-ae40-c6d8e7d8b092"]
}, Open  ]],
Cell[CellGroupData[{
Cell[105690, 2676, 185, 4, 43, "Input",ExpressionUUID->"1cd7eac1-0211-4be9-9d63-898acd230a16"],
Cell[105878, 2682, 781, 15, 65, "Message",ExpressionUUID->"4dd90489-bb68-4ea7-a42b-170845dc4ee8"],
Cell[106662, 2699, 335, 6, 79, "Output",ExpressionUUID->"1250fd0a-e045-420f-8340-1d699426db55"]
}, Open  ]],
Cell[CellGroupData[{
Cell[107034, 2710, 480, 11, 43, "Input",ExpressionUUID->"bec6cb0b-169a-4421-bed7-75bfe35e9f53"],
Cell[107517, 2723, 980, 18, 65, "Message",ExpressionUUID->"99e96cea-63d2-40e6-8d3a-6ae118f9e69b"],
Cell[108500, 2743, 391, 8, 49, "Output",ExpressionUUID->"5de88334-86b8-4074-a683-61dde939346a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[108928, 2756, 273, 6, 43, "Input",ExpressionUUID->"277be86e-0e08-4225-b98d-89d591791510"],
Cell[109204, 2764, 736, 13, 72, "Message",ExpressionUUID->"912736b4-7576-4a8c-8dd2-94230f877fe3"],
Cell[109943, 2779, 293, 5, 49, "Output",ExpressionUUID->"3a555530-fd8f-42a1-b8eb-7eafebdc087b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[110273, 2789, 177, 4, 43, "Input",ExpressionUUID->"62dd5168-6525-4a83-b6cd-e243ee307f92"],
Cell[CellGroupData[{
Cell[110475, 2797, 183, 4, 68, "Print",ExpressionUUID->"e695d451-00f9-447c-9bb3-7e9031f7d72c",
 CellTags->"Info3593864070-1805780"],
Cell[110661, 2803, 1448, 39, 63, "Print",ExpressionUUID->"be4097ac-03cb-4115-adac-90643a1d1b73",
 CellTags->"Info3593864070-1805780"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[112158, 2848, 228, 5, 43, "Input",ExpressionUUID->"9fe1bfae-3d42-437f-89c9-9bb1dd18b6ee"],
Cell[112389, 2855, 238, 4, 49, "Output",ExpressionUUID->"7d478dcf-9acc-48a1-8591-bc0716f6d036"]
}, Open  ]],
Cell[CellGroupData[{
Cell[112664, 2864, 177, 4, 43, "Input",ExpressionUUID->"b4f713c4-2941-4400-9911-40db3a7c34ea"],
Cell[112844, 2870, 241, 5, 69, "Output",ExpressionUUID->"82d9dcf4-0679-4136-ab1d-ad799f35ba68"]
}, Open  ]],
Cell[CellGroupData[{
Cell[113122, 2880, 177, 4, 43, "Input",ExpressionUUID->"7d32549e-fe40-465c-8528-f95642e818f0"],
Cell[113302, 2886, 260, 7, 69, "Output",ExpressionUUID->"a932c29e-eb6e-4886-82c9-ce34758ae254"]
}, Open  ]],
Cell[113577, 2896, 573, 14, 43, "Input",ExpressionUUID->"437ac05e-327a-46f3-9a49-e4cd06f448c0"],
Cell[114153, 2912, 508, 13, 43, "Input",ExpressionUUID->"589adab6-80b7-4904-a38d-4d04e6221266"],
Cell[CellGroupData[{
Cell[114686, 2929, 266, 6, 43, "Input",ExpressionUUID->"fd723ac3-7ad8-4e35-9439-ddb25c4a9979"],
Cell[114955, 2937, 390, 7, 49, "Output",ExpressionUUID->"006acb43-9c53-4983-b99c-3676cf2d186f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[115382, 2949, 267, 6, 43, "Input",ExpressionUUID->"69acf5ee-b769-4f99-b07a-bc2fa95489d7"],
Cell[115652, 2957, 390, 7, 49, "Output",ExpressionUUID->"b0e601b8-33e1-4284-b7f8-4131e52ac1e2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[116079, 2969, 226, 5, 43, "Input",ExpressionUUID->"0e76c2fb-0610-4403-ac05-243160610439"],
Cell[116308, 2976, 218, 4, 49, "Output",ExpressionUUID->"63a5ebc5-c061-495b-9c9a-53ecec34fa1d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[116563, 2985, 175, 4, 43, "Input",ExpressionUUID->"bb119df2-1b37-4e52-9f37-aa77fc776ff5"],
Cell[CellGroupData[{
Cell[116763, 2993, 183, 4, 68, "Print",ExpressionUUID->"3d719588-07ec-49c9-a6d6-087f8dfd0a71",
 CellTags->"Info3593864072-1805780"],
Cell[116949, 2999, 1446, 39, 63, "Print",ExpressionUUID->"38730339-e9c8-434c-8cd6-32e1f67a228d",
 CellTags->"Info3593864072-1805780"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[118444, 3044, 176, 4, 43, "Input",ExpressionUUID->"a9a81bd2-15d0-4482-890f-8d2f40bee8ff"],
Cell[118623, 3050, 562, 14, 68, "Print",ExpressionUUID->"9b73a979-0471-434e-98be-5394f0abc645",
 CellTags->"Info3593864072-1805780"]
}, Open  ]],
Cell[CellGroupData[{
Cell[119222, 3069, 194, 4, 43, "Input",ExpressionUUID->"28c7d0d7-d71b-4f14-9d12-9a34ab5178f1"],
Cell[119419, 3075, 196, 4, 49, "Output",ExpressionUUID->"8baa8720-3e08-4427-a285-72f05c2ba0d7"]
}, Open  ]],
Cell[119630, 3082, 234, 5, 43, "Input",ExpressionUUID->"9d69f4b9-962b-49ab-8c86-9275ca1b63e9"],
Cell[CellGroupData[{
Cell[119889, 3091, 190, 4, 43, "Input",ExpressionUUID->"8a4e4381-d74f-424a-a9a3-b43801efd743"],
Cell[120082, 3097, 184, 3, 49, "Output",ExpressionUUID->"5127d39f-7a52-417d-b45e-fae8cbec0224"]
}, Open  ]],
Cell[CellGroupData[{
Cell[120303, 3105, 270, 6, 43, "Input",ExpressionUUID->"50dadb38-8b85-46c4-9a9d-d6c0472ace6e"],
Cell[120576, 3113, 246, 5, 49, "Output",ExpressionUUID->"2ccf419a-c82a-4b87-9210-96cfab85a3a2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[120859, 3123, 219, 5, 43, "Input",ExpressionUUID->"9b4c39fa-d37e-48bf-a7fa-b45958d6ee79"],
Cell[121081, 3130, 297, 6, 49, "Output",ExpressionUUID->"b6c095f0-6ac7-45c4-a0ff-24311a986e94"]
}, Open  ]],
Cell[CellGroupData[{
Cell[121415, 3141, 220, 5, 43, "Input",ExpressionUUID->"b28e9727-0ef4-459a-b1af-75320c9d3e61"],
Cell[121638, 3148, 194, 3, 49, "Output",ExpressionUUID->"164d550e-b55c-41ec-bd96-6781b8fc0a16"]
}, Open  ]],
Cell[CellGroupData[{
Cell[121869, 3156, 265, 7, 43, "Input",ExpressionUUID->"74ef6292-2c80-419d-9095-333a09cb2656"],
Cell[122137, 3165, 343, 6, 49, "Output",ExpressionUUID->"50118aad-5b7a-47db-8a5a-5e137c69c9b2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[122517, 3176, 294, 7, 43, "Input",ExpressionUUID->"43e6026a-ab8c-4c81-bd2b-adca57378598"],
Cell[122814, 3185, 320, 6, 79, "Output",ExpressionUUID->"3f0f2eaf-4350-4e1e-844a-1a2f83fa3dd0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[123171, 3196, 1652, 39, 73, "Input",ExpressionUUID->"5095fdb0-b8be-48e8-81d1-8cd37c352d32"],
Cell[124826, 3237, 4662, 102, 1744, "Output",ExpressionUUID->"e3447110-6ddc-4ff7-9bdc-48885254b7c1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[129525, 3344, 621, 19, 43, "Input",ExpressionUUID->"e2872171-140b-4a91-bbb7-4b4d9cdaea56"],
Cell[130149, 3365, 566, 12, 55, "Message",ExpressionUUID->"c62275f3-dea9-4d97-bfe5-f5c5123b0f7f"],
Cell[130718, 3379, 594, 12, 35, "Message",ExpressionUUID->"3601625b-012c-4c79-8d39-a3d9e633a3d2"],
Cell[131315, 3393, 566, 12, 55, "Message",ExpressionUUID->"b8300ddb-c46a-4475-b231-b84cb365ad0a"],
Cell[131884, 3407, 594, 12, 35, "Message",ExpressionUUID->"fbc737d8-a1cf-453b-a836-58cfd0783d59"],
Cell[132481, 3421, 566, 12, 55, "Message",ExpressionUUID->"f3742bf1-8482-47f1-8912-303fa73da074"],
Cell[133050, 3435, 647, 13, 35, "Message",ExpressionUUID->"f0947477-50ec-49ec-adc7-61ad540159cd"],
Cell[133700, 3450, 594, 12, 35, "Message",ExpressionUUID->"5b77d89f-b335-43c7-8bb6-e3c675c9eb24"],
Cell[134297, 3464, 651, 13, 35, "Message",ExpressionUUID->"a29752e0-d007-44e4-976c-cffb78e4c81b"],
Cell[134951, 3479, 3097, 64, 456, "Output",ExpressionUUID->"704432d4-63b1-4592-86fb-fc8354a00e46"]
}, Open  ]],
Cell[CellGroupData[{
Cell[138085, 3548, 187, 4, 43, "Input",ExpressionUUID->"e74716d6-fc1c-44e3-8469-724ca6a126bb"],
Cell[138275, 3554, 1221, 28, 357, "Output",ExpressionUUID->"d44e1b29-8c53-4c24-bc93-b1528624d754"]
}, Open  ]],
Cell[CellGroupData[{
Cell[139533, 3587, 171, 3, 43, "Input",ExpressionUUID->"790b474e-8a24-4b2d-9822-e17507514134"],
Cell[139707, 3592, 152, 3, 49, "Output",ExpressionUUID->"5993025e-ecd0-42c8-b78d-47fb6c457f2b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[139896, 3600, 172, 4, 43, "Input",ExpressionUUID->"1ef2f62a-c8cd-45c3-9cf3-fc75499a7396"],
Cell[140071, 3606, 793, 17, 103, "Print",ExpressionUUID->"b34ea39b-b09b-4623-ade6-5d12dbddc73c",
 CellTags->"Info3593866568-9659176"]
}, Open  ]],
Cell[CellGroupData[{
Cell[140901, 3628, 1495, 42, 73, "Input",ExpressionUUID->"47db145e-a1db-420d-a0ff-63afc7814537"],
Cell[142399, 3672, 40271, 682, 367, "Output",ExpressionUUID->"6b982fde-d305-4c23-b34f-512958528758"]
}, Open  ]],
Cell[CellGroupData[{
Cell[182707, 4359, 710, 20, 43, "Input",ExpressionUUID->"aaca4b9d-27e0-4f54-89c8-a9a66fd050db"],
Cell[183420, 4381, 203, 5, 110, "Output",ExpressionUUID->"f0cf7898-6dcb-4e16-9d39-9072c882aac8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[183660, 4391, 203, 3, 43, "Input",ExpressionUUID->"a22720b2-bfaa-4a75-a163-d6055e7683ea"],
Cell[183866, 4396, 169, 2, 49, "Output",ExpressionUUID->"c20db700-d673-4d3d-a54b-35da4552cf32"]
}, Open  ]],
Cell[CellGroupData[{
Cell[184072, 4403, 415, 11, 43, "Input",ExpressionUUID->"b15a2a1e-df07-490a-a4d2-28aaefbad09d"],
Cell[184490, 4416, 179, 3, 49, "Output",ExpressionUUID->"8464be46-c90a-4062-85e0-c05ebec57a27"]
}, Open  ]],
Cell[CellGroupData[{
Cell[184706, 4424, 1630, 39, 43, "Input",ExpressionUUID->"1100e39c-35cf-469f-a56b-3ed0682828d4"],
Cell[186339, 4465, 2104, 54, 124, "Output",ExpressionUUID->"c7fd795f-abaf-4453-b349-3ccb0b0b894b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[188480, 4524, 913, 28, 43, "Input",ExpressionUUID->"896164b2-77ba-4de0-b8a6-b3adc0ade953"],
Cell[189396, 4554, 1110, 31, 119, "Output",ExpressionUUID->"8bc7b154-14a9-4404-a9e1-f33939cc1f76"]
}, Open  ]],
Cell[CellGroupData[{
Cell[190543, 4590, 4549, 113, 179, "Input",ExpressionUUID->"06b016ba-39f5-424e-92de-32348b08e8f7"],
Cell[195095, 4705, 1182, 20, 38, "Message",ExpressionUUID->"96d7f48b-7e5c-4553-a79b-6a5216314d21"],
Cell[196280, 4727, 1204, 21, 35, "Message",ExpressionUUID->"3ca0c269-bf6b-480a-9296-7006acc89648"],
Cell[197487, 4750, 1179, 20, 38, "Message",ExpressionUUID->"7c2e224c-5bc9-42e9-96eb-206f40c21b19"],
Cell[198669, 4772, 1185, 20, 35, "Message",ExpressionUUID->"b6450351-79c8-4392-a117-913da9cc2f6d"],
Cell[199857, 4794, 9142, 180, 719, "Output",ExpressionUUID->"9590f5d3-2e17-48af-bd2e-11d6e86ce387"]
}, Open  ]],
Cell[CellGroupData[{
Cell[209036, 4979, 316, 8, 43, "Input",ExpressionUUID->"5d4311d8-3785-4f36-928f-b1c77739292b"],
Cell[209355, 4989, 4257, 112, 62, "Output",ExpressionUUID->"7e99486f-6119-4c62-a079-68deb3a1c6f1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[213649, 5106, 2312, 64, 198, "Input",ExpressionUUID->"61c63c3a-b391-4333-a494-571e0f9ad485"],
Cell[215964, 5172, 578, 12, 38, "Message",ExpressionUUID->"d2769f56-b670-4e0c-835c-c35d27eee099"],
Cell[216545, 5186, 580, 12, 38, "Message",ExpressionUUID->"020553f9-c517-4c07-bb50-7c822ea84d23"],
Cell[217128, 5200, 578, 12, 38, "Message",ExpressionUUID->"24953f20-791d-45b2-9c82-1ce46898a4aa"],
Cell[217709, 5214, 548, 11, 35, "Message",ExpressionUUID->"e3b9de3d-fcfa-4f2f-982b-2286895d604c"],
Cell[218260, 5227, 9671, 194, 386, "Output",ExpressionUUID->"a11f0fed-32fe-4f8c-abb6-30da73cd5ea0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[227968, 5426, 388, 11, 43, "Input",ExpressionUUID->"b9b8748b-d069-47e6-b524-e7eaff32c2bb"],
Cell[228359, 5439, 475, 11, 35, "Message",ExpressionUUID->"1fe9c246-63e5-4857-b123-43d237296d82"],
Cell[228837, 5452, 389, 10, 73, "Output",ExpressionUUID->"106b3ca6-c066-4fe4-8413-6e73a4177058"]
}, Open  ]],
Cell[CellGroupData[{
Cell[229263, 5467, 207, 4, 43, "Input",ExpressionUUID->"09619871-297f-41be-bb4e-c1846ee80f85"],
Cell[229473, 5473, 245, 6, 49, "Output",ExpressionUUID->"0cb3d099-a62c-4de9-919b-8c327d783ceb"]
}, Open  ]],
Cell[CellGroupData[{
Cell[229755, 5484, 401, 11, 43, "Input",ExpressionUUID->"19eb6346-4c07-41a5-aa13-48944aa96422"],
Cell[230159, 5497, 587, 19, 70, "Output",ExpressionUUID->"d0d9c1c2-1d1e-4292-aaa9-ae7ba5e0abbc"]
}, Open  ]],
Cell[CellGroupData[{
Cell[230783, 5521, 258, 5, 43, "Input",ExpressionUUID->"38055604-f9a5-4177-a12d-6e8c3586f124"],
Cell[231044, 5528, 353, 10, 69, "Output",ExpressionUUID->"03b2549a-b1ee-4ee0-806e-eca61b206509"]
}, Open  ]],
Cell[CellGroupData[{
Cell[231434, 5543, 1111, 31, 43, "Input",ExpressionUUID->"2c7a2c72-59b5-4941-9a0a-3b5cb386b26a"],
Cell[232548, 5576, 239, 4, 49, "Output",ExpressionUUID->"83e6c5e4-12ab-415c-a259-73e48a48a0c2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[232824, 5585, 476, 13, 43, "Input",ExpressionUUID->"94e1ce36-2bbb-4b6a-98a6-99d362c38fe0"],
Cell[233303, 5600, 782, 22, 80, "Output",ExpressionUUID->"4913ddc3-b57b-4d8a-95b7-2720e742b333"]
}, Open  ]],
Cell[CellGroupData[{
Cell[234122, 5627, 346, 8, 43, "Input",ExpressionUUID->"41b51fb0-8418-4ae8-8237-642566fafb0d"],
Cell[234471, 5637, 501, 12, 35, "Message",ExpressionUUID->"f9502188-21e0-4c35-8d0f-a4281d16d275"],
Cell[234975, 5651, 473, 13, 56, "Output",ExpressionUUID->"7232f311-dc79-430c-9a04-86e132f55417"]
}, Open  ]],
Cell[CellGroupData[{
Cell[235485, 5669, 1432, 40, 84, "Input",ExpressionUUID->"206d7147-3ec3-400c-b7ea-ef3751d15622"],
Cell[236920, 5711, 10724, 206, 463, "Output",ExpressionUUID->"7f61c09c-f65b-47a8-ba01-0ce03cfda4bb"]
}, Open  ]],
Cell[CellGroupData[{
Cell[247681, 5922, 1131, 32, 84, "Input",ExpressionUUID->"6f89147b-4aa5-4de0-955c-1367f16b9a15"],
Cell[248815, 5956, 11131, 210, 361, "Output",ExpressionUUID->"3d2759fb-bea6-440f-96c8-2a83c148700d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[259983, 6171, 227, 4, 43, "Input",ExpressionUUID->"63094d15-287a-4be6-b126-858c539c5839"],
Cell[260213, 6177, 19962, 366, 361, "Output",ExpressionUUID->"7f1a255d-5455-44c0-864b-2097b9acad0c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[280212, 6548, 506, 13, 50, "Input",ExpressionUUID->"9224b7a6-0417-494d-b68b-bd1b0b5828ee"],
Cell[280721, 6563, 2454, 70, 74, "Output",ExpressionUUID->"3ae77829-005e-41f9-b62c-16bba97890f5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[283212, 6638, 1826, 47, 84, "Input",ExpressionUUID->"487824bd-b09e-4259-8e8e-3d4df4651bf0"],
Cell[285041, 6687, 35394, 622, 364, 23547, 428, "CachedBoxData", "BoxData", "Output",ExpressionUUID->"b6361193-df52-4f7f-82ec-990acb54c718"]
}, Open  ]],
Cell[CellGroupData[{
Cell[320472, 7314, 474, 12, 50, "Input",ExpressionUUID->"90fb37c4-5fd2-41fc-9798-588df55b27f4"],
Cell[320949, 7328, 588, 16, 87, "Output",ExpressionUUID->"34d6fd3e-dfd9-4156-804d-90ec2790b2bc"]
}, Open  ]],
Cell[CellGroupData[{
Cell[321574, 7349, 249, 6, 43, "Input",ExpressionUUID->"9e5bc734-3435-4bc4-9c3c-afcee7f39a14"],
Cell[321826, 7357, 214, 4, 49, "Output",ExpressionUUID->"5e5c4c86-6608-4e73-a86a-733230932c22"]
}, Open  ]],
Cell[CellGroupData[{
Cell[322077, 7366, 1745, 48, 218, "Input",ExpressionUUID->"1bd2c7e9-d69e-449e-b4a5-309a64a7a325"],
Cell[323825, 7416, 16933, 347, 347, "Output",ExpressionUUID->"e2cac587-6884-466a-9729-dd23de44ed52"]
}, Open  ]],
Cell[CellGroupData[{
Cell[340795, 7768, 252, 5, 43, "Input",ExpressionUUID->"79ea98bf-a36e-4a3b-88dc-96b4bc779a93"],
Cell[341050, 7775, 1080, 35, 69, "Output",ExpressionUUID->"aad86b6b-d4be-461b-828f-6fb244944ac5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[342167, 7815, 441, 12, 43, "Input",ExpressionUUID->"30bca7b7-eb7c-4637-a784-d3719a75b5ab"],
Cell[342611, 7829, 561, 16, 49, "Output",ExpressionUUID->"63c55702-3288-47ac-85d6-4a198d47efb5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[343209, 7850, 620, 16, 43, "Input",ExpressionUUID->"e76cf6e3-8fd7-4cda-ab69-8e30668e2070"],
Cell[343832, 7868, 2121, 68, 167, "Output",ExpressionUUID->"4d8a4ef8-5c15-4084-afd0-e903cf501b7e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[345990, 7941, 1622, 45, 109, "Input",ExpressionUUID->"32335262-5ba0-4ae6-be6d-717c8c2e0946"],
Cell[347615, 7988, 6234, 153, 799, "Output",ExpressionUUID->"585be9d0-04d5-4355-8bde-6b77827737e5"]
}, Open  ]]
}
]
*)

